define(["exports", "../utils/element.js"], function (_exports, _element) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.calculateDepthForNode = void 0;

  var calculateDepthForNode = function calculateDepthForNode(node) {
    if ((0, _element.isHidden)(node)) {
      return Infinity;
    }

    var depth = 0;
    var parent = node.parentNode;

    while (parent) {
      depth += 1;
      parent = parent.parentNode;
    }

    return depth;
  };

  _exports.calculateDepthForNode = calculateDepthForNode;
});