define(["exports"], function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.queueMicroTask = void 0;
  var trigger;
  var callbacks = [];

  var notify = function notify() {
    return callbacks.splice(0).forEach(function (cb) {
      return cb();
    });
  };

  var queueMicroTask = function queueMicroTask(callback) {
    if (!trigger) {
      var toggle_1 = 0;
      var el_1 = document.createTextNode('');
      var config = {
        characterData: true
      };
      new MutationObserver(function () {
        return notify();
      }).observe(el_1, config);

      trigger = function trigger() {
        el_1.textContent = "" + (toggle_1 ? toggle_1-- : toggle_1++);
      };
    }

    callbacks.push(callback);
    trigger();
  };

  _exports.queueMicroTask = queueMicroTask;
});