define(["exports", "require", "../../../lit-element/lit-element.js", "../../utils/utils.js", "./hax-tray-button.js"], function (_exports, _require, _litElement, _utils, _haxTrayButton) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxAppBrowser = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject3_2eb585a0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n            <hax-tray-button\n              index=\"", "\"\n              label=\"", "\"\n              icon=\"", "\"\n              color=\"", "\"\n              event-name=\"search-selected\"\n              event-data=\"", "\"\n            ></hax-tray-button>\n          "]);

    _templateObject3_2eb585a0c07b11ea85f79731808de288 = function _templateObject3_2eb585a0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject2_2eb585a0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div class=\"item-wrapper\">\n        ", "\n      </div>\n      <hax-app-search\n        id=\"haxappsearch\"\n        .hidden=\"", "\"\n      ></hax-app-search>\n      <slot></slot>\n    "]);

    _templateObject2_2eb585a0c07b11ea85f79731808de288 = function _templateObject2_2eb585a0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_2eb585a0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n        :host *[hidden] {\n          display: none;\n        }\n        .toolbar-inner {\n          display: block;\n          padding: 0;\n          width: 100%;\n        }\n        .item-wrapper {\n          text-align: center;\n        }\n      "]);

    _templateObject_2eb585a0c07b11ea85f79731808de288 = function _templateObject_2eb585a0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `hax-app-browser`
   * @element hax-app-browser
   *
   * `Browse a list of apps. This provides a listing of our gizmos that we've integrated with.`
   * @microcopy - the mental model for this element
   * - hax-app - expression of how to communicate and visualize a data source
   * - gizmo - silly name for the general public when talking about hax-app and what it provides in the end
   */
  var HaxAppBrowser =
  /*#__PURE__*/
  function (_winEventsElement) {
    babelHelpers.inherits(HaxAppBrowser, _winEventsElement);
    babelHelpers.createClass(HaxAppBrowser, null, [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject_2eb585a0c07b11ea85f79731808de288())];
      }
    }]);

    function HaxAppBrowser() {
      var _this;

      babelHelpers.classCallCheck(this, HaxAppBrowser);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HaxAppBrowser).call(this));
      _this.__winEvents = {
        "hax-store-property-updated": "_haxStorePropertyUpdated",
        "hax-search-source-updated": "_searchSelected"
      };
      _this.searching = false;
      _this.activeApp = null;
      _this.appList = [];
      _this.hasActive = false;
      new Promise(function (res, rej) {
        return _require.default(["./hax-app-search.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(HaxAppBrowser, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_2eb585a0c07b11ea85f79731808de288(), this.appList.map(function (app) {
          return (0, _litElement.html)(_templateObject3_2eb585a0c07b11ea85f79731808de288(), app.index, app.details.title, app.details.icon, app.details.color, app.index);
        }), !this.searching);
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        this.resetBrowser();
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "activeApp") {
            _this2._activeAppChanged(_this2[propName], oldValue);
          }
        });
      }
      /**
       * App has been selected.
       */

    }, {
      key: "_searchSelected",
      value: function _searchSelected(e) {
        // item bubbled up
        if (babelHelpers.typeof(e.detail) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          this.searching = true;
          window.HaxStore.write("activeApp", this.appList[e.detail], this);
        }
      }
      /**
       * Active app updated, so scroll it into view
       */

    }, {
      key: "_activeAppChanged",
      value: function _activeAppChanged(newValue, oldValue) {
        if (babelHelpers.typeof(oldValue) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && newValue != null) {
          this.hasActive = true;
        } else {
          this.hasActive = false;
        }
      }
      /**
       * Store updated, sync.
       */

    }, {
      key: "_haxStorePropertyUpdated",
      value: function _haxStorePropertyUpdated(e) {
        if (e.detail && babelHelpers.typeof(e.detail.value) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && e.detail.property) {
          this[e.detail.property] = e.detail.value;
        }
      }
      /**
       * Reset this browser.
       */

    }, {
      key: "resetBrowser",
      value: function resetBrowser() {
        this.searching = false;
        this.appList = babelHelpers.toConsumableArray(window.HaxStore.instance.appList);
      }
    }], [{
      key: "tag",
      get: function get() {
        return "hax-app-browser";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Search term
           */
          search: {
            type: String
          },

          /**
           * Searching mode
           */
          searching: {
            type: Boolean,
            reflect: true
          },

          /**
           * Global activeApp object.
           */
          activeApp: {
            type: Object
          },

          /**
           * If we have an active, scale everything
           */
          hasActive: {
            reflect: true,
            type: Boolean,
            attribute: "has-active"
          },
          appList: {
            type: Array
          }
        };
      }
    }]);
    return HaxAppBrowser;
  }((0, _utils.winEventsElement)(_litElement.LitElement));

  _exports.HaxAppBrowser = HaxAppBrowser;
  window.customElements.define(HaxAppBrowser.tag, HaxAppBrowser);
});