define(["exports", "require", "../../../lit-element/lit-element.js"], function (_exports, _require, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxToolbar = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject2_3017d4c0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div class=\"wrapper\">\n        <slot name=\"prefix\"></slot>\n        <slot name=\"primary\"></slot>\n        <hax-context-item-menu\n          mini\n          action\n          ?hidden=\"", "\"\n          icon=\"icons:more-horiz\"\n          label=\"More options\"\n          id=\"moremenu\"\n          event-name=\"hax-plate-op\"\n          reset-on-select\n        >\n          <paper-item value=\"\" hidden></paper-item>\n          <slot name=\"more\"></slot>\n        </hax-context-item-menu>\n      </div>\n    "]);

    _templateObject2_3017d4c0c07b11ea85f79731808de288 = function _templateObject2_3017d4c0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_3017d4c0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: flex;\n          justify-content: flex-start;\n          visibility: visible;\n          transition: 0.2s all ease-in-out;\n          box-sizing: border-box;\n          pointer-events: all;\n          background-color: white;\n        }\n\n        :host *[hidden] {\n          display: none;\n        }\n        .wrapper {\n          display: flex;\n          align-items: center;\n          transition: 0.2s all ease-in-out;\n          visibility: visible;\n          opacity: 0.8;\n        }\n        .wrapper:hover {\n          opacity: 1;\n        }\n        :host .wrapper ::slotted(*) {\n          pointer-events: all;\n        }\n        .close-cap {\n          margin: 10px 10px 0 8px;\n          display: flex;\n          padding: 0;\n        }\n        :host * ::slotted(hax-context-item:hover),\n        :host * ::slotted(hax-context-item-textop:hover),\n        :host * ::slotted(hax-context-item-menu:hover),\n        hax-context-item:hover,\n        hax-context-item-textop:hover,\n        hax-context-item-menu:hover {\n          z-index: 2;\n        }\n        #moremenu hax-context-item,\n        #moremenu ::slotted(paper-item),\n        paper-item {\n          height: 32px;\n          padding: 0;\n          min-width: 100px;\n        }\n\n        #moremenu hax-context-item:hover,\n        :host #moremenu ::slotted(paper-item:hover),\n        paper-item:hover {\n          cursor: pointer;\n        }\n        .convert-button {\n          border-top: 1px solid var(--hax-color-bg-accent);\n        }\n      "]);

    _templateObject_3017d4c0c07b11ea85f79731808de288 = function _templateObject_3017d4c0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  var HaxToolbar =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(HaxToolbar, _LitElement);
    babelHelpers.createClass(HaxToolbar, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject_3017d4c0c07b11ea85f79731808de288())];
      }
    }]);

    function HaxToolbar() {
      var _this;

      babelHelpers.classCallCheck(this, HaxToolbar);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HaxToolbar).call(this));
      _this.selected = false;
      _this.hideMore = false;
      _this.inline = false;
      setTimeout(function () {
        new Promise(function (res, rej) {
          return _require.default(["../../../@polymer/paper-item/paper-item.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["./hax-toolbar-item.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["./hax-context-item.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["./hax-context-item-menu.js"], res, rej);
        });

        _this.addEventListener("hax-context-item-selected", _this._haxContextOperation.bind(babelHelpers.assertThisInitialized(_this)));
      }, 0);
      return _this;
    }

    babelHelpers.createClass(HaxToolbar, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_3017d4c0c07b11ea85f79731808de288(), this.hideMore);
      }
    }, {
      key: "_haxContextOperation",

      /**
       * Respond to simple modifications.
       */
      value: function _haxContextOperation(e) {
        var _this2 = this;

        var detail = e.detail; // support a simple insert event to bubble up or everything else

        switch (detail.eventName) {
          case "close-menu":
            setTimeout(function () {
              _this2.shadowRoot.querySelector("#moremenu").shadowRoot.querySelector("#menu").hideMenu();

              _this2.shadowRoot.querySelector("#justify").shadowRoot.querySelector("#menu").hideMenu();
            }, 200);
            break;
        }
      }
    }], [{
      key: "tag",
      get: function get() {
        return "hax-toolbar";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * See what's selected
           */
          selected: {
            type: Boolean,
            reflect: true
          },

          /**
           * Hide the more menu.
           */
          hideMore: {
            type: Boolean,
            attribute: "hide-more"
          },

          /**
           * This is an inline context menu
           */
          inline: {
            type: Boolean,
            reflect: true
          }
        };
      }
    }]);
    return HaxToolbar;
  }(_litElement.LitElement);

  _exports.HaxToolbar = HaxToolbar;
  window.customElements.define(HaxToolbar.tag, HaxToolbar);
});