define(["exports", "../../../../../lit-element/lit-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js"], function (_exports, _litElement, _haxcmsSiteStore, _mobxModule) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteDotIndicator = void 0;

  function _templateObject2_3be6bff0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <ol id=\"list\"></ol>\n    "]);

    _templateObject2_3be6bff0c07b11ea85f79731808de288 = function _templateObject2_3be6bff0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_3be6bff0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          --site-dot-indicator-color: white;\n        }\n        :host([sticky=\"left\"]) {\n          position: fixed;\n          left: 8px;\n          z-index: 1000;\n          top: 25vh;\n        }\n        :host([sticky=\"right\"]) {\n          position: fixed;\n          right: 8px;\n          z-index: 1000;\n          top: 25vh;\n        }\n        :host([sticky=\"left\"]) ol,\n        :host([sticky=\"right\"]) ol {\n          display: grid;\n        }\n        ol {\n          padding-left: 0;\n          margin-left: 0;\n        }\n        li {\n          transition: 0.3s all ease-in-out;\n          display: inline-block;\n          width: 10px;\n          height: 10px;\n          margin: 2px;\n          text-indent: -999px;\n          cursor: pointer;\n          background-color: rgba(0, 0, 0, 0.1);\n          border: 1px solid var(--site-dot-indicator-color);\n          border-radius: 10px;\n        }\n        a {\n          width: 12px;\n          height: 12px;\n          display: block;\n          margin: 0;\n          padding: 0;\n        }\n        .active {\n          width: 12px;\n          height: 12px;\n          margin: 1px;\n          background-color: var(--site-dot-indicator-color);\n        }\n      "]);

    _templateObject_3be6bff0c07b11ea85f79731808de288 = function _templateObject_3be6bff0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `site-dot-indicator`
   * `list of items based on manifest`
   *
  
   * @polymer
   * @demo demo/index.html
   */
  var SiteDotIndicator =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(SiteDotIndicator, _LitElement);
    babelHelpers.createClass(SiteDotIndicator, null, [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject_3be6bff0c07b11ea85f79731808de288())];
      }
    }]);

    function SiteDotIndicator() {
      var _this;

      babelHelpers.classCallCheck(this, SiteDotIndicator);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SiteDotIndicator).call(this));
      _this.__disposer = [];
      _this.scrollOnActive = false;
      return _this;
    }
    /**
     * Store the tag name to make it easier to obtain directly.
     */


    babelHelpers.createClass(SiteDotIndicator, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject2_3be6bff0c07b11ea85f79731808de288());
      }
      /**
       * Props
       */

    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "activeId") {
            _this2._activeIdChanged(_this2[propName], oldValue);
          }

          if (propName == "routerManifest") {
            _this2._routerManifestChanged(_this2[propName], oldValue);
          }
        });
      }
    }, {
      key: "_activeIdChanged",
      value: function _activeIdChanged(newValue, oldValue) {
        if (newValue) {
          var tmp = this.shadowRoot.querySelector('[data-item="' + newValue + '"');

          if (tmp) {
            tmp.classList.add("active");
          }

          if (oldValue) {
            var _tmp = this.shadowRoot.querySelector('[data-item="' + oldValue + '"');

            if (_tmp) {
              _tmp.classList.remove("active");
            }
          }
        }
      }
    }, {
      key: "_routerManifestChanged",
      value: function _routerManifestChanged(routerManifest) {
        while (this.shadowRoot.querySelector("#list").firstChild !== null) {
          this.shadowRoot.querySelector("#list").removeChild(this.shadowRoot.querySelector("#list").firstChild);
        }

        for (var i in routerManifest.items) {
          var li = document.createElement("li");
          li.setAttribute("data-item", routerManifest.items[i].id);
          li.setAttribute("title", routerManifest.items[i].title);

          if (this.activeId === routerManifest.items[i].id) {
            li.classList.add("active");
          }

          var link = document.createElement("a");
          link.href = routerManifest.items[i].slug;
          li.appendChild(link);
          this.shadowRoot.querySelector("#list").appendChild(li);
        }
      }
    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        var _this3 = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteDotIndicator.prototype), "connectedCallback", this).call(this);
        (0, _mobxModule.autorun)(function (reaction) {
          _this3.routerManifest = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.routerManifest);

          _this3.__disposer.push(reaction);
        });
        (0, _mobxModule.autorun)(function (reaction) {
          _this3.activeId = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.activeId);

          _this3.__disposer.push(reaction);
        });

        if (this.scrollOnActive) {
          this.shadowRoot.querySelector("#list").addEventListener("click", function () {
            _this3.parentElement.querySelector("#" + _this3.activeId).scrollIntoView({
              behavior: "smooth",
              block: "end",
              inline: "nearest"
            });
          });
        }
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        var _this4 = this;

        for (var i in this.__disposer) {
          this.__disposer[i].dispose();
        }

        if (this.scrollOnActive) {
          this.shadowRoot.querySelector("#list").removeEventListener("click", function () {
            _this4.parentElement.querySelector("#" + _this4.activeId).scrollIntoView({
              behavior: "smooth",
              block: "end",
              inline: "nearest"
            });
          });
        }

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteDotIndicator.prototype), "disconnectedCallback", this).call(this);
      }
    }], [{
      key: "tag",
      get: function get() {
        return "site-dot-indicator";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          activeId: {
            type: String,
            attribute: "active-id"
          },
          routerManifest: {
            type: Object
          },
          sticky: {
            type: String,
            reflect: true
          },
          scrollOnActive: {
            type: Boolean,
            attribute: "scroll-on-active"
          }
        };
      }
    }]);
    return SiteDotIndicator;
  }(_litElement.LitElement);

  _exports.SiteDotIndicator = SiteDotIndicator;
  window.customElements.define(SiteDotIndicator.tag, SiteDotIndicator);
});