define(["exports", "require", "../../lit-element/lit-element.js", "../simple-colors/simple-colors.js", "../paper-avatar/paper-avatar.js"], function (_exports, _require, _litElement, _simpleColors, _paperAvatar) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignAvatar = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_26b61900c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          border-radius: 50%;\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n\n        paper-avatar {\n          --paper-avatar-width: var(--lrndesign-avatar-width, 40px);\n          --paper-avatar-color: var(\n            --simple-colors-default-theme-accent-8,\n            #444\n          );\n          --paper-avatar-text-color: var(\n            --simple-colors-default-theme-grey-1,\n            #fff\n          );\n        }\n      "]);

    _templateObject2_26b61900c07b11ea85f79731808de288 = function _templateObject2_26b61900c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_26b61900c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <paper-avatar\n        .label=\"", "\"\n        .icon=\"", "\"\n        .src=\"", "\"\n        ?two-chars=\"", "\"\n        ?jdenticon=\"", "\"\n      ></paper-avatar>\n    "]);

    _templateObject_26b61900c07b11ea85f79731808de288 = function _templateObject_26b61900c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `lrndesign-avatar`
   * Visualize a user account either with an image, icon, initials, or as abstract art.
   *
  ### Styling
  Custom property | Description | Default
  ----------------|-------------|----------
  `--lrndesign-avatar-width` | Size (width and height) of the avatar image | 40px
   *
   * @customElement
   * @lit-html
   * @lit-element
   * @demo demo/index.html
   */
  var LrndesignAvatar =
  /*#__PURE__*/
  function (_SimpleColors) {
    babelHelpers.inherits(LrndesignAvatar, _SimpleColors);
    babelHelpers.createClass(LrndesignAvatar, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_26b61900c07b11ea85f79731808de288(), this.label || "", this.icon || "", this.src || "", this.twoChars, this.jdenticon);
      } // haxProperty definition

    }], [{
      key: "styles",
      //styles function
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignAvatar), "styles", this)), [(0, _litElement.css)(_templateObject2_26b61900c07b11ea85f79731808de288())]);
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: false,
          canEditSource: false,
          gizmo: {
            title: "Avatar",
            description: "Visualize a user account either with an image, icon, initials, or as abstract art.",
            icon: "image:collections",
            color: "yellow",
            groups: ["Media", "Image"],
            handles: [{
              type: "image",
              source: "image"
            }],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            quick: [{
              property: "accentColor",
              title: "Accent Color",
              description: "Pick an accent color.",
              inputMethod: "colorpicker"
            }, {
              property: "dark",
              title: "Dark",
              description: "Use dark text (and light background) for avatar.",
              inputMethod: "boolean"
            }, {
              property: "icon",
              title: "Icon",
              description: "Optional: Pick an icon for avatar.",
              inputMethod: "iconpicker"
            }, {
              property: "src",
              title: "Image Source",
              description: "Optional: Upload an image for avatar.",
              inputMethod: "haxupload"
            }],
            configure: [{
              property: "accentColor",
              title: "Accent Color",
              description: "Pick an accent color.",
              inputMethod: "colorpicker"
            }, {
              property: "dark",
              title: "Dark",
              description: "Use dark text (and light background) for avatar.",
              inputMethod: "boolean"
            }, {
              property: "icon",
              title: "Icon",
              description: "Optional: Pick an icon for avatar.",
              inputMethod: "iconpicker"
            }, {
              property: "src",
              title: "Image Source",
              description: "Optional: Upload an image for avatar.",
              inputMethod: "haxupload"
            }, {
              property: "label",
              title: "Two-character initials",
              description: "Label used to create initials or unique Jdenticon.",
              inputMethod: "textfield"
            }, {
              property: "twoChars",
              title: "Two-character initials",
              description: "When no Jdenticon, image, or icon, use two-character for initials.",
              inputMethod: "boolean"
            }, {
              property: "jdenticon",
              title: "Jdenticon",
              description: "Optional: Unique icon design based on label.",
              inputMethod: "boolean"
            }],
            advanced: []
          }
        };
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignAvatar), "properties", this), {
          /**
           * optional iron-icon
           */
          icon: {
            type: String
          },

          /**
           * text to use for avatar
           */
          label: {
            type: String
          },

          /**
           * link to an image, optional
           */
          src: {
            type: String
          },

          /**
           * Mode for presenting 1st two letters
           */
          twoChars: {
            type: Boolean,
            attribute: "two-chars"
          },

          /**
           * "Deprecated": Color class work to apply
           */
          color: {
            type: String
          },

          /**
           * Form abstract art from hash of label
           */
          jdenticon: {
            type: Boolean
          }
        });
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-avatar";
      } // life cycle

    }]);

    function LrndesignAvatar() {
      var _this;

      babelHelpers.classCallCheck(this, LrndesignAvatar);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrndesignAvatar).call(this));
      _this.tag = LrndesignAvatar.tag;
      new Promise(function (res, rej) {
        return _require.default(["../paper-avatar/paper-avatar.js"], res, rej);
      });
      _this.dark = false;
      _this.twoChars = false;
      _this.jdenticon = false;
      _this.label = "|";
      return _this;
    }
    /**
     * life cycle, element is afixed to the DOM
     */


    babelHelpers.createClass(LrndesignAvatar, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignAvatar.prototype), "connectedCallback", this).call(this);
      }
    }, {
      key: "_getAccentColor",
      value: function _getAccentColor(color) {
        // legacy API bridge
        color = color.replace("-text", "");

        if (this.colors[color] && (!this.accentColor || this.accentColor === "grey")) {
          this.accentColor = this.color;
        }
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        if (babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignAvatar.prototype), "updated", this)) {
          babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignAvatar.prototype), "updated", this).call(this, changedProperties);
        }

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "color") {
            _this2._getAccentColor(_this2[propName]);
          }
        });
      }
    }]);
    return LrndesignAvatar;
  }(_simpleColors.SimpleColors);

  _exports.LrndesignAvatar = LrndesignAvatar;
  customElements.define("lrndesign-avatar", LrndesignAvatar);
});