define(["exports", "../../../lit-element/lit-element.js"], function (_exports, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignGalleryDetails = void 0;

  function _templateObject2_30e1db80c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n        :host([hidden]) {\n          display: none;\n        }\n      "]);

    _templateObject2_30e1db80c07b11ea85f79731808de288 = function _templateObject2_30e1db80c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_30e1db80c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <slot></slot>\n    "]);

    _templateObject_30e1db80c07b11ea85f79731808de288 = function _templateObject_30e1db80c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `lrndesign-gallery-details`
   * An element that renders the print view of a gallery item.
   *
   * @element lrndesign-gallery-details
   * 
   * @microcopy - language worth noting:```
  <lrndesign-gallery-details 
    details="<strong>HTML MARKUP HERE</strong>"       //required, an array of item data
  </lrndesign-gallery-details>```
   *
   */
  var LrndesignGalleryDetails =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(LrndesignGalleryDetails, _LitElement);
    babelHelpers.createClass(LrndesignGalleryDetails, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_30e1db80c07b11ea85f79731808de288());
      }
    }], [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_30e1db80c07b11ea85f79731808de288())];
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       */

    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-gallery-details";
      }
    }]);

    function LrndesignGalleryDetails() {
      babelHelpers.classCallCheck(this, LrndesignGalleryDetails);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrndesignGalleryDetails).call(this));
    }

    babelHelpers.createClass(LrndesignGalleryDetails, [{
      key: "updated",
      value: function updated(changedProperties) {
        var _this = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "details") {
            _this._detailsChanged(_this[propName]);
          }
        });
      } // properties available to the custom element for data binding

    }, {
      key: "_detailsChanged",

      /**
       * updates the details
       */
      value: function _detailsChanged(newValue) {
        this.innerHTML = newValue;
      }
    }], [{
      key: "properties",
      get: function get() {
        return {
          /**
           * image's details in as a string of HTML
           */
          details: {
            type: String
          }
        };
      }
    }]);
    return LrndesignGalleryDetails;
  }(_litElement.LitElement);

  _exports.LrndesignGalleryDetails = LrndesignGalleryDetails;
  window.customElements.define(LrndesignGalleryDetails.tag, LrndesignGalleryDetails);
});