define(["exports", "../../lit-element/lit-element.js", "./lib/lrndesign-gallery-behaviors.js", "../responsive-utility/responsive-utility.js", "./lib/lrndesign-gallery-carousel.js", "./lib/lrndesign-gallery-grid.js", "./lib/lrndesign-gallery-masonry.js"], function (_exports, _litElement, _lrndesignGalleryBehaviors, _responsiveUtility, _lrndesignGalleryCarousel, _lrndesignGalleryGrid, _lrndesignGalleryMasonry) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignGallery = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject5_281b7560c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n\n        ::slotted(figure) {\n          display: block;\n          margin-top: 15px;\n          margin-bottom: 15px;\n          max-width: 400px;\n          max-height: 400px;\n          display: block;\n          border: 1px solid #ddd;\n          page-break-inside: avoid;\n        }\n\n        @media screen {\n          ::slotted(figure) {\n            display: none;\n          }\n        }\n      "]);

    _templateObject5_281b7560c07b11ea85f79731808de288 = function _templateObject5_281b7560c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject4_281b7560c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n              <lrndesign-gallery-carousel\n                accent-color=\"", "\"\n                .aspect-ratio=\"", "\"\n                .extra-wide=\"", "\"\n                ?dark=\"", "\"\n                .gallery-id=\"", "\"\n                @item-changed=\"", "\"\n                responsive-size=\"", "\"\n                .selected=\"", "\"\n                sizing=\"", "\"\n                .sources=\"", "\"\n              >\n              </lrndesign-gallery-carousel>\n            "]);

    _templateObject4_281b7560c07b11ea85f79731808de288 = function _templateObject4_281b7560c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject3_281b7560c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n              <lrndesign-gallery-grid\n                accent-color=\"", "\"\n                .aspect-ratio=\"", "\"\n                .extra-wide=\"", "\"\n                ?dark=\"", "\"\n                .gallery-id=\"", "\"\n                @item-changed=\"", "\"\n                responsive-size=\"", "\"\n                .selected=\"", "\"\n                sizing=\"", "\"\n                .sources=\"", "\"\n              >\n              </lrndesign-gallery-grid>\n            "]);

    _templateObject3_281b7560c07b11ea85f79731808de288 = function _templateObject3_281b7560c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject2_281b7560c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n              <lrndesign-gallery-masonry\n                accent-color=\"", "\"\n                .aspect-ratio=\"", "\"\n                .extra-wide=\"", "\"\n                ?dark=\"", "\"\n                .gallery-id=\"", "\"\n                @item-changed=\"", "\"\n                responsive-size=\"", "\"\n                .selected=\"", "\"\n                .sources=\"", "\"\n              >\n              </lrndesign-gallery-masonry>\n            "]);

    _templateObject2_281b7560c07b11ea85f79731808de288 = function _templateObject2_281b7560c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_281b7560c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div\n        id=\"gallery\"\n        style=\"--lrndesign-gallery-image-aspect:", ";--lrndesign-gallery-image-height:", "%\"\n      >\n        <div slot=\"title\"><slot name=\"title\"></slot></div>\n        <div slot=\"description\"><slot name=\"description\"></slot></div>\n        ", "\n      </div>\n      <slot hidden></slot>\n    "]);

    _templateObject_281b7560c07b11ea85f79731808de288 = function _templateObject_281b7560c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `lrndesign-gallery`
   * displays images as a carousel or grid with the ability to zoom
   *
   * @element lrndesign-gallery
   * @lit-html
   * @lit-element
   * @demo demo/index.html
   */
  var LrndesignGallery =
  /*#__PURE__*/
  function (_LrndesignGalleryBeha) {
    babelHelpers.inherits(LrndesignGallery, _LrndesignGalleryBeha);
    babelHelpers.createClass(LrndesignGallery, [{
      key: "render",
      // render function
      value: function render() {
        var _this2 = this;

        return (0, _litElement.html)(_templateObject_281b7560c07b11ea85f79731808de288(), this.aspectRatio, 100 / this.aspectRatio, this.layout === "masonry" ? (0, _litElement.html)(_templateObject2_281b7560c07b11ea85f79731808de288(), this.accentColor, this.aspect, this.extra, this.dark, this.id, function (e) {
          return _this2.goToItem(e.detail);
        }, this.responsiveSize, this.selected, this.items) : this.grid || this.layout === "grid" ? (0, _litElement.html)(_templateObject3_281b7560c07b11ea85f79731808de288(), this.accentColor, this.aspect, this.extra, this.dark, this.id, function (e) {
          return _this2.goToItem(e.detail);
        }, this.responsiveSize, this.selected, this.sizing === "cover" || "contain", this.items) : (0, _litElement.html)(_templateObject4_281b7560c07b11ea85f79731808de288(), this.accentColor, this.aspect, this.extra, this.dark, this.id, function (e) {
          return _this2.goToItem(e.detail);
        }, this.responsiveSize, this.selected, this.sizing === "cover" || "contain", this.items));
      } // haxProperty definition

    }], [{
      key: "styles",
      //styles function
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGallery), "styles", this)), [(0, _litElement.css)(_templateObject5_281b7560c07b11ea85f79731808de288())]);
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: false,
          canEditSource: true,
          gizmo: {
            title: "Image Gallery",
            description: "An image gallery displayed as a carousel or a grid",
            icon: "image:collections",
            color: "cyan",
            groups: ["Content", "Instructional", "Media", "Image"],
            handles: [{
              type: "image",
              source: "image"
            }],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            quick: [{
              property: "accentColor",
              title: "Accent Color",
              description: "An optional accent color.",
              inputMethod: "colorpicker",
              icon: "editor:format-color-fill"
            }, {
              property: "dark",
              title: "Dark Theme",
              description: "Enable Dark Theme",
              inputMethod: "boolean",
              icon: "icons:invert-colors"
            }, {
              property: "layout",
              title: "Layout",
              description: "Display as grid?",
              inputMethod: "select",
              itemsList: ["carousel", "grid", "masonry"]
            }],
            configure: [{
              slot: "title",
              title: "Optional Gallery Title",
              description: "Am optional title for the gallery.",
              inputMethod: "textfield"
            }, {
              slot: "description",
              title: "OptionalGallery Description",
              description: "An optional description for the gallery.",
              inputMethod: "textfield"
            }, {
              property: "accentColor",
              title: "Accent Color",
              description: "An optional accent color.",
              inputMethod: "colorpicker"
            }, {
              property: "dark",
              title: "Dark Theme",
              description: "Enable Dark Theme",
              inputMethod: "boolean"
            }, {
              property: "layout",
              title: "Layout",
              description: "Display as grid?",
              inputMethod: "select",
              itemsList: ["carousel", "grid", "masonry"]
            }, {
              property: "sources",
              title: "Gallery Images",
              description: "The images for the gallery.",
              inputMethod: "array",
              itemLabel: "title",
              properties: [{
                property: "title",
                title: "Image Title",
                description: "The heading for the image.",
                inputMethod: "textfield"
              }, {
                property: "details",
                title: "Image Details",
                description: "The body text with details for the image.",
                inputMethod: "textfield"
              }, {
                property: "src",
                title: "Image",
                description: "Default Image",
                inputMethod: "haxupload"
              }, {
                property: "thumbnail",
                title: "Optional Thumbnail Image",
                description: "Optional smaller thumbnail version of the image.",
                inputMethod: "haxupload"
              }, {
                property: "large",
                title: "Optional Full Image",
                description: "Optional larger full-sized version of the image for zooming.",
                inputMethod: "haxupload"
              }]
            }],
            advanced: [{
              property: "aspectRatio",
              title: "Aspect Ratio",
              description: "Custom aspect ratio, default is calculated based on the first image's aspect ratio",
              inputMethod: "textfield"
            }, {
              property: "sizing",
              title: "Fit to Aspect Ratio",
              description: "Fit images to aspect ratio",
              inputMethod: "select",
              options: {
                cover: "crop",
                contain: "letterbox"
              }
            }]
          }
        };
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGallery), "properties", this), {
          id: {
            type: String,
            reflect: true,
            attribute: "id"
          },
          responsiveSize: {
            type: String,
            reflect: true,
            attribute: "responsive-size"
          }
        });
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-gallery";
      } // life cycle

    }]);

    function LrndesignGallery() {
      var _this;

      babelHelpers.classCallCheck(this, LrndesignGallery);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrndesignGallery).call(this));
      _this.sources = [];
      _this.sizing = "cover";
      return _this;
    }
    /**
     * life cycle, element is afixed to the DOM
     */


    babelHelpers.createClass(LrndesignGallery, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGallery.prototype), "connectedCallback", this).call(this);
        window.ResponsiveUtility.requestAvailability();
        this.updateGallery();
        this.observer.observe(this, {
          attributes: false,
          childList: true,
          subtree: false
        });
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        if (this.observer && this.observer.disconnect) this.observer.disconnect();
        if (babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGallery.prototype), "disconnectedCallback", this)) babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGallery.prototype), "disconnectedCallback", this).call(this);
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated() {
        babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGallery.prototype), "firstUpdated", this).call(this);
        window.dispatchEvent(new CustomEvent("responsive-element", {
          detail: {
            element: this,
            attribute: "responsive-size",
            sm: 300,
            md: 600,
            lg: 1000,
            xl: 1500
          }
        }));
        this.anchorData = this._getAnchorData();

        if (this.anchorData.gallery === this.id) {
          this.goToItem(this.anchorData.id);
        } else {
          this.goToItem();
        }
      }
      /**
       * handle updates
       */

    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this3 = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGallery.prototype), "updated", this).call(this, changedProperties);
        changedProperties.forEach(function (oldValue, propName) {
          if (propName === "id" && !_this3.id) _this3.id = "gallery-".concat(_this3._generateUUID());
        });
      }
      /**
       * gets aspect ratio of images
       *
       * @readonly
       * @memberof LrndesignGallery
       */

    }, {
      key: "goToItem",

      /**
       * go to item by id, or index
       *
       * @param {string} query
       */
      value: function goToItem(query) {
        var start = this.items[0] || {};

        if (typeof query === "number" && query >= 0 && query < this.items.length) {
          this.selected = this.items[query] || start;
        } else {
          var matches = this.items.filter(function (item) {
            return item.id === query;
          });
          this.selected = matches.length > 0 ? matches[0] : start;
        }
      }
    }, {
      key: "updateGallery",
      value: function updateGallery() {
        var sources = [],
            figures = this.querySelectorAll("figure");
        figures.forEach(function (figure) {
          var id = figure.getAttribute("id"),
              img = figure.querySelector("img"),
              sizing = figure.getAttribute("sizing"),
              query = [1, 2, 3, 4, 5, 6].map(function (num) {
            return "h".concat(num, ":first-child");
          }).join(","),
              src = img && img.getAttribute("src") ? img.getAttribute("src") : undefined,
              srcset = img && img.getAttribute("srcset") ? img.getAttribute("srcset").split(",") : undefined,
              thumbset = srcset && srcset[0] ? srcset[0].split(" ") : undefined,
              largeset = srcset && srcset[srcset.length - 1] ? srcset[srcset.length - 1].split(" ") : undefined,
              thumbnail = thumbset && thumbset[0] ? thumbset[0] : undefined,
              large = largeset && largeset[0] ? largeset[0] : undefined,
              details = figure.querySelector("figcaption") ? figure.querySelector("figcaption").cloneNode(true) : undefined,
              alt = img && img.getAttribute("alt") ? img.getAttribute("alt") : undefined,
              figheading = details && details.querySelector(query) ? details.querySelector(query) : undefined,
              title = figheading.innerHTML;
          if (figheading) figheading.remove();
          sources.push({
            alt: alt,
            id: id,
            src: src,
            thumbnail: thumbnail,
            large: large,
            title: title,
            details: details.innerHTML,
            sizing: sizing
          });
        });
        if (sources.length > 0 && (!this.sources || this.sources.length < 1)) this.sources = sources;
      }
      /**
       * gets aspect ratio of an image and
       * determine if aspect ratio is extra wide
       *
       * @param {array}
       */

    }, {
      key: "_getAnchorData",
      value: function _getAnchorData() {
        var hash = window.location.hash !== null && window.location.hash !== "" ? window.location.hash.replace("#", "") : false,
            data = hash ? hash.split("---") : [];
        return {
          id: data.length > 1 ? data[1] : -1,
          gallery: data.length > 0 ? data[0] : -1,
          zoom: scroll && data.length > 2 && data[2] === "zoom"
        };
      }
    }, {
      key: "aspect",
      get: function get() {
        var items = (this.items || []).filter(function (item) {
          return item.src && item.src != "";
        }),
            src = items && items[0] ? items[0].src : false;

        if (src) {
          var img = new Image();
          img.src = src;
          return img.naturalWidth > 0 && img.naturalHeight > 0 ? img.naturalWidth / img.naturalHeight : 1.33333333;
        } else {
          return 1.33333333;
        }
      }
      /**
       * gets aspect ratio of an image and
       * determine if aspect ratio is extra wide
       *
       * @readonly
       * @memberof LrndesignGallery
       */

    }, {
      key: "extra",
      get: function get() {
        var ew = this.aspect > 2;
        return ew;
      }
      /**
       * gets items array
       *
       * @readonly
       * @memberof LrndesignGalleryBehaviors
       */

    }, {
      key: "items",
      get: function get() {
        var _this4 = this;

        var sources = this.sources || [],
            items = typeof sources === "string" ? JSON.parse(sources) : sources,
            total = items.length,
            itemData = (items || []).map(function (item, i) {
          return {
            alt: item.alt,
            details: item.details,
            index: i,
            id: item.id || "gallery-".concat(_this4.id, "-item-").concat(i),
            src: item.src,
            large: item.large && item.large !== "" ? item.large : item.src,
            thumbnail: item.thumbnail && item.thumbnail != "" ? item.thumbnail : item.src,
            xofy: "".concat(i + 1, " of ").concat(total),
            next: i + 1 < total ? i + 1 : -1,
            prev: i - 1 > -1 ? i - 1 : -1,
            sizing: item.sizing && item.sizing != "" ? item.sizing : _this4.sizing,
            title: item.title,
            tooltip: "".concat(item.title || "Image ".concat(i), " (Zoom In)"),
            heading: "".concat(item.title || "Image ".concat(i), " (Full-Sized)")
          };
        });
        return itemData;
      }
      /**
       * mutation observer for tabs
       * @readonly
       * @returns {object}
       */

    }, {
      key: "observer",
      get: function get() {
        var _this5 = this;

        var callback = function callback() {
          return _this5.updateGallery();
        };

        return new MutationObserver(callback);
      }
    }]);
    return LrndesignGallery;
  }(_lrndesignGalleryBehaviors.LrndesignGalleryBehaviors);

  _exports.LrndesignGallery = LrndesignGallery;
  customElements.define("lrndesign-gallery", LrndesignGallery);
});