define(["exports", "require", "../../@polymer/polymer/polymer-element.js", "../simple-colors/lib/simple-colors-polymer.js", "../a11y-behaviors/a11y-behaviors.js"], function (_exports, _require, _polymerElement, _simpleColorsPolymer, _a11yBehaviors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignPaperstack = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject_28c32710c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style include=\"simple-colors-shared-styles-polymer\">\n        :host {\n          display: block;\n          font-size: 14px;\n          --lrndesign-paperstack-bg: var(--simple-colors-default-theme-grey-1);\n          --lrndesign-paperstack-faded-bg: var(\n            --simple-colors-default-theme-grey-2\n          );\n          --lrndesign-paperstack-border: var(\n            --simple-colors-default-theme-grey-4\n          );\n          --lrndesign-paperstack-shadow: var(\n            --simple-colors-default-theme-grey-12\n          );\n          --lrndesign-paperstack-accent: var(\n            --simple-colors-default-theme-accent-8\n          );\n          --lrndesign-paperstack-text: var(\n            --simple-colors-default-theme-grey-12\n          );\n          --lrndesign-paperstack-heading-font: cursive;\n        }\n        :host([dark]) {\n          --lrndesign-paperstack-bg: var(\n            --simple-colors-default-theme-accent-4\n          );\n          --lrndesign-paperstack-faded-bg: var(\n            --simple-colors-default-theme-accent-3\n          );\n          --lrndesign-paperstack-border: var(\n            --simple-colors-default-theme-accent-1\n          );\n          --lrndesign-paperstack-shadow: var(\n            --simple-colors-default-theme-grey-1\n          );\n          --lrndesign-paperstack-accent: var(\n            --simple-colors-default-theme-grey-12\n          );\n          --lrndesign-paperstack-text: var(\n            --simple-colors-default-theme-grey-12\n          );\n        }\n        .stack {\n          width: 100%;\n          position: relative;\n          display: flex;\n          flex-direction: column;\n          align-items: stretch;\n        }\n        .paper {\n          min-height: 160px;\n          width: 80%;\n          padding: 12px 24px;\n          position: absolute;\n          flex: 1 1 auto;\n          left: 0;\n          top: 0;\n          box-shadow: 0 0 1px var(--lrndesign-paperstack-shadow);\n          border: 1px solid var(--lrndesign-paperstack-border);\n        }\n        .paper:first-of-type {\n          left: -0.32px;\n          top: 0.32px;\n          transform: rotate(-2.5deg);\n          background-color: var(--lrndesign-paperstack-faded-bg);\n        }\n        .paper:nth-of-type(2) {\n          right: -0.32px;\n          top: 1.6px;\n          transform: rotate(1.4deg);\n          background-color: var(--lrndesign-paperstack-faded-bg);\n        }\n        .front {\n          flex: 0 0 100%;\n          position: relative;\n          margin-bottom: 48px;\n          background-color: var(--lrndesign-paperstack-bg);\n          color: var(--lrndesign-paperstack-text);\n        }\n\n        iron-icon {\n          width: 40px;\n          height: 40px;\n          margin: 4px;\n          color: var(--lrndesign-paperstack-bg);\n        }\n        .heading {\n          display: flex;\n          align-items: center;\n        }\n        .icon-container {\n          width: 48px;\n          height: 48px;\n          border-radius: 50%;\n          background-color: var(--lrndesign-paperstack-accent);\n          margin-right: 8px;\n          display: flex;\n          align-items: center;\n        }\n        .title {\n          font-size: 16px;\n          color: var(--lrndesign-paperstack-accent);\n          font-family: var(--lrndesign-paperstack-heading-font);\n        }\n      </style>\n      <div class=\"stack\">\n        <div class=\"paper\"></div>\n        <div class=\"paper\"></div>\n        <div class=\"front paper\">\n          <div class=\"heading\">\n            <div class=\"icon-container circle\">\n              <iron-icon icon=\"[[icon]]\"></iron-icon>\n            </div>\n            <span class=\"title\">[[title]]</span>\n          </div>\n          <p><slot></slot></p>\n        </div>\n      </div>\n    "]);

    _templateObject_28c32710c07b11ea85f79731808de288 = function _templateObject_28c32710c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `lrndesign-paperstack`
   * @element lrndesign-paperstack
   * `Stack of papers visually`
   *
   * @demo demo/index.html
   */
  var LrndesignPaperstack =
  /*#__PURE__*/
  function (_A11yBehaviors) {
    babelHelpers.inherits(LrndesignPaperstack, _A11yBehaviors);

    function LrndesignPaperstack() {
      var _this;

      babelHelpers.classCallCheck(this, LrndesignPaperstack);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrndesignPaperstack).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/iron-icon/iron-icon.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../lrn-icons/lrn-icons.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(LrndesignPaperstack, null, [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_28c32710c07b11ea85f79731808de288());
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-paperstack";
      }
    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignPaperstack), "properties", this), {
          /**
           * Title
           */
          title: {
            type: String,
            value: "Title"
          },

          /**
           * icon
           */
          icon: {
            type: String,
            value: "lrn:assignment"
          }
        });
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Paper stack",
            description: "A stack of papers",
            icon: "icons:content-copy",
            color: "grey",
            groups: ["Content", "Layout"],
            handles: [],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            quick: [{
              property: "title",
              title: "Title",
              description: "Title of the cards",
              inputMethod: "textfield",
              icon: "editor:title"
            }, {
              property: "accentColor",
              title: "Accent Color",
              description: "Select the accent color use",
              inputMethod: "colorpicker",
              icon: "editor:format-color-fill"
            }, {
              property: "dark",
              title: "Dark",
              description: "Use dark theme",
              inputMethod: "boolean",
              icon: "invert-colors"
            }],
            configure: [{
              property: "title",
              title: "Title",
              description: "Title of the cards",
              inputMethod: "boolean"
            }, {
              property: "accentColor",
              title: "Accent Color",
              description: "Select the accent color use",
              inputMethod: "colorpicker",
              icon: "editor:format-color-fill"
            }, {
              property: "dark",
              title: "Dark",
              description: "Use dark theme",
              inputMethod: "boolean",
              icon: "invert-colors"
            }, {
              property: "icon",
              title: "Icon",
              description: "Icon for the card",
              inputMethod: "iconpicker"
            }, {
              slot: "",
              title: "Contents",
              description: "card contents",
              inputMethod: "code-editor"
            }],
            advanced: []
          }
        };
      }
    }]);
    return LrndesignPaperstack;
  }((0, _a11yBehaviors.A11yBehaviors)(_simpleColorsPolymer.SimpleColorsPolymer));

  _exports.LrndesignPaperstack = LrndesignPaperstack;
  window.customElements.define(LrndesignPaperstack.tag, LrndesignPaperstack);
});