define(["exports", "require", "../../../lit-element/lit-element.js"], function (_exports, _require, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnsysCollapselistItem = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject2_31385ff0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <paper-button\n        @click=\"", "\"\n        id=\"collapse-trigger\"\n        aria-controls=\"collapse\"\n      >\n        <span class=\"collapse-label\"> <slot name=\"label\"></slot> </span>\n      </paper-button>\n      <iron-collapse\n        id=\"collapse\"\n        .opened=\"", "\"\n        @opened-changed=\"", "\"\n      >\n        <div class=\"collapse-content\"><slot name=\"content\"></slot></div>\n      </iron-collapse>\n    "]);

    _templateObject2_31385ff0c07b11ea85f79731808de288 = function _templateObject2_31385ff0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_31385ff0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          color: var(--lrnsys-collapselist-text-color, #000);\n        }\n        paper-button {\n          height: 48px;\n          padding: 0;\n          margin: 0;\n          min-width: 0.16px;\n          -webkit-justify-content: flex-start;\n          justify-content: flex-start;\n          align-items: center;\n          width: 100%;\n          text-transform: unset;\n          border-radius: 0;\n          background-color: var(--lrnsys-collapselist-item-color, #fff);\n        }\n        paper-button span {\n          pointer-events: none;\n        }\n        .collapse-label {\n          padding: 12px 8px 4px 8px;\n          width: 100%;\n          height: 32px;\n        }\n        :host([opened]) #collapse {\n          border-top: 1px solid var(--lrnsys-collapselist-item-border, #bbb);\n          background-color: var(--lrnsys-collapselist-item-active-color, #eee);\n        }\n        :host([opened]) .collapse-label {\n          font-weight: bold;\n          background-color: var(--lrnsys-collapselist-item-active-color, #eee);\n        }\n        .collapse-content {\n          padding: 16px;\n        }\n      "]);

    _templateObject_31385ff0c07b11ea85f79731808de288 = function _templateObject_31385ff0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `lrnsys-collapselist-item`
   * @element lrnsys-collapselist-item
   * @demo demo/index.html
   */
  var LrnsysCollapselistItem =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(LrnsysCollapselistItem, _LitElement);
    babelHelpers.createClass(LrnsysCollapselistItem, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject_31385ff0c07b11ea85f79731808de288())];
      }
      /**
       * HTMLElement
       */

    }]);

    function LrnsysCollapselistItem() {
      var _this;

      babelHelpers.classCallCheck(this, LrnsysCollapselistItem);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrnsysCollapselistItem).call(this));
      _this.value = false;
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-button/paper-button.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/iron-collapse/iron-collapse.js"], res, rej);
      });
      return _this;
    }
    /**
     * LitElement render
     */


    babelHelpers.createClass(LrnsysCollapselistItem, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_31385ff0c07b11ea85f79731808de288(), this.collapseToggle, this.opened, this.__openedChanged);
      }
    }, {
      key: "__openedChanged",
      value: function __openedChanged(e) {
        this.opened = e.detail.value;
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName === "opened") {
            // notify
            _this2.dispatchEvent(new CustomEvent("opened-changed", {
              detail: {
                value: _this2[propName]
              }
            }));
          }
        });
      }
      /**
       * Toggling collapse on an iron element.
       */

    }, {
      key: "collapseToggle",
      value: function collapseToggle(e) {
        this.shadowRoot.querySelector("#collapse").toggle();
      }
    }], [{
      key: "tag",
      get: function get() {
        return "lrnsys-collapselist-item";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Whether or not this is default open on render.
           */
          opened: {
            type: Boolean,
            reflect: true
          }
        };
      }
    }]);
    return LrnsysCollapselistItem;
  }(_litElement.LitElement);

  _exports.LrnsysCollapselistItem = LrnsysCollapselistItem;
  window.customElements.define(LrnsysCollapselistItem.tag, LrnsysCollapselistItem);
});