define(["exports", "../../../lit-element/lit-element.js", "../../../@polymer/iron-icons/iron-icons.js", "../../../@polymer/iron-icon/iron-icon.js", "../../../@polymer/paper-button/paper-button.js"], function (_exports, _litElement, _ironIcons, _ironIcon, _paperButton) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MapMenuItem = void 0;

  function _templateObject4_316626b0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          transition: 0.1s all ease-in-out;\n          font-size: var(--map-menu-item-font-size);\n          --map-menu-item-height: 24px;\n          --map-menu-item-a-color: inherit;\n        }\n        :host([active]) {\n          background: var(--map-menu-active-color);\n          color: var(--map-menu-item-active-item-color, #000000);\n        }\n        paper-button {\n          width: 100%;\n          justify-content: left;\n          margin: 0;\n        }\n        iron-icon {\n          display: inline-block;\n          --iron-icon-height: var(--map-menu-item-height);\n          --iron-icon-width: var(--map-menu-item-height);\n        }\n        .title {\n          text-transform: none;\n        }\n        a:visited,\n        a {\n          display: block;\n          color: var(--map-menu-item-a-color);\n          text-decoration: var(--map-menu-item-a-text-decoration, none);\n        }\n        a:hover,\n        a:active,\n        a:focus {\n          color: var(\n            --map-menu-item-a-active-color,\n            var(--map-menu-item-a-color)\n          );\n          text-decoration: var(\n            --map-menu-item-a-text-decoration-hover,\n            underline\n          );\n        }\n        #track {\n          transition: 0.1s all ease-in-out;\n          position: absolute;\n          right: 0;\n\n          margin-right: 0px;\n          width: 0px;\n          height: 0px;\n          visibility: hidden;\n          opacity: 0;\n        }\n        #track.show-icon {\n          margin-right: 5px;\n          width: 18px;\n          height: 18px;\n          visibility: visible;\n          opacity: 1;\n        }\n        #wrapper {\n          font-size: var(--map-menu-font-size);\n        }\n      "]);

    _templateObject4_316626b0c07b11ea85f79731808de288 = function _templateObject4_316626b0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject3_316626b0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n                <iron-icon id=\"track\" icon=\"", "\"></iron-icon>\n              "]);

    _templateObject3_316626b0c07b11ea85f79731808de288 = function _templateObject3_316626b0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject2_316626b0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n                <iron-icon icon=\"", "\"></iron-icon>\n              "]);

    _templateObject2_316626b0c07b11ea85f79731808de288 = function _templateObject2_316626b0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_316626b0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <a tabindex=\"-1\" href=\"", "\">\n        <paper-button id=\"wrapper\" role=\"link\" noink>\n          ", "\n          <span class=\"title\">", "</span>\n          ", "\n        </paper-button>\n      </a>\n    "]);

    _templateObject_316626b0c07b11ea85f79731808de288 = function _templateObject_316626b0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  var MapMenuItem =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(MapMenuItem, _LitElement);
    babelHelpers.createClass(MapMenuItem, [{
      key: "render",

      /**
       * LitElement life cycle - render callback
       */
      value: function render() {
        return (0, _litElement.html)(_templateObject_316626b0c07b11ea85f79731808de288(), this.url, this.icon ? (0, _litElement.html)(_templateObject2_316626b0c07b11ea85f79731808de288(), this.icon) : "", this.title, this.trackIcon ? (0, _litElement.html)(_templateObject3_316626b0c07b11ea85f79731808de288(), this.trackIcon) : "");
      }
    }], [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject4_316626b0c07b11ea85f79731808de288())];
      }
    }, {
      key: "tag",
      get: function get() {
        return "map-menu-item";
      }
    }]);

    function MapMenuItem() {
      var _this;

      babelHelpers.classCallCheck(this, MapMenuItem);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(MapMenuItem).call(this));
      _this.icon = "";
      _this.trackIcon = "";
      _this.title = "";
      _this.url = "";
      _this.active = false;
      return _this;
    }
    /**
     * LitElement life cycle - properties definition
     */


    babelHelpers.createClass(MapMenuItem, [{
      key: "updated",

      /**
       * LitElement life cycle - properties changed callback
       */
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "trackIcon") {
            _this2._trackIconChanged(_this2[propName], oldValue);
          }

          if (["id", "selected"].includes(propName)) {
            _this2.__selectedChanged(_this2.selected, _this2.id);
          }
        });
      }
    }, {
      key: "_trackIconChanged",
      value: function _trackIconChanged(newValue, oldValue) {
        if (this.shadowRoot.querySelector("#track")) {
          if (newValue) {
            this.shadowRoot.querySelector("#track").classList.add("show-icon");
          } else {
            this.shadowRoot.querySelector("#track").classList.remove("show-icon");
          }
        }
      }
    }, {
      key: "__selectedChanged",
      value: function __selectedChanged(selected, id) {
        if (selected === id) {
          this.dispatchEvent(new CustomEvent("active-item", {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: this
          }));
        }
      }
    }, {
      key: "_click",
      value: function _click() {
        this.dispatchEvent(new CustomEvent("link-clicked", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            id: this.id
          }
        }));
      }
    }], [{
      key: "properties",
      get: function get() {
        var _ref;

        return _ref = {
          icon: {
            type: String
          },
          trackIcon: {
            type: String,
            attribute: "track-icon"
          },
          title: {
            type: String
          },
          url: {
            type: String
          }
        }, babelHelpers.defineProperty(_ref, "icon", {
          type: String
        }), babelHelpers.defineProperty(_ref, "id", {
          type: String,
          reflect: true
        }), babelHelpers.defineProperty(_ref, "active", {
          type: Boolean
        }), babelHelpers.defineProperty(_ref, "selected", {
          type: String
        }), _ref;
      }
    }]);
    return MapMenuItem;
  }(_litElement.LitElement);

  _exports.MapMenuItem = MapMenuItem;
  window.customElements.define(MapMenuItem.tag, MapMenuItem);
});