define(["exports", "./lib/MutationObserverImportMixin.js"], function (_exports, _MutationObserverImportMixin) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MutationObserverImportElement = void 0;

  /**
   * Copyright 2020 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */

  /**
   * `mutation-observer-import-mixin`
   * `a SuperClass mixin that dynamically imports undefined custom element definitions`
   * @demo demo/index.html
   * @element mutation-observer-import-mixin
   */
  var MutationObserverImportElement =
  /*#__PURE__*/
  function (_MutationObserverImpo) {
    babelHelpers.inherits(MutationObserverImportElement, _MutationObserverImpo);

    function MutationObserverImportElement() {
      babelHelpers.classCallCheck(this, MutationObserverImportElement);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(MutationObserverImportElement).apply(this, arguments));
    }

    babelHelpers.createClass(MutationObserverImportElement, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(MutationObserverImportElement.prototype), "connectedCallback", this).call(this);
        this.processElementList(this.children);
      }
    }], [{
      key: "tag",
      get: function get() {
        return "mutation-observer-import";
      }
    }]);
    return MutationObserverImportElement;
  }((0, _MutationObserverImportMixin.MutationObserverImportMixin)(HTMLElement));

  _exports.MutationObserverImportElement = MutationObserverImportElement;
  customElements.define(MutationObserverImportElement.tag, MutationObserverImportElement);
});