define(["exports", "../../lit-element/lit-element.js", "../hax-body-behaviors/lib/HAXWiring.js", "../accent-card/accent-card.js", "../../@polymer/iron-icon/iron-icon.js", "../../@polymer/iron-icons/iron-icons.js", "./lib/nav-card-item.js"], function (_exports, _litElement, _HAXWiring, _accentCard, _ironIcon, _ironIcons, _navCardItem) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.NavCard = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_2a9b6980c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          --accent-card-content-padding-bottom: 0px;\n          --nav-card-item-avatar-size: 36px;\n          --nav-card-item-icon-size: 24px;\n        }\n\n        ::slotted([slot=\"linklist\"]) {\n          --nav-card-item-color: var(--accent-card-color);\n          --nav-card-item-background-color: var(--accent-card-background-color);\n          margin-top: var(--nav-card-linklist-margin-top, 20px);\n          margin-bottom: var(--nav-card-linklist-margin-bottom, 20px);\n        }\n      "]);

    _templateObject2_2a9b6980c07b11ea85f79731808de288 = function _templateObject2_2a9b6980c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_2a9b6980c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <article id=\"card\">\n        <div class=\"image-outer\" ?hidden=\"", "\">\n          <div\n            class=\"image\"\n            .style=\"", "\"\n          ></div>\n        </div>\n        <div class=\"body\">\n          <h1 id=\"heading\"><slot name=\"heading\"></slot></h1>\n          <div id=\"subheading\"><slot name=\"subheading\"></slot></div>\n          <div id=\"content\">\n            <slot name=\"body\"></slot>\n            <div id=\"linklist\">\n              <slot name=\"linklist\"></slot>\n            </div>\n          </div>\n          <div id=\"footer\"><slot name=\"footer\"></slot></div>\n        </div>\n      </article>\n    "]);

    _templateObject_2a9b6980c07b11ea85f79731808de288 = function _templateObject_2a9b6980c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `nav-card`
   * an accent card of link lists
   *
   * @customElement nav-card
   * @lit-html
   * @lit-element
   * @demo demo/index.html
   */
  var NavCard =
  /*#__PURE__*/
  function (_AccentCard) {
    babelHelpers.inherits(NavCard, _AccentCard);
    babelHelpers.createClass(NavCard, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_2a9b6980c07b11ea85f79731808de288(), !this.imageSrc, this.imageSrc ? "background-image: url(".concat(this.imageSrc, ");") : "display: none;");
      } // haxProperty definition

    }], [{
      key: "styles",
      //styles function
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(NavCard), "styles", this)), [(0, _litElement.css)(_templateObject2_2a9b6980c07b11ea85f79731808de288())]);
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Nav card",
            description: "an accent card of link lists",
            icon: "av:playlist-play",
            color: "pink",
            groups: ["Card", "Nav", "List"],
            handles: [{
              type: "todo:read-the-docs-for-usage"
            }],
            meta: {
              author: "nikkimk",
              owner: "The Pennsylvania State University"
            }
          },
          settings: {
            quick: [],
            configure: [{
              property: "accentColor",
              title: "Accent Color",
              description: "Select an accent color.",
              inputMethod: "colorpicker",
              required: false
            }, {
              property: "dark",
              title: "Dark",
              description: "Display the card as dark theme?",
              inputMethod: "boolean",
              required: false
            }, {
              property: "imageSrc",
              title: "Image",
              description: "Optional image",
              inputMethod: "haxupload"
            }, {
              slot: "heading",
              title: "Heading",
              inputMethod: "code-editor",
              required: false
            }, {
              slot: "subheading",
              title: "Subheading",
              inputMethod: "code-editor",
              required: false
            }, {
              slot: "body",
              title: "Body",
              inputMethod: "code-editor",
              required: false
            }, {
              property: "linkIcon",
              title: "Link Icon",
              description: "Select an icon.",
              inputMethod: "iconpicker",
              required: false
            }, {
              slot: "linklist",
              title: "Link List",
              inputMethod: "code-editor",
              required: false
            }, {
              slot: "footer",
              title: "Footer",
              inputMethod: "code-editor",
              required: false
            }],
            advanced: []
          }
        };
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(NavCard), "properties", this));
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }, {
      key: "tag",
      get: function get() {
        return "nav-card";
      } // life cycle

    }]);

    function NavCard() {
      var _this;

      babelHelpers.classCallCheck(this, NavCard);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(NavCard).call(this));
      _this.tag = NavCard.tag;
      return _this;
    }

    return NavCard;
  }(_accentCard.AccentCard);

  _exports.NavCard = NavCard;
  customElements.define("nav-card", NavCard);
});