define(["exports", "../../../lit-element/lit-element.js", "../responsive-utility.js"], function (_exports, _litElement, _responsiveUtility) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ResponsiveUtilityBehaviors = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject_346c61d0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        <slot></slot>\n      "]);

    _templateObject_346c61d0c07b11ea85f79731808de288 = function _templateObject_346c61d0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `responsive-utility-behaviors`
   * A superclass to that custom elements can extend to automatically use ResponsiveUtility.
   *
   * @class ResponsiveUtilityBehaviors
   * @see ResponsiveUtility
   * @demo ../demo/index.html
   */
  var ResponsiveUtilityBehaviors = function ResponsiveUtilityBehaviors(SuperClass) {
    return (
      /*#__PURE__*/
      function (_SuperClass) {
        babelHelpers.inherits(_class, _SuperClass);
        babelHelpers.createClass(_class, [{
          key: "render",
          value: function render() {
            return (0, _litElement.html)(_templateObject_346c61d0c07b11ea85f79731808de288());
          }
        }], [{
          key: "properties",
          get: function get() {
            var props = {};

            if (babelHelpers.get(babelHelpers.getPrototypeOf(_class), "properties", this)) {
              props = babelHelpers.get(babelHelpers.getPrototypeOf(_class), "properties", this);
            }

            return _objectSpread({}, props, {
              /*
               * size for responsive styling: xs, sm, md, lg, xl
               */
              responsiveSize: {
                type: String,
                attribute: "responsive-size",
                reflect: true
              },

              /*
               * width in pixels
               */
              responsiveWidth: {
                type: Number,
                attribute: "responsive-width",
                reflect: true
              },

              /*
               * Miniumum value for small breakpoint
               */
              sm: {
                type: Number,
                attribute: "sm"
              },

              /*
               * Miniumum value for medium breakpoint
               */
              md: {
                type: Number,
                attribute: "md"
              },

              /*
               * Miniumum value for large breakpoint
               */
              lg: {
                type: Number,
                attribute: "lg"
              },

              /**
               * Miniumum value for extra-large breakpoint
               */
              xl: {
                type: Number,
                attribute: "xl"
              }
            });
          }
        }]);

        function _class() {
          var _this;

          babelHelpers.classCallCheck(this, _class);
          _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(_class).call(this));
          _this.responsiveSize = "xs";
          _this.sm = 600;
          _this.md = 900;
          _this.lg = 1200;
          _this.xl = 1500;
          return _this;
        }
        /**
         * init the utility & register element
         */


        babelHelpers.createClass(_class, [{
          key: "firstUpdated",
          value: function firstUpdated() {
            babelHelpers.get(babelHelpers.getPrototypeOf(_class.prototype), "firstUpdated", this).call(this);
            window.ResponsiveUtility.requestAvailability();
            this.dispatchEvent(new CustomEvent("responsive-element", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: {
                attribute: "responsive-size",
                custom: "responsive-width",
                element: this,
                sm: this.sm,
                md: this.md,
                lg: this.lg,
                xl: this.xl
              }
            }));
          }
          /**
           * detached the element
           */

        }, {
          key: "disconnectedCallback",
          value: function disconnectedCallback() {
            this.dispatchEvent(new CustomEvent("responsive-element-deleted", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: this
            }));
            babelHelpers.get(babelHelpers.getPrototypeOf(_class.prototype), "disconnectedCallback", this).call(this);
          }
        }]);
        return _class;
      }(SuperClass)
    );
  };

  _exports.ResponsiveUtilityBehaviors = ResponsiveUtilityBehaviors;
});