define(["exports", "../../../lit-element/lit-element.js", "./responsive-utility-behaviors.js"], function (_exports, _litElement, _responsiveUtilityBehaviors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ResponsiveUtilityElement = void 0;

  /**
   * `responsive-utility-element`
   * A simpler way to use responsive utility.
   *
   * @element responsive-utility-element
   * @extends ResponsiveUtilityBehaviors
   * @see ResponsiveUtility
   * @demo ../demo/index.html
   */
  var ResponsiveUtilityElement =
  /*#__PURE__*/
  function (_ResponsiveUtilityBeh) {
    babelHelpers.inherits(ResponsiveUtilityElement, _ResponsiveUtilityBeh);

    function ResponsiveUtilityElement() {
      babelHelpers.classCallCheck(this, ResponsiveUtilityElement);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(ResponsiveUtilityElement).apply(this, arguments));
    }

    babelHelpers.createClass(ResponsiveUtilityElement, null, [{
      key: "tag",
      get: function get() {
        return "responsive-utility-element";
      }
    }]);
    return ResponsiveUtilityElement;
  }((0, _responsiveUtilityBehaviors.ResponsiveUtilityBehaviors)(_litElement.LitElement));

  _exports.ResponsiveUtilityElement = ResponsiveUtilityElement;
  window.customElements.define(ResponsiveUtilityElement.tag, ResponsiveUtilityElement);
});