define(["exports", "../../../lit-element/lit-element.js", "./simple-fields-fieldset.js", "../../a11y-tabs/a11y-tabs.js", "./simple-fields-tab.js"], function (_exports, _litElement, _simpleFieldsFieldset, _a11yTabs, _simpleFieldsTab) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SimpleFieldsTabs = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_351461a0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host([error]) #tabs .error {\n          color: var(--simple-fields-error-color, #dd2c00);\n          transition: border 0.5s ease;\n        }\n        :host {\n          --a11y-tabs-font-family: var(--simple-fields-font-family, sans-serif);\n          --a11y-tabs-font-size: var(--simple-fields-detail-font-size, 12px);\n          --a11y-tabs-color: var(--simple-fields-color, black);\n          --a11y-tabs-focus-color: var(--simple-fields-color, black);\n          --a11y-tabs-border-color: var(\n            --simple-fields-border-color-light,\n            #ccc\n          );\n          --a11y-tabs-margin: var(--simple-fields-margin, 16px) 0;\n          --a11y-tabs-border-radius: var(--simple-fields-border-radius, 2px);\n          --a11y-tabs-button-padding: var(--simple-fields-margin-small, 8px);\n          --a11y-tabs-content-padding: var(--simple-fields-margin, 16px);\n        }\n      "]);

    _templateObject2_351461a0c07b11ea85f79731808de288 = function _templateObject2_351461a0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_351461a0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <span class=\"label", "\"\n        >", "", "</span\n      >\n    "]);

    _templateObject_351461a0c07b11ea85f79731808de288 = function _templateObject_351461a0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `simple-fields-tabs` takes in a JSON schema of type array and builds a form,
   * exposing a `value` property that represents an array described by the schema.
   *
   * @group simple-fields
   * @element simple-fields-tabs
   * @extends a11y-tabs
   * @extends simple-fields-fieldset
   */
  var SimpleFieldsTabs =
  /*#__PURE__*/
  function (_A11yTabs) {
    babelHelpers.inherits(SimpleFieldsTabs, _A11yTabs);

    function SimpleFieldsTabs() {
      babelHelpers.classCallCheck(this, SimpleFieldsTabs);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SimpleFieldsTabs).apply(this, arguments));
    }

    babelHelpers.createClass(SimpleFieldsTabs, [{
      key: "_tabLabel",

      /**
       * makes tab label
       *
       * @param {string} flag tab's flag
       * @returns object
       * @memberof A11yTabs
       */
      value: function _tabLabel(tab) {
        return (0, _litElement.html)(_templateObject_351461a0c07b11ea85f79731808de288(), tab.error ? " error" : "", tab.label, tab.error ? "*" : "");
      }
    }, {
      key: "tabQuery",

      /**
       * query selector for tabs
       * override this for custom elements that extend a11y-tabs
       *
       * @readonly
       * @memberof A11yTabs
       */
      get: function get() {
        return "simple-fields-tab";
      }
    }], [{
      key: "tag",
      get: function get() {
        return "simple-fields-tabs";
      }
    }, {
      key: "styles",
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(SimpleFieldsTabs), "styles", this)), babelHelpers.toConsumableArray(_simpleFieldsFieldset.SimpleFieldsFieldset.styles), [(0, _litElement.css)(_templateObject2_351461a0c07b11ea85f79731808de288())]);
      }
    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(SimpleFieldsTabs), "properties", this), {}, _simpleFieldsFieldset.SimpleFieldsFieldset.properties);
      }
    }]);
    return SimpleFieldsTabs;
  }(_a11yTabs.A11yTabs);

  _exports.SimpleFieldsTabs = SimpleFieldsTabs;
  window.customElements.define(SimpleFieldsTabs.tag, SimpleFieldsTabs);
});