define(["exports", "require", "../../lit-element/lit-element.js", "../../@polymer/paper-tabs/paper-tabs.js"], function (_exports, _require, _litElement, _paperTabs) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.TabList = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject3_2c892fc0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n            <paper-tab>\n              <a\n                target=\"_blank\"\n                href=\"", "\"\n                tabindex=\"-1\"\n                rel=\"noopener noreferrer\"\n              >\n                <paper-button raised>", "</paper-button>\n              </a>\n            </paper-tab>\n          "]);

    _templateObject3_2c892fc0c07b11ea85f79731808de288 = function _templateObject3_2c892fc0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject2_2c892fc0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <paper-tabs>\n        ", "\n      </paper-tabs>\n    "]);

    _templateObject2_2c892fc0c07b11ea85f79731808de288 = function _templateObject2_2c892fc0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_2c892fc0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          margin: 0 auto;\n          list-style: none;\n          display: block;\n          padding: 16px;\n          border-bottom: 1px solid black;\n        }\n        paper-tabs {\n          align-items: center;\n          justify-items: center;\n        }\n        paper-tab a {\n          text-decoration: none;\n          flex: unset;\n          height: unset;\n          width: 100%;\n          text-align: center;\n        }\n        paper-button {\n          text-transform: unset;\n          width: 100%;\n          display: block;\n          min-width: unset;\n          margin: 0;\n          text-overflow: ellipsis;\n          overflow: hidden;\n        }\n        @media screen and (max-width: 600px) {\n          paper-tab {\n            display: block;\n          }\n        }\n      "]);

    _templateObject_2c892fc0c07b11ea85f79731808de288 = function _templateObject_2c892fc0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `tab-list`
   * @element tab-list
   * `A simple listing of tabed links / items`
   * @demo demo/index.html
   */
  var TabList =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(TabList, _LitElement);
    babelHelpers.createClass(TabList, null, [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject_2c892fc0c07b11ea85f79731808de288())];
      }
    }]);

    function TabList() {
      var _this;

      babelHelpers.classCallCheck(this, TabList);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(TabList).call(this));
      _this.tabs = [];
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/paper-tabs/paper-tab.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/paper-button/paper-button.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(TabList, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_2c892fc0c07b11ea85f79731808de288(), this.tabs.map(function (tab) {
          return (0, _litElement.html)(_templateObject3_2c892fc0c07b11ea85f79731808de288(), tab.link, tab.label);
        }));
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "tabs") {
            // fire an event that this is a core piece of the system
            _this2.dispatchEvent(new CustomEvent("tabs-changed", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: _this2[propName]
            }));
          }
        });
      }
    }], [{
      key: "tag",
      get: function get() {
        return "tab-list";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * List of tabs
           */
          tabs: {
            type: Array
          }
        };
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: false,
          canEditSource: false,
          gizmo: {
            title: "Tabs",
            description: "A list of links as tabs.",
            icon: "icons:tab",
            color: "grey",
            groups: ["Presentation", "Links"],
            handles: [],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            quick: [],
            configure: [{
              property: "tabs",
              title: "Tabs",
              description: "Listing of tabs",
              inputMethod: "array",
              itemLabel: "label",
              properties: [{
                property: "link",
                title: "Link",
                description: "link to go to",
                inputMethod: "textfield",
                required: true
              }, {
                property: "label",
                title: "Label",
                description: "text to place on the tab",
                inputMethod: "textfield",
                required: true
              }]
            }],
            advanced: []
          }
        };
      }
    }]);
    return TabList;
  }(_litElement.LitElement);

  _exports.TabList = TabList;
  window.customElements.define(TabList.tag, TabList);
});