define(["exports", "meta", "require", "../../lit-element/lit-element.js", "./lib/vmsg-fork.js"], function (_exports, meta, _require, _litElement, _vmsgFork) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.VoiceRecorder = void 0;
  meta = babelHelpers.interopRequireWildcard(meta);
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject2_2d13e390c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: inline-flex;\n        }\n      "]);

    _templateObject2_2d13e390c07b11ea85f79731808de288 = function _templateObject2_2d13e390c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_2d13e390c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <button @click=\"", "\">\n        <iron-icon icon=\"", "\"></iron-icon>", "\n      </button>\n      <slot></slot>\n    "]);

    _templateObject_2d13e390c07b11ea85f79731808de288 = function _templateObject_2d13e390c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * `voice-recorder`
   * `LAME bridge`
   *
   * @demo demo/index.html
   * @element voice-recorder
   */
  var VoiceRecorder =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(VoiceRecorder, _LitElement);
    babelHelpers.createClass(VoiceRecorder, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_2d13e390c07b11ea85f79731808de288(), this.recordState, this.iconState, this.textState);
      }
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_2d13e390c07b11ea85f79731808de288())];
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          iconState: {
            type: String
          },
          textState: {
            type: String
          },
          recording: {
            type: Boolean
          }
        };
      }
      /**
       * Convention we use
       */

    }, {
      key: "tag",
      get: function get() {
        return "voice-recorder";
      }
      /**
       * HTMLElement
       */

    }]);

    function VoiceRecorder() {
      var _this;

      babelHelpers.classCallCheck(this, VoiceRecorder);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(VoiceRecorder).call(this));
      _this.recording = false;
      setTimeout(function () {
        new Promise(function (res, rej) {
          return _require.default(["../../@polymer/iron-icon/iron-icon.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["../../@polymer/iron-icons/av-icons.js"], res, rej);
        });

        _this.addEventListener("vmsg-ready", _this.vmsgReady.bind(babelHelpers.assertThisInitialized(_this)));
      }, 0);
      return _this;
    }

    babelHelpers.createClass(VoiceRecorder, [{
      key: "recordState",
      value: function recordState(e) {
        this.recording = !this.recording;
      }
      /**
       * LitElement life cycle - property changed
       */

    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "recording") {
            if (_this2[propName]) {
              _this2.textState = "stop";
              _this2.iconState = "av:stop";
            } else {
              _this2.textState = "Record";
              _this2.iconState = "av:play-arrow";
            } // observer to act on the recording piece


            _this2.toggleRecording(_this2[propName], oldValue);
          }
        });
      }
    }, {
      key: "vmsgReady",
      value: function vmsgReady(e) {
        console.log(e.detail.value);
      }
      /**
       * Toggle the LAME bridge
       */

    }, {
      key: "toggleRecording",
      value: function toggleRecording(newValue, oldValue) {
        var _this3 = this;

        if (newValue) {
          // need to start...
          (0, _vmsgFork.record)({
            wasmURL: this.pathFromUrl(decodeURIComponent(meta.url)) + "../../node_modules/vmsg/vmsg.wasm"
          }, this).then(function (blob) {
            _this3.dispatchEvent(new CustomEvent("voice-recorder-recording", {
              value: blob
            }));
          });
        }
      }
    }, {
      key: "pathFromUrl",
      value: function pathFromUrl(url) {
        return url.substring(0, url.lastIndexOf("/") + 1);
      }
    }]);
    return VoiceRecorder;
  }(_litElement.LitElement);

  _exports.VoiceRecorder = VoiceRecorder;
  customElements.define(VoiceRecorder.tag, VoiceRecorder);
});