define(["exports", "../../tslib/tslib.es6.js", "../mwc-icon/mwc-icon.js", "../mwc-ripple/ripple-directive.js", "../../lit-element/lit-element.js", "../../lit-html/directives/class-map.js"], function (_exports, _tslibEs, _mwcIcon, _rippleDirective, _litElement, _classMap) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ButtonBase = void 0;

  function _templateObject2_26b1fa50c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <mwc-icon class=\"mdc-button__icon\">\n        ", "\n      </mwc-icon>"]);

    _templateObject2_26b1fa50c07b11ea85f79731808de288 = function _templateObject2_26b1fa50c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  function _templateObject_26b1fa50c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <button\n          id=\"button\"\n          class=\"mdc-button ", "\"\n          ?disabled=\"", "\"\n          aria-label=\"", "\">\n        <div class=\"mdc-button__ripple\"></div>\n        <span class=\"leading-icon\">\n          <slot name=\"icon\">\n            ", "\n          </slot>\n        </span>\n        <span class=\"mdc-button__label\">", "</span>\n        <slot></slot>\n        <span class=\"trailing-icon\">\n          <slot name=\"trailingIcon\">\n            ", "\n          </slot>\n        </span>\n      </button>"]);

    _templateObject_26b1fa50c07b11ea85f79731808de288 = function _templateObject_26b1fa50c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  var ButtonBase =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(ButtonBase, _LitElement);

    function ButtonBase() {
      var _this;

      babelHelpers.classCallCheck(this, ButtonBase);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(ButtonBase).apply(this, arguments));
      _this.raised = false;
      _this.unelevated = false;
      _this.outlined = false;
      _this.dense = false;
      _this.disabled = false;
      _this.trailingIcon = false;
      _this.fullwidth = false;
      _this.icon = '';
      _this.label = '';
      return _this;
    }

    babelHelpers.createClass(ButtonBase, [{
      key: "createRenderRoot",
      value: function createRenderRoot() {
        return this.attachShadow({
          mode: 'open',
          delegatesFocus: true
        });
      }
    }, {
      key: "focus",
      value: function focus() {
        var buttonElement = this.buttonElement;

        if (buttonElement) {
          var ripple = buttonElement.ripple;

          if (ripple) {
            ripple.handleFocus();
          }

          buttonElement.focus();
        }
      }
    }, {
      key: "blur",
      value: function blur() {
        var buttonElement = this.buttonElement;

        if (buttonElement) {
          var ripple = buttonElement.ripple;

          if (ripple) {
            ripple.handleBlur();
          }

          buttonElement.blur();
        }
      }
    }, {
      key: "render",
      value: function render() {
        var classes = {
          'mdc-button--raised': this.raised,
          'mdc-button--unelevated': this.unelevated,
          'mdc-button--outlined': this.outlined,
          'mdc-button--dense': this.dense
        };
        return (0, _litElement.html)(_templateObject_26b1fa50c07b11ea85f79731808de288(), (0, _classMap.classMap)(classes), this.disabled, this.label || this.icon, this.icon && !this.trailingIcon ? this.renderIcon(this.icon) : '', this.label, this.icon && this.trailingIcon ? this.renderIcon(this.icon) : '');
      }
    }, {
      key: "renderIcon",
      value: function renderIcon(icon) {
        return (0, _litElement.html)(_templateObject2_26b1fa50c07b11ea85f79731808de288(), icon);
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated() {
        this.buttonElement.ripple = (0, _rippleDirective.rippleNode)({
          surfaceNode: this.buttonElement,
          unbounded: false
        });
      }
    }]);
    return ButtonBase;
  }(_litElement.LitElement);

  _exports.ButtonBase = ButtonBase;
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: Boolean
  })], ButtonBase.prototype, "raised", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: Boolean
  })], ButtonBase.prototype, "unelevated", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: Boolean
  })], ButtonBase.prototype, "outlined", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: Boolean
  })], ButtonBase.prototype, "dense", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: Boolean,
    reflect: true
  })], ButtonBase.prototype, "disabled", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: Boolean
  })], ButtonBase.prototype, "trailingIcon", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: Boolean,
    reflect: true
  })], ButtonBase.prototype, "fullwidth", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: String
  })], ButtonBase.prototype, "icon", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.property)({
    type: String
  })], ButtonBase.prototype, "label", void 0);
  (0, _tslibEs.__decorate)([(0, _litElement.query)('#button')], ButtonBase.prototype, "buttonElement", void 0);
});