define(["../../../@polymer/polymer/polymer-element.js", "../../../@polymer/polymer/lib/utils/html-tag.js"], function (_polymerElement, _htmlTag) {
  "use strict";

  function _templateObject_46e53bc0c07b11ea85f79731808de288() {
    var data = babelHelpers.taggedTemplateLiteral(["\n    <style>\n      :host {\n        display: block;\n        height: 100%;\n        width: 100%;\n        position: absolute;\n        top: 0;\n        box-sizing: border-box;\n        overflow: auto;\n      }\n\n      :host([passthrough]) {\n        pointer-events: none;\n      }\n    </style>\n\n    <slot></slot>\n"]);

    _templateObject_46e53bc0c07b11ea85f79731808de288 = function _templateObject_46e53bc0c07b11ea85f79731808de288() {
      return data;
    };

    return data;
  }

  /**
   * This Element is used internally by vaadin-grid.
   *
   * @private
   */
  var GridOuterScrollerElement =
  /*#__PURE__*/
  function (_ref) {
    babelHelpers.inherits(GridOuterScrollerElement, _ref);

    function GridOuterScrollerElement() {
      babelHelpers.classCallCheck(this, GridOuterScrollerElement);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(GridOuterScrollerElement).apply(this, arguments));
    }

    babelHelpers.createClass(GridOuterScrollerElement, [{
      key: "ready",
      value: function ready() {
        var _this = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(GridOuterScrollerElement.prototype), "ready", this).call(this);
        this.addEventListener('scroll', function () {
          return _this._syncScrollTarget();
        });
        this.parentElement.addEventListener('mousemove', this._onMouseMove.bind(this)); // for some reason scroll bars are hidden in iOS if this style is
        // added in stylesheets or before attaching.

        this.style.webkitOverflowScrolling = 'touch';
        this.addEventListener('mousedown', function (_) {
          return _this.outerScrolling = true;
        });
        this.addEventListener('mouseup', function (_) {
          _this.outerScrolling = false;

          _this.scrollHandler._scrollHandler();
        });
      }
    }, {
      key: "_onMouseMove",
      value: function _onMouseMove(e) {
        // Ignore mousemove events on touch devices
        if (!this._touchDevice) {
          if (this.noScrollbars && this.parentElement.hasAttribute('scroll-period')) {
            this.passthrough = e.offsetY <= this.clientHeight - 20 && e.offsetX <= this.clientWidth - 20;
          } else {
            this.passthrough = e.offsetY <= this.clientHeight && e.offsetX <= this.clientWidth;
          }
        }
      }
    }, {
      key: "syncOuterScroller",
      value: function syncOuterScroller() {
        this.scrollTop = this.scrollTarget.scrollTop;
        this.scrollLeft = this.scrollTarget.scrollLeft;
      }
    }, {
      key: "_syncScrollTarget",
      value: function _syncScrollTarget() {
        var _this2 = this;

        requestAnimationFrame(function () {
          _this2.scrollTarget.scrollTop = _this2.scrollTop;
          _this2.scrollTarget.scrollLeft = _this2.scrollLeft;

          _this2.scrollHandler._scrollHandler();
        });
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _htmlTag.html)(_templateObject_46e53bc0c07b11ea85f79731808de288());
      }
    }, {
      key: "is",
      get: function get() {
        return 'vaadin-grid-outer-scroller';
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          scrollTarget: {
            type: Object
          },
          scrollHandler: {
            type: Object
          },
          passthrough: {
            type: Boolean,
            reflectToAttribute: true,
            value: true
          },
          outerScrolling: Boolean,
          noScrollbars: Boolean,
          _touchDevice: Boolean
        };
      }
    }]);
    return GridOuterScrollerElement;
  }(
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(_class, _PolymerElement);

    function _class() {
      babelHelpers.classCallCheck(this, _class);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(_class).apply(this, arguments));
    }

    return _class;
  }(_polymerElement.PolymerElement));

  customElements.define(GridOuterScrollerElement.is, GridOuterScrollerElement);
});