define(["exports", "../lit-html.js"], function (_exports, _litHtml) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ifDefined = void 0;

  /**
   * @license
   * Copyright (c) 2018 The Polymer Project Authors. All rights reserved.
   * This code may only be used under the BSD style license found at
   * http://polymer.github.io/LICENSE.txt
   * The complete set of authors may be found at
   * http://polymer.github.io/AUTHORS.txt
   * The complete set of contributors may be found at
   * http://polymer.github.io/CONTRIBUTORS.txt
   * Code distributed by Google as part of the polymer project is also
   * subject to an additional IP rights grant found at
   * http://polymer.github.io/PATENTS.txt
   */

  /**
   * For AttributeParts, sets the attribute if the value is defined and removes
   * the attribute if the value is undefined.
   *
   * For other part types, this directive is a no-op.
   */
  var ifDefined = (0, _litHtml.directive)(function (value) {
    return function (part) {
      if (value === undefined && babelHelpers.instanceof(part, _litHtml.AttributePart)) {
        if (value !== part.value) {
          var name = part.committer.name;
          part.committer.element.removeAttribute(name);
        }
      } else {
        part.setValue(value);
      }
    };
  });
  _exports.ifDefined = ifDefined;
});