define(["exports", "../utils/resizeObservers.js", "./calculateDepthForNode.js", "./calculateBoxSize.js"], function (_exports, _resizeObservers, _calculateDepthForNode, _calculateBoxSize) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.gatherActiveObservationsAtDepth = void 0;

  var gatherActiveObservationsAtDepth = function (depth) {
    _calculateBoxSize.cache.clear();

    _resizeObservers.resizeObservers.forEach(function processObserver(ro) {
      ro.activeTargets.splice(0, ro.activeTargets.length);
      ro.skippedTargets.splice(0, ro.skippedTargets.length);
      ro.observationTargets.forEach(function processTarget(ot) {
        if (ot.isActive()) {
          if ((0, _calculateDepthForNode.calculateDepthForNode)(ot.target) > depth) {
            ro.activeTargets.push(ot);
          } else {
            ro.skippedTargets.push(ot);
          }
        }
      });
    });
  };

  _exports.gatherActiveObservationsAtDepth = gatherActiveObservationsAtDepth;
});