define(["exports", "../algorithms/hasActiveObservations.js", "../algorithms/hasSkippedObservations.js", "../algorithms/deliverResizeLoopError.js", "../algorithms/broadcastActiveObservations.js", "../algorithms/gatherActiveObservationsAtDepth.js"], function (_exports, _hasActiveObservations, _hasSkippedObservations, _deliverResizeLoopError, _broadcastActiveObservations, _gatherActiveObservationsAtDepth) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.process = void 0;

  var process = function () {
    var depth = 0;
    (0, _gatherActiveObservationsAtDepth.gatherActiveObservationsAtDepth)(depth);

    while ((0, _hasActiveObservations.hasActiveObservations)()) {
      depth = (0, _broadcastActiveObservations.broadcastActiveObservations)();
      (0, _gatherActiveObservationsAtDepth.gatherActiveObservationsAtDepth)(depth);
    }

    if ((0, _hasSkippedObservations.hasSkippedObservations)()) {
      (0, _deliverResizeLoopError.deliverResizeLoopError)();
    }

    return depth > 0;
  };

  _exports.process = process;
});