define(["exports", "../../@polymer/polymer/polymer-element.js", "../../@polymer/polymer/lib/utils/render-status.js", "../random-image/random-image.js", "../../@polymer/paper-button/paper-button.js"], function (_exports, _polymerElement, _renderStatus, _randomImage, _paperButton) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnsysRandomimage = void 0;

  /**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */

  /**
   * `lrnsys-randomimage`
   * @element lrnsys-randomimage
   * @demo demo/index.html
   */
  class LrnsysRandomimage extends _polymerElement.PolymerElement {
    static get template() {
      return (0, _polymerElement.html)`
      <style>
        :host {
          display: block;
        }
      </style>
      <div id="list">
        <random-image images-list$="{{images}}"></random-image>
      </div>
      <paper-button raised on-click="reload">Reload</paper-button>
    `;
    }

    static get tag() {
      return "lrnsys-randomimage";
    }

    static get properties() {
      return {
        /**
         * An array of images to pick from at random.
         */
        images: {
          type: Object,
          notify: true,

          value() {
            return [];
          }

        }
      };
    }
    /**
     * trigger a reload of the random-image element
     */


    reload(e) {
      this.shadowRoot.querySelector("#list").innerHTML = this.shadowRoot.querySelector("#list").innerHTML;
    }

  }

  _exports.LrnsysRandomimage = LrnsysRandomimage;
  window.customElements.define(LrnsysRandomimage.tag, LrnsysRandomimage);
});