define(["exports", "../../../lit-element/lit-element.js", "./simple-fields-fieldset.js", "../../a11y-tabs/lib/a11y-tab.js"], function (_exports, _litElement, _simpleFieldsFieldset, _a11yTab) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SimpleFieldsTab = void 0;

  /**
   * `simple-fields-tab` takes in a JSON schema of type array and builds a form,
   * exposing a `value` property that represents an array described by the schema.
   *
   * @group simple-fields
   * @element simple-fields-tab
   * @extends a11y-tab
   * @extends simple-fields-fieldset
   */
  class SimpleFieldsTab extends _a11yTab.A11yTab {
    static get tag() {
      return "simple-fields-tab";
    }

    static get styles() {
      return [...super.styles, ..._simpleFieldsFieldset.SimpleFieldsFieldset.styles];
    }

    static get properties() {
      return { ...super.properties,
        ..._simpleFieldsFieldset.SimpleFieldsFieldset.properties
      };
    }

  }

  _exports.SimpleFieldsTab = SimpleFieldsTab;
  window.customElements.define(SimpleFieldsTab.tag, SimpleFieldsTab);
});