define(["exports"], function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.extend = extend;
  _exports.hop = void 0;

  /*
  Copyright (c) 2014, Yahoo! Inc. All rights reserved.
  Copyrights licensed under the New BSD License.
  See the accompanying LICENSE file for terms.
  */

  /* jslint esnext: true */
  var hop = Object.prototype.hasOwnProperty;
  _exports.hop = hop;

  function extend(obj) {
    var sources = Array.prototype.slice.call(arguments, 1),
        i,
        len,
        source,
        key;

    for (i = 0, len = sources.length; i < len; i += 1) {
      source = sources[i];

      if (!source) {
        continue;
      }

      for (key in source) {
        if (hop.call(source, key)) {
          obj[key] = source[key];
        }
      }
    }

    return obj;
  }
});