import{LitElement as t,html as e,css as o}from"../../../lit-element/lit-element.js";import{A11yCollapse as i}from"../a11y-collapse.js";class A11yCollapseGroup extends t{static get styles(){return[o`
        :host {
          display: block;
          margin: var(--a11y-collapse-group-margin, 15px 0);
          --a11y-collapse-margin: 15px;
        }
        :host([hidden]) {
          display: none;
        }
        #heading {
          font-weight: bold;
        }
        .wrapper {
          border-radius: 0;
          --a11y-collapse-margin: 0 0;
          --a11y-collapse-border-between: none;
        }
      `]}render(){return e`
      <div class="wrapper"><slot></slot></div>
    `}constructor(){super(),this.globalOptions={},this.radio=!1,this.__items=[],this.addEventListener("a11y-collapse-attached",t=>{t.stopPropagation(),t.stopImmediatePropagation(),this._attachItem(t.detail),t.stopPropagation(),t.stopImmediatePropagation()}),this.addEventListener("a11y-collapse-detached",t=>{t.stopPropagation(),t.stopImmediatePropagation(),this._detachItem(t.detail),t.stopPropagation(),t.stopImmediatePropagation()}),this.addEventListener("a11y-collapse-click",t=>{t.stopPropagation(),t.stopImmediatePropagation(),this.radioToggle(t.detail),t.stopPropagation(),t.stopImmediatePropagation()})}static get tag(){return"a11y-collapse-group"}static get properties(){return{...super.properties,...i.properties,globalOptions:{type:Object,attribute:"global-options",reflect:!0},radio:{type:Boolean,attribute:"radio"},__items:{type:Array}}}static get haxProperties(){return{canScale:!1,canPosition:!0,canEditSource:!1,gizmo:{title:"Expand Collapse Group",description:"A group of expand collapse elements.",icon:"view-day",color:"grey",groups:["Content","Presentation","Collapse"]},settings:{quick:[{property:"radio",title:"Expand only one",description:"Only one item can be expanded.",inputMethod:"boolean"},{property:"disabled",title:"Disabled",description:"Disable items.",inputMethod:"boolean"}],configure:[{property:"radio",title:"Expand only one",description:"Only one item can be expanded.",inputMethod:"boolean"},{property:"disabled",title:"Disabled",description:"Disable items.",inputMethod:"boolean"},{slot:"",title:"Collapse Items",description:"The collapse items.",inputMethod:"code-editor"}],advanced:[{property:"hidden",title:"Hidden",inputMethod:"boolean"}]}}}get items(){return this.__items}_attachItem(t){this.__items.push(t),Object.keys(A11yCollapseGroup.properties||{}).forEach(e=>this._updateItem(t,e))}updated(t){t.forEach((t,e)=>{this.__items.forEach(o=>this._updateItem(o,e,t))})}_updateItem(t,e,o){if("globalOptions"===e||"__items"===e){if(this.globalOptions!=={})for(let e in this.globalOptions)this.globalOptions.hasOwnProperty(e)&&(t[e]=this.globalOptions[e])}else"radio"===e&&this.radio?t.expanded=!1:null===this[e]&&void 0===this[e]||(t[e]=this[e])}_detachItem(t){if(this.__items&&t)for(let e=0;e<this.__items.length;e++)this.__items[e]===t&&this.__items.splice(e,1)}radioToggle(t){if(this.radio&&t.expanded)for(let e=0;e<this.__items.length;e++)this.__items[e]!==t&&this.__items[e].toggle(!1)}disconnectedCallback(){this.removeEventListener("a11y-collapse-click",t=>{t.stopPropagation(),this.radioToggle(t.detail)}),this.removeEventListener("a11y-collapse-attached",t=>{t.stopPropagation(),this.push("__items",t.detail)}),this.removeEventListener("a11y-collapse-detached",t=>{t.stopPropagation(),this._detachItem(t.detail)}),super.disconnectedCallback()}}window.customElements.define(A11yCollapseGroup.tag,A11yCollapseGroup);export{A11yCollapseGroup};