/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as o}from"../../lit-element/lit-element.js";import{SimpleColors as a}from"../simple-colors/simple-colors.js";class AccentCard extends a{static get tag(){return"accent-card"}static get styles(){return[...super.styles,o`
        :host {
          display: block;
          border-radius: 2px;
          margin: 0 0 15px;
          box-shadow: var(
            --accent-card-box-shadow,
            0 2px 2px 0 rgba(0, 0, 0, 0.14),
            0 1px 5px 0 rgba(0, 0, 0, 0.12),
            0 3px 1px -2px rgba(0, 0, 0, 0.2)
          );
          color: var(
            --accent-card-color,
            var(--simple-colors-default-theme-grey-9, #222)
          );
          background-color: var(
            --accent-card-background-color,
            var(--simple-colors-default-theme-grey-1, #fff)
          );
          --accent-card-image-width: 30%;
          --accent-card-image-height: 10%;
          --accent-card-border-color: var(
            --simple-colors-default-theme-accent-6,
            #ddd
          );
          --accent-card-heading-color: var(
            --simple-colors-default-theme-accent-7,
            #000
          );
          --accent-card-footer-border-color: var(
            --simple-colors-default-theme-grey-3,
            #ddd
          );
        }
        :host([dark]) {
          color: var(
            --accent-card-color,
            var(--simple-colors-default-theme-grey-12, #fff)
          );
          --accent-card-border-color: var(
            --simple-colors-default-theme-accent-7,
            #fff
          );
          --accent-card-footer-border-color: var(
            --simple-colors-default-theme-grey-6,
            #666
          );
        }
        :host([accent-background]) {
          background-color: var(
            --accent-card-background-color,
            var(--simple-colors-default-theme-accent-1, #fff)
          );
          --accent-card-footer-border-color: var(--accent-card-border-color);
        }
        article {
          width: 100%;
          box-sizing: border-box;
        }
        :host([horizontal]) article {
          display: flex;
          justify-content: space-between;
          align-items: stretch;
        }
        :host([flat]) {
          box-shadow: none;
        }
        :host([flat]:not([accent-background])) {
          border: 1px solid var(--accent-card-footer-border-color);
        }
        :host(:not([horizontal]):not([no-border])) article {
          border-top: 4px solid var(--accent-card-border-color);
        }
        :host([horizontal]:not([no-border])) article {
          border-left: 4px solid var(--accent-card-border-color);
        }
        .image-outer {
          box-sizing: border-box;
          position: relative;
          overflow: visible;
        }
        :host([horizontal]) .image-outer {
          height: auto;
          width: var(--accent-card-image-width);
        }
        :host(:not([horizontal])) .image-outer {
          height: auto;
          width: 100%;
        }
        .image {
          height: 100%;
          width: 100%;
          background-size: cover;
          background-position-x: var(--accent-card-image-x, center);
          background-position-y: var(--accent-card-image-y, center);
        }
        :host([image-align="left"]) .image {
          background-position-x: left;
        }
        :host([image-align="center"]) .image {
          background-position-x: center;
        }
        :host([image-align="right"]) .image {
          background-position-x: right;
        }
        :host([image-valign="top"]) .image {
          background-position-y: top;
        }
        :host([image-valign="center"]) .image {
          background-position-y: center;
        }
        :host([image-valign="bottom"]) .image {
          background-position-y: bottom;
        }
        :host(:not([horizontal])) .image {
          height: 0;
          padding-top: var(--accent-card-image-height);
        }
        .body {
          flex-grow: 1;
          overflow: visible;
        }
        #heading {
          flex: 0 0 auto;
          display: flex;
          justify-content: space-between;
          align-items: var(--accent-card-heading-align, unset);
          padding-top: var(
            --accent-card-heading-padding-top,
            var(--accent-card-padding, 20px)
          );
          padding-left: var(
            --accent-card-heading-padding-left,
            var(--accent-card-padding, 20px)
          );
          padding-right: var(
            --accent-card-heading-padding-right,
            var(--accent-card-padding, 20px)
          );
          padding-bottom: var(--accent-card-heading-padding-bottom, 0px);
          margin: 0;
        }
        #heading h1 {
          margin: 0;
          flex: 1 1 auto;
        }
        #heading div {
          flex: 0 0 auto;
        }
        :host([accent-heading][accent-color]) #heading h1 {
          color: var(--accent-card-heading-color);
        }
        #subheading {
          flex: 0 0 auto;
          font-size: 90%;
          font-style: italic;
          padding-top: var(--accent-card-subheading-padding-top, unset);
          padding-left: var(
            --accent-card-subheading-padding-left,
            var(--accent-card-padding, 20px)
          );
          padding-right: var(
            --accent-card-subheading-padding-right,
            var(--accent-card-padding, 20px)
          );
          padding-bottom: var(--accent-card-subheading-padding-bottom, unset);
        }
        #content {
          font-size: 100%;
          padding-top: var(
            --accent-card-content-padding-top,
            var(--accent-card-padding, 20px)
          );
          padding-left: var(
            --accent-card-content-padding-left,
            var(--accent-card-padding, 20px)
          );
          padding-right: var(
            --accent-card-content-padding-right,
            var(--accent-card-padding, 20px)
          );
          padding-bottom: var(
            --accent-card-content-padding-bottom,
            var(--accent-card-padding, 20px)
          );
          flex: 1 1 auto;
        }
        #footer {
          flex: 0 0 auto;
          border-top: 1px solid var(--accent-card-footer-border-color);
          padding-top: var(--accent-card-footer-padding-top, unset);
          padding-left: var(
            --accent-card-footer-padding-left,
            var(--accent-card-padding, 20px)
          );
          padding-right: var(
            --accent-card-footer-padding-right,
            var(--accent-card-padding, 20px)
          );
          padding-bottom: var(--accent-card-footer-padding-bottom, unset);
        }
      `]}render(){return e`
      <article id="card">
        <div class="image-outer" ?hidden="${!this.imageSrc}">
          <div
            class="image"
            .style="${this.imageSrc?`background-image: url(${this.imageSrc});`:"display: none;"}"
          ></div>
        </div>
        <div class="body">
          <div id="heading">
            <h1><slot name="heading"></slot></h1>
            <div><slot name="corner"></slot></div>
          </div>
          <div id="subheading"><slot name="subheading"></slot></div>
          <div id="content"><slot name="content"></slot></div>
          <div id="footer"><slot name="footer"></slot></div>
        </div>
      </article>
    `}static get haxProperties(){return{canEditSource:!1,canPosition:!1,canEditSource:!1,gizmo:{title:"Accent Card",description:"A card with optional accent styling.",icon:"chrome-reader-mode",color:"light-blue",groups:["Media","Content","Image","Presentation"],handles:[{type:"media",url:"source"},{type:"image",source:"imageSrc"},{type:"text",url:"source"}],meta:{author:"nikkimk",owner:"The Pennsylvania State University"}},settings:{quick:[{property:"accentColor",title:"Accent Color",description:"An optional accent color.",inputMethod:"colorpicker",icon:"editor:format-color-fill"},{property:"dark",title:"Dark Theme",description:"Enable Dark Theme",inputMethod:"boolean",icon:"icons:invert-colors"},{property:"horizontal",title:"Horizontal",description:"Horizontal orientation?",inputMethod:"boolean"}],configure:[{slot:"heading",title:"Heading",description:"A heading for card.",inputMethod:"textfield"},{slot:"subheading",title:"Subheading",description:"An optional subheading for card.",inputMethod:"textfield"},{slot:"content",title:"Content",description:"Content for card.",inputMethod:"textfield"},{slot:"footer",title:"Footer",description:"An optional footer for card.",inputMethod:"textfield"},{property:"imageSrc",title:"Image",description:"Optional image",inputMethod:"haxupload",icon:"editor:insert-photo"},{property:"imageAlign",title:"imageAlign",description:"Image Horizontal Alignment",inputMethod:"select",options:{left:"left",center:"center",right:"right"}},{property:"imageValign",title:"imageValign",description:"Image Vertical Alignment",inputMethod:"select",options:{top:"top",center:"center",bottom:"bottom"}},{property:"accentColor",title:"Accent Color",description:"An optional accent color.",inputMethod:"colorpicker",icon:"editor:format-color-fill"},{property:"dark",title:"Dark Theme",description:"Enable Dark Theme",inputMethod:"boolean",icon:"icons:invert-colors"},{property:"horizontal",title:"Horizontal",description:"Horizontal orientation?",inputMethod:"boolean"},{property:"accentHeading",title:"Heading Accent",description:"Apply accent color to heading?",inputMethod:"boolean"},{property:"accentBackground",title:"Background Accent",description:"Apply accent color to card background?",inputMethod:"boolean"},{property:"noBorder",title:"No Border Accent",description:"Remove border accent?",inputMethod:"boolean"},{property:"flat",title:"Flat",description:"Remove box shadow?",inputMethod:"boolean"}],advanced:[]},demoSchema:[{tag:"accent-card",properties:{style:"maxWidth:600px;width:100%;",accentColor:"cyan",dark:!0,imageSrc:"http://placekitten.com/200/600"},content:'<h1 slot="heading">Card Heading</h1>\n<p slot="content">This is the body of the card.</p>'}],saveOptions:{unsetAttributes:["colors"]}}}constructor(){super(),this.accentBackground=!1,this.accentHeading=!1,this.flat=!1,this.horizontal=!1,this.imageAlign=null,this.imageSrc=null,this.imageValign=null,this.noBorder=!1}static get properties(){return{...super.properties,accentBackground:{type:Boolean,attribute:"accent-background",reflect:!0},accentHeading:{type:Boolean,attribute:"accent-heading",reflect:!0},flat:{type:Boolean,reflect:!0},horizontal:{type:Boolean,reflect:!0},imageAlign:{type:String,attribute:"image-align",reflect:!0},imageSrc:{type:String,attribute:"image-src"},imageValign:{type:String,attribute:"image-valign",reflect:!0},noBorder:{type:Boolean,attribute:"no-border",reflect:!0}}}}window.customElements.define(AccentCard.tag,AccentCard);export{AccentCard};