/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html as t,css as e}from"../../lit-element/lit-element.js";import{SimpleColors as o}from"../simple-colors/simple-colors.js";class CsvRender extends o{static get styles(){return[e`
        :host {
          display: block;
        }
        .table {
          width: 100%;
          border: 1px solid var(--simple-colors-default-theme-accent-6);
          border-collapse: collapse;
          white-space: nowrap;
          font-size: 16px;
          background-color: var(--simple-colors-default-theme-grey-1);
        }
        .table thead {
          padding-bottom: 0.16px;
          position: sticky;
        }
        .table caption {
          background-color: var(--simple-colors-default-theme-accent-1);
          font-weight: bold;
          padding: 8px;
          border: 1px solid var(--simple-colors-default-theme-accent-6);
          border-bottom: none;
        }
        :host(:not([accent-color])) .table caption,
        :host([accent-color="grey"]) .table caption {
          background-color: var(--simple-colors-default-theme-accent-2);
        }
        .table tbody tr {
          position: relative;
          height: 48px;
          -webkit-transition-duration: 0.28s;
          transition-duration: 0.28s;
          -webkit-transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1);
          transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1);
          -webkit-transition-property: background-color;
          transition-property: background-color;
        }
        .table tbody tr:hover {
          background-color: var(--simple-colors-default-theme-accent-1);
        }
        :host(:not([accent-color])) .table tbody tr:hover,
        :host([accent-color="grey"]) .table tbody tr:hover {
          background-color: var(--simple-colors-default-theme-accent-2);
        }
        .table td,
        .table thead th,
        .table th {
          padding: 0 1.125em;
          text-align: left;
        }
        .table td {
          border-top: 1px solid var(--simple-colors-default-theme-accent-6);
          border-bottom: 1px solid var(--simple-colors-default-theme-accent-6);
        }
        .table th {
          position: relative;
          vertical-align: bottom;
          text-overflow: ellipsis;
          font-size: 16px;
          font-weight: bold;
          line-height: 24px;
          letter-spacing: 0;
          color: rgba(0, 0, 0, 0.54);
          height: 48px;
          padding-bottom: 8px;
          box-sizing: border-box;
        }
        #loading {
          position: absolute;
        }
        #download paper-button {
          color: var(--simple-colors-default-theme-accent-6);
          border-radius: 36px;
          width: 36px;
          height: 36px;
          min-width: unset;
          padding: 0;
          margin: 0;
          display: inline-flex;
        }
        iron-icon {
          display: inline-flex;
          margin: 0;
          padding: 0;
        }
        #download paper-button:hover,
        #download paper-button:focus,
        #download paper-button:active {
          color: var(--simple-colors-default-theme-accent-8);
          outline: 2px solid var(--simple-colors-default-theme-accent-6);
        }
      `]}constructor(){super(),this.table=[],this.tableHeadings=[],this.tableData="",import("../hexagon-loader/hexagon-loader.js"),import("../../@polymer/iron-ajax/iron-ajax.js"),import("../../@polymer/iron-icons/iron-icons.js"),import("../../@polymer/iron-icon/iron-icon.js"),import("../../@polymer/paper-button/paper-button.js"),import("../simple-tooltip/simple-tooltip.js")}updated(t){t.forEach((t,e)=>{"color"==e&&this._getAccentColor(this[e],t)})}render(){return t`
      <iron-ajax
        auto
        url="${this.dataSource}"
        handle-as="text"
        debounce-duration="500"
        @last-response-changed="${this.tableDataChanged}"
        @response="${this.handleResponse}"
      ></iron-ajax>
      <hexagon-loader
        id="loading"
        accent-color="${this.accentColor}"
        loading
        item-count="4"
        size="small"
      ></hexagon-loader>
      <a href="${this.dataSource}" id="download" tabindex="-1">
        <paper-button
          ><iron-icon icon="file-download"></iron-icon
        ></paper-button>
      </a>
      <simple-tooltip for="download" animation-delay="200" offset="14"
        >Download table data</simple-tooltip
      >
      <table class="table" summary="${this.summary}">
        ${this.caption?t`
              <caption>
                ${this.caption}
              </caption>
            `:""}
        <thead>
          <tr>
            ${this.tableHeadings.map(e=>t`
                  <th scope="col">${e}</th>
                `)}
          </tr>
        </thead>
        <tbody>
          ${this.table.map(e=>t`
              <tr>
                ${e.map(e=>t`
                    <td>${e}</td>
                  `)}
              </tr>
            `)}
        </tbody>
      </table>
    `}static get tag(){return"csv-render"}tableDataChanged(t){this.tableData=t.detail.value}static get properties(){return{dataSource:{type:String,attribute:"data-source"},caption:{type:String},summary:{type:String},table:{type:Array},tableHeadings:{type:Array},tableData:{type:String,attribute:"table-data"},color:{type:String}}}handleResponse(t){this.table=this.CSVtoArray(this.tableData),this.tableHeadings=this.table.shift(),this.shadowRoot.querySelector("#loading").loading=!1}CSVtoArray(t){let e,o="",a=[""],r=[a],i=0,l=0,n=!0;for(e in t)e=t[e],'"'===e?(n&&e===o&&(a[i]+=e),n=!n):","===e&&n?e=a[++i]="":"\n"===e&&n?("\r"===o&&(a[i]=a[i].slice(0,-1)),a=r[++l]=[e=""],i=0):a[i]+=e,o=e;return r}_getAccentColor(t){t=t.replace("-text",""),this.accentColor&&"grey"!==this.accentColor||!this.colors[t]||(this.accentColor=t)}}window.customElements.define(CsvRender.tag,CsvRender);export{CsvRender};