/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html as e,PolymerElement as t}from"../../../@polymer/polymer/polymer-element.js";import"../../../@polymer/iron-autogrow-textarea/iron-autogrow-textarea.js";import"../../../@polymer/iron-a11y-keys/iron-a11y-keys.js";import{cellBehaviors as o}from"./editable-table-behaviors.js";class EditableTableEditorCell extends(o(t)){static get template(){return e`
      <style is="custom-style">
        :host {
          padding: 0;
          margin: 0;
          width: calc(
            100% - var(--editable-table-row-horizontal-padding) -
              var(--editable-table-row-horizontal-padding)
          );
          min-width: unset;
          display: inline-flex;
          justify-content: space-between;
          align-items: center;
          align-content: stretch;
        }
        :host iron-autogrow-textarea {
          width: 100%;
          padding: 0;
          border: none;
          font-weight: unset;
          resize: none;
          -webkit-appearance: none;
          -mozilla-appearance: none;
          flex-grow: 1;
          --iron-autogrow-textarea: {
            padding: 0;
            font-weight: unset;
            border: none;
            resize: none;
            flex-direction: column;
            -webkit-flex-direction: column;
            -webkit-appearance: none;
            -mozilla-appearance: none;
          }
        }
        :host iron-autogrow-textarea > * {
          padding: 0;
          font-weight: unset;
          border: none;
          resize: none;
          flex-direction: column;
          -webkit-flex-direction: column;
          -webkit-appearance: none;
          -mozilla-appearance: none;
        }
      </style>
      <iron-autogrow-textarea
        autofocus
        id="cell"
        label$="[[label]]"
        on-value-changed="_onValueChanged"
        value$="{{value}}"
      >
      </iron-autogrow-textarea>
      <div id="icons"><slot></slot></div>
    `}static get tag(){return"editable-table-editor-cell"}static get properties(){return{row:{type:Number,value:null},column:{type:Number,value:null},label:{type:String,computed:"_getCellLabel(column,row)"},value:{type:String,value:!1}}}ready(){super.ready(),this.cell=this.shadowRoot.querySelector("#cell")}focus(){this.cell.textarea.focus()}_getCellLabel(e,t){return this._getLabel(e,!1)+this._getLabel(t,!0)+"(editable table cell)"}_onValueChanged(e){this.dispatchEvent(new CustomEvent("change",{bubbles:!0,cancelable:!0,composed:!0,detail:{row:this.row,column:this.column,value:e.detail.value}}))}getCaretPosition(){var e=0;if(document.selection){this.shadowRoot.querySelector("#cell").focus();var t=document.selection.createRange();t.moveStart("character",-this.shadowRoot.querySelector("#cell").value.length),e=t.text.length}else(this.shadowRoot.querySelector("#cell").shadowRoot.querySelector("textarea").selectionStart||"0"==this.shadowRoot.querySelector("#cell").shadowRoot.querySelector("textarea").selectionStart)&&(e=this.shadowRoot.querySelector("#cell").shadowRoot.querySelector("textarea").selectionStart);return e}setCaretPosition(e,t){let o=this.shadowRoot.querySelector("#cell").shadowRoot.querySelector("textarea");if(o.focus(),o.createTextRange){let l=o.createTextRange();l.collapse(!0),l.moveEnd("character",t),l.moveStart("character",e),l.select()}else o.setSelectionRange&&(o.setSelectionRange(e,t),o.selectionStart=e,o.selectionEnd=t)}setFocus(e,t){this.shadowRoot.querySelector("#cell").shadowRoot.querySelector("textarea").focus(),void 0!==e&&void 0!==t?this.setCaretPosition(e,this.getCaretPosition()-t):void 0!==e&&e>-1?this.setCaretPosition(e,e):-1==e&&void 0!==t?this.setCaretPosition(e,this.getCaretPosition()-t):this.setCaretPosition(0,0)}_onCellLeft(){this.dispatchEvent(new CustomEvent("cell-move",{bubbles:!0,cancelable:!0,composed:!0,detail:{cell:this.parentNode,direction:"left"}}))}_onCellRight(){this.dispatchEvent(new CustomEvent("cell-move",{bubbles:!0,cancelable:!0,composed:!0,detail:{cell:this.parentNode,direction:"right"}}))}_onCellAbove(){this.dispatchEvent(new CustomEvent("cell-move",{bubbles:!0,cancelable:!0,composed:!0,detail:{cell:this.parentNode,direction:"up"}}))}_onCellBelow(){this.dispatchEvent(new CustomEvent("cell-move",{bubbles:!0,cancelable:!0,composed:!0,detail:{cell:this.parentNode,direction:"down"}}))}}window.customElements.define(EditableTableEditorCell.tag,EditableTableEditorCell);export{EditableTableEditorCell};