/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as s}from"../../../../../lit-element/lit-element.js";import"../../../../simple-fields/lib/simple-fields-field.js";import"../../../../../@polymer/iron-icons/iron-icons.js";import"../../../../../@polymer/iron-icon/iron-icon.js";class SiteSearch extends e{static get styles(){return[s`
        :host {
          display: block;
          font-size: 16px;
          color: var(--site-search-color, #383f45);
          height: 55vh;
          width: 60vh;
        }
        [hidden] {
          display: none;
        }
        .result {
          display: block;
          background-color: var(--site-search-result-background-color, #eeeeee);
          color: var(--site-search-result-color, #222222);
          margin-bottom: 1.5rem;
          padding-bottom: 0.5rem;
        }
        .result:hover,
        .result:focus {
          background-color: var(
            --site-search-result-background-color-hover,
            #dddddd
          );
          color: var(--site-search-link-color-hover, #000000);
          text-decoration: none;
          outline: 2px solid grey;
          outline-offset: 4px;
        }
        .result .title {
          font-size: 28px;
          margin: 0 0 8px 0;
          line-height: 1;
        }
        .result {
          color: var(--site-search-link-color, #444444);
          text-decoration: none;
        }
        simple-datetime {
          color: var(--site-search-link-color, #444444);
        }
        .result .link-text {
          font-size: 12px;
          color: var(--site-search-link-text-color, #999999);
          font-style: italic;
          padding-left: 8px;
        }
        .results-found-text {
          margin-bottom: 1.5rem;
          padding-bottom: 0.5rem;
        }
        #search {
          flex-grow: 2;
          margin-right: 4px;
          --simple-fields-accent-color: var(--site-search-text-color, #000);
          color: var(--site-search-placeholder-color, #222);
        }
      `]}static get tag(){return"site-search"}constructor(){super(),this.hideInput=!1,this.search="",this.showPath=!1,this.showDate=!1,this.__results=[],setTimeout(()=>{import("../../../../lunr-search/lunr-search.js"),import("../../../../simple-datetime/simple-datetime.js")},0)}render(){return t`
      <simple-fields-field
        ?hidden="${this.hideInput}"
        id="search"
        always-float-label
        label="Search"
        type="text"
        @value-changed="${this._searchValueChanged}"
      >
        <iron-icon icon="search" slot="prefix"></iron-icon>
      </simple-fields-field>
      ${this.search.length>0?t`
            <h1 class="results-found-text">
              Found ${this.__results.length} results.
            </h1>
          `:t``}
      <lunr-search id="lunr"></lunr-search>

      ${this.__results.map(e=>t`
          <a
            class="result"
            .href="${e.location}"
            @click="${this.selectionMade}"
          >
            <div class="title">
              ${e.title}<span
                ?hidden="${!this.showPath}"
                class="link-text"
                aria-hidden="true"
                >(${e.location})</span
              >
            </div>
            <div class="date" ?hidden="${!this.showDate}">
              <simple-datetime format="M jS" .timestamp="${e.created}" unix
                >${e.created}</simple-datetime
              >
            </div>
            <p>${e.description}..</p>
          </a>
        `)}
    `}selectionMade(e){this.dispatchEvent(new CustomEvent("search-item-selected",{detail:{value:e.detail}}))}_searchValueChanged(e){this.search=e.detail.value}__resultsChanged(e){e.detail.value?this.__results=[...e.detail.value]:this.__results=[]}static get properties(){return{dataSource:{type:String,attribute:"data-source"},showDate:{type:Boolean,attribute:"show-date"},showPath:{type:Boolean,attribute:"show-path"},hideInput:{type:Boolean,attribute:"hide-input"},search:{type:String},__results:{type:Array}}}firstUpdated(e){this.shadowRoot.querySelector("#lunr").addEventListener("results-changed",this.__resultsChanged.bind(this))}updated(e){e.forEach((e,t)=>{"search"==t&&(this._searchChanged(this[t],e),this.shadowRoot.querySelector("#lunr").search=this[t]),"dataSource"==t&&this[t]&&(this.shadowRoot.querySelector("#lunr").dataSource=this[t])})}_searchChanged(e,t){e.length>=3&&void 0===this.dataSource&&(this.dataSource="lunrSearchIndex.json")}}window.customElements.define(SiteSearch.tag,SiteSearch);export{SiteSearch};