/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as a}from"../../lit-element/lit-element.js";import{SimpleColors as r}from"../simple-colors/simple-colors.js";import"../paper-avatar/paper-avatar.js";class LrndesignAvatar extends r{static get styles(){return[...super.styles,a`
        :host {
          display: block;
          border-radius: 50%;
        }

        :host([hidden]) {
          display: none;
        }

        paper-avatar {
          --paper-avatar-width: var(--lrndesign-avatar-width, 40px);
          --paper-avatar-color: var(
            --simple-colors-default-theme-accent-8,
            #444
          );
          --paper-avatar-text-color: var(
            --simple-colors-default-theme-grey-1,
            #fff
          );
        }
      `]}render(){return e`
      <paper-avatar
        .label="${this.label||""}"
        .icon="${this.icon||""}"
        .src="${this.src||""}"
        ?two-chars="${this.twoChars}"
        ?jdenticon="${this.jdenticon}"
      ></paper-avatar>
    `}static get haxProperties(){return{canScale:!1,canPosition:!1,canEditSource:!1,gizmo:{title:"Avatar",description:"Visualize a user account either with an image, icon, initials, or as abstract art.",icon:"image:collections",color:"yellow",groups:["Media","Image"],handles:[{type:"image",source:"image"}],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"accentColor",title:"Accent Color",description:"Pick an accent color.",inputMethod:"colorpicker"},{property:"dark",title:"Dark",description:"Use dark text (and light background) for avatar.",inputMethod:"boolean"},{property:"icon",title:"Icon",description:"Optional: Pick an icon for avatar.",inputMethod:"iconpicker"},{property:"src",title:"Image Source",description:"Optional: Upload an image for avatar.",inputMethod:"haxupload"}],configure:[{property:"accentColor",title:"Accent Color",description:"Pick an accent color.",inputMethod:"colorpicker"},{property:"dark",title:"Dark",description:"Use dark text (and light background) for avatar.",inputMethod:"boolean"},{property:"icon",title:"Icon",description:"Optional: Pick an icon for avatar.",inputMethod:"iconpicker"},{property:"src",title:"Image Source",description:"Optional: Upload an image for avatar.",inputMethod:"haxupload"},{property:"label",title:"Two-character initials",description:"Label used to create initials or unique Jdenticon.",inputMethod:"textfield"},{property:"twoChars",title:"Two-character initials",description:"When no Jdenticon, image, or icon, use two-character for initials.",inputMethod:"boolean"},{property:"jdenticon",title:"Jdenticon",description:"Optional: Unique icon design based on label.",inputMethod:"boolean"}],advanced:[]}}}static get properties(){return{...super.properties,icon:{type:String},label:{type:String},src:{type:String},twoChars:{type:Boolean,attribute:"two-chars"},color:{type:String},jdenticon:{type:Boolean}}}static get tag(){return"lrndesign-avatar"}constructor(){super(),this.tag=LrndesignAvatar.tag,import("../paper-avatar/paper-avatar.js"),this.dark=!1,this.twoChars=!1,this.jdenticon=!1,this.label="|"}connectedCallback(){super.connectedCallback()}_getAccentColor(t){t=t.replace("-text",""),!this.colors[t]||this.accentColor&&"grey"!==this.accentColor||(this.accentColor=this.color)}updated(t){super.updated&&super.updated(t),t.forEach((t,e)=>{"color"==e&&this._getAccentColor(this[e])})}}customElements.define("lrndesign-avatar",LrndesignAvatar);export{LrndesignAvatar};