/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as i,css as r}from"../../../lit-element/lit-element.js";import{LrndesignGalleryBehaviors as s}from"./lrndesign-gallery-behaviors.js";import"./lrndesign-gallery-zoom.js";import"./lrndesign-gallery-details.js";class LrndesignGalleryGrid extends s{static get tag(){return"lrndesign-gallery-grid"}static get styles(){return[...super.styles,r`
        :host {
          margin: 15px 0;
          padding: 0;
          max-width: 100%;
          display: block;
        }
        #galleryscreen {
          display: grid;
          grid-gap: 7.5px;
          grid-template-columns: repeat(2, 1fr);
        }
        :host([responsive-size="sm"]) #galleryscreen {
          grid-template-columns: repeat(3, 1fr);
        }
        :host([responsive-size="md"]) #galleryscreen {
          grid-template-columns: repeat(4, 1fr);
        }
        :host([responsive-size="lg"]) #galleryscreen {
          grid-template-columns: repeat(5, 1fr);
        }
        :host([responsive-size="xl"]) #galleryscreen {
          grid-template-columns: repeat(6, 1fr);
        }
        lrndesign-gallery-zoom {
          position: relative;
          width: 100%;
        }
        lrndesign-gallery-zoom img {
          width: 100%;
          transition: outline 0.25s ease-in-out;
          outline: 1px solid var(--lrndesign-gallery-color);
        }
        lrndesign-gallery-zoom:hover img,
        lrndesign-gallery-zoom:focus img,
        lrndesign-gallery-zoom:focus-within img {
          transition: outline 0.25s ease-in-out;
          outline: 2px solid var(--lrndesign-gallery-focus-color);
        }
        .zoombg,
        .zoomicon {
          top: unset;
          bottom: 5px;
          left: 5px;
        }
      `]}static get properties(){return{...super.properties}}constructor(){super();let e=this.shadowRoot.querySelector("#carouselitem");this.selected.scroll&&e&&(this._scrollIntoView([this._getParentOffset(e)]),this.selected.zoomed||e.focus())}render(){return i`
      <div id="grid">
        <p class="sr-only">A list of columns buttons items:</p>
        <div id="galleryscreen">
          ${this.sources.map(e=>i`
              <lrndesign-gallery-zoom
                .id="${e.id}"
                .details="${e.details}"
                .heading="${e.heading}"
                .src="${e.large}"
                .tooltip="${e.tooltip}"
                .zoom-alt="${e.zoomAlt}"
              >
                <img
                  .alt="${e.alt}"
                  fade
                  sizing="${this.selected.sizing||"cover"===this.sizing||"contain"}"
                  .src="${e.src}"
                />
                <div class="zoombg"></div>
                <iron-icon icon="zoom-in" class="zoomicon"></iron-icon>
              </lrndesign-gallery-zoom>
            `)}
        </div>
      </div>
    `}}window.customElements.define(LrndesignGalleryGrid.tag,LrndesignGalleryGrid);export{LrndesignGalleryGrid};