/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as o,html as t,css as e}from"../../../lit-element/lit-element.js";import"../../simple-modal/lib/simple-modal-template.js";import"../../img-pan-zoom/img-pan-zoom.js";import"../../simple-tooltip/simple-tooltip.js";import"./lrndesign-gallery-details.js";class LrndesignGalleryZoom extends o{static get tag(){return"lrndesign-gallery-zoom"}static get styles(){return[e`
        :host {
          display: block;
          background-color: none;
        }
        :host([hidden]) {
          display: none;
        }
        #zoombtn {
          display: block;
          width: 100%;
          padding: 0;
          margin: 0;
          border-width: 0;
          background-color: transparent;
        }
        simple-modal-template[modal-id="zoomdialog"] {
          --simple-modal-width: 75vw;
          --simple-modal-height: 75vh;
          --simple-modal-titlebar-color: var(
            --lrndesign-gallery-dialog-titlebar-color
          );
          --simple-modal-titlebar-background: var(
            --lrndesign-gallery-dialog-titlebar-background-color
          );
          --simple-modal-header-color: var(
            --lrndesign-gallery-dialog-header-color
          );
          --simple-modal-header-background: var(
            --lrndesign-gallery-dialog-header-background-color
          );
          --simple-modal-content-container-color: var(
            --lrndesign-gallery-dialog-color
          );
          --simple-modal-content-container-background: var(
            --lrndesign-gallery-dialog-background-color
          );
        }
      `]}render(){return t`
      <button id="zoombtn" @click="${this.zoom}" aria-label="${this.tooltip}">
        <slot></slot>
      </button>
      <simple-tooltip for="zoombtn" position="right" controls="zoomtpl"
        >${this.tooltip}</simple-tooltip
      >
      <simple-modal-template id="zoomtpl" title="${this.heading}">
        <lrndesign-gallery-details
          id="details"
          slot="header"
          ?hidden="${!this.details||""===this.details}"
          details="${this.details||""}"
        >
        </lrndesign-gallery-details>

        <div slot="content" ?hidden="${!this.src||""===this.src}">
          <img-pan-zoom
            alt="${this.zoomAlt}"
            src="${this.src}"
            max-zoom-pixel-ratio="1.5"
            min-zoom-image-ratio="0.5"
            zoom-per-click="1.2"
            zoom-per-scroll="0.6"
          >
          </img-pan-zoom>
          <div>
            Swipe, use a mouse or use the +/- and arrow keys to zoom and pan the
            image above.
          </div>
        </div>
      </simple-modal-template>
    `}static get properties(){return{heading:{type:String},details:{type:String},src:{type:String,reflect:!0,attribute:"src"},tooltip:{type:String},zoomAlt:{type:String,attribute:"zoom-alt"}}}constructor(){super(),this.heading="Image Zoom",this.details="",this.src="",this.tooltip="Zoom In",this.zoomAlt="Full-sized Image"}get button(){return!(!this.shadowRoot||!this.shadowRoot.querySelector("#zoombtn"))&&this.shadowRoot.querySelector("#zoombtn")}get modal(){return!(!this.shadowRoot||!this.shadowRoot.querySelector("#zoomtpl"))&&this.shadowRoot.querySelector("#zoomtpl")}zoom(){if(this.button&&this.modal){this.modal.openModal(this.button);let o=new CustomEvent("gallery-zoom",{detail:this});this.button.dispatchEvent(o)}}}window.customElements.define(LrndesignGalleryZoom.tag,LrndesignGalleryZoom);export{LrndesignGalleryZoom};