/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as i}from"../../lit-element/lit-element.js";class PageContentsMenu extends e{static get styles(){return[i`
        :host {
          display: block;
        }
        :host([is-empty][hide-if-empty]) {
          display: none;
        }
        :host([hidden]) {
          display: none;
        }
        [hidden] {
          display: none;
        }
        .wrapper {
          display: inline-block;
          padding: 8px;
        }
        .header {
          display: flex;
          color: var(--page-contents-menu-heading-color, #9daab6);
          padding: 0 24px 0 0;
          margin: 0 0 8px 0;
        }
        .header .svg {
          padding-right: 6px;
          display: inline-flex;
          color: var(--page-contents-menu-link, #74818d);
        }
        svg {
          width: 1em;
          height: 1em;
          vertical-align: middle;
        }
        .header .label {
          align-items: center;
          display: inline-flex;
          font-size: var(--page-contents-menu-heading-font-size, 10px);
          font-weight: var(--page-contents-menu-heading-font-weight, 700);
          padding: 0;
          margin: 0;
          font-family: Content-font, Roboto, sans-serif;
          line-height: 1;
          letter-spacing: 1.2px;
          text-transform: uppercase;
        }

        .contents {
          margin: 0;
          padding: 0;
          list-style-type: none;
        }
        .item {
          margin: 0;
          display: block;
          padding: 0;
          overflow: hidden;
          white-space: nowrap;
          text-overflow: ellipsis;
        }
        .link {
          font-family: Content-font, Roboto, sans-serif;
          line-height: 1.5;
          display: flex;
          padding: 4px 16px 4px 24px;
          font-size: var(--page-contents-menu-link-font-size, 12px);
          text-decoration: none;
          font-weight: var(--page-contents-menu-link-font-weight, 500);
          color: var(--page-contents-menu-link, #74818d);
          cursor: pointer;
          margin: 0;
          align-items: center;
          vertical-align: middle;
          -webkit-box-align: center;
          overflow: hidden;
          white-space: nowrap;
          text-overflow: ellipsis;
        }
        .link:hover,
        .link:focus,
        .link:active {
          text-decoration: underline;
          color: var(--page-contents-menu-link-hover, rgb(56, 132, 255));
        }
        .link:focus {
          outline: 1px solid var(--page-contents-menu-link, black);
          outline-offset: 4px;
        }
        .indent-1 {
          padding-left: 0px;
        }
        .indent-2 {
          padding-left: 16px;
        }
        .indent-3,
        .indent-4,
        .indent-5,
        .indent-6 {
          padding-left: 32px;
        }
      `]}render(){return t`
      <section class="wrapper" role="navigation">
        <div class="header">
          <a
            class="svg"
            @click="${this.toggleSettings}"
            @keypress="${this.keyToggle}"
            id="popovertarget"
            aria-title="${this.label}"
          >
            <svg
              preserveAspectRatio="xMidYMid meet"
              height="1em"
              width="1em"
              fill="none"
              xmlns="http://www.w3.org/2000/svg"
              viewBox="0 0 24 24"
              stroke-width="2"
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke="currentColor"
              class="icon-7f6730be--text-3f89f380"
            >
              <g>
                <line x1="21" y1="10" x2="7" y2="10"></line>
                <line x1="21" y1="6" x2="3" y2="6"></line>
                <line x1="21" y1="14" x2="3" y2="14"></line>
                <line x1="21" y1="18" x2="7" y2="18"></line>
              </g>
            </svg>
          </a>
          <simple-tooltip
            for="popovertarget"
            offset="32"
            ?hidden="${!this.mobile||!this.hideSettings}"
          >
            ${this.label}
          </simple-tooltip>
          ${this.mobile?"":t`
                <h2 class="label">${this.label}</h2>
              `}
        </div>
        ${this.mobile?t`
              <simple-popover
                class="dropdown pull-left font-settings js-toolbar-action settings-container"
                ?hidden="${this.hideSettings}"
                auto
              >
                <ol class="contents">
                  ${this.items.map((e,t)=>this.renderItem(e,t))}
                </ol>
              </simple-popover>
            `:t`
              <ol class="contents">
                ${this.items.map((e,t)=>this.renderItem(e,t))}
              </ol>
            `}
      </section>
    `}keyToggle(e){["Enter","Space"].includes(e.key)&&this.toggleSettings(e)}keyScroll(e){"Enter"==e.key&&this.scrollToObject(e)}toggleSettings(e){this.mobile&&(this.hideSettings=!this.hideSettings)}scrollToObject(e){e.path&&e.path[0]&&e.path[0].getAttribute("data-index")&&(e.preventDefault(),e.stopPropagation(),e.stopImmediatePropagation(),this.items[parseInt(e.path[0].getAttribute("data-index"))].object.scrollIntoView({behavior:"smooth",block:"start",inline:"nearest"}),this.hideSettings=!0)}renderItem(e,i){return null==e.link&&e.object?t`
        <li class="item">
          <a
            class="link indent-${e.indent}"
            tabindex="0"
            @click="${this.scrollToObject}"
            @keypress="${this.keyScroll}"
            data-index="${i}"
            >${e.title}</a
          >
        </li>
      `:t`
      <li class="item">
        <a
          class="link indent-${e.indent}"
          href="${e.link}"
          @click="${this.scrollToObject}"
          @keypress="${this.keyScroll}"
          data-index="${i}"
          >${e.title}</a
        >
      </li>
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Page contents-menu",description:"Links that jump you to the right place in the page's content",icon:"icons:android",color:"green",groups:["Contents"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"btopro",owner:"The Pennsylvania State University"}},settings:{quick:[],configure:[],advanced:[]}}}static get properties(){return{contentContainer:{type:Object},relationship:{type:String},items:{type:Array},mobile:{type:Boolean,reflect:!0},label:{type:String},hideSettings:{type:Boolean},hideIfEmpty:{type:Boolean,attribute:"hide-if-empty",reflect:!0},isEmpty:{type:Boolean,attribute:"is-empty",reflect:!0}}}static get tag(){return"page-contents-menu"}constructor(){super(),this.relationship=null,this.items=[],this.isEmpty=!0,this.hideIfEmpty=!1,this.contentContainer=null,this.mobile=!1,this.hideSettings=!0,this.label="Contents",window.addEventListener("click",this.checkMenuOpen.bind(this)),this.hierarchyTags=["h1","h2","h3","h4","h5","h6"]}checkMenuOpen(e){!this.mobile||this.hideSettings||!e.path||e.path.includes(this.__toggleTarget)||e.path.includes(this.shadowRoot.querySelector("simple-popover"))||(this.hideSettings=!0)}firstUpdated(){"parent"==this.relationship?this.contentContainer=this.parentElement:"next"==this.relationship?this.contentContainer=this.nextElementSibling:"previous"==this.relationship&&(this.contentContainer=this.previousElementSibling)}updated(e){e.forEach((e,t)=>{"contentContainer"==t&&this._contentContainerChanged(this[t]),"mobile"==t&&(this[t]?(import("../simple-popover/simple-popover.js").then(e=>{setTimeout(()=>{this.__toggleTarget=this.shadowRoot.querySelector("#popovertarget"),this.__toggleTarget.setAttribute("tabindex","0"),this.shadowRoot.querySelector("simple-popover").target=this.__toggleTarget},0)}),import("../simple-tooltip/simple-tooltip.js")):e&&!this[t]&&this.__toggleTarget.removeAttribute("tabindex"))})}updateMenu(){const e=this.hierarchyTags;let t=[];for(var i=0;i<this.contentContainer.childNodes.length;i++){let n=this.contentContainer.childNodes[i];if(void 0!==n.tagName&&e.includes(n.tagName.toLowerCase())){let e={title:n.innerText,link:n.id?"#"+n.id:null,object:n,indent:parseInt(n.tagName.toLowerCase().replace("h",""))};t.push(e)}}0===t.length?this.isEmpty=!0:this.isEmpty=!1,this.items=[...t]}_contentContainerChanged(e){e&&e.childNodes&&e.childNodes.length>0&&this.updateMenu()}}customElements.define(PageContentsMenu.tag,PageContentsMenu);export{PageContentsMenu};