/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{SimpleFields as e}from"../../simple-fields/simple-fields.js";import{HaxSchematizer as t,HaxElementizer as i}from"./HAXFields.js";export class HAXWiring{constructor(){this.haxProperties={canScale:!1,canPosition:!1,canEditSource:!1,settings:{quick:[],configure:[],advanced:[]},wipeSlot:{}},this.pathFromUrl=e=>e.substring(0,e.lastIndexOf("/")+1),this.setup=(e,t="",i=this)=>(void 0!==this.tagName&&(t=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?this.setHaxProperties(e,t,i,!0):this.setHaxProperties(e,t,i,!1)),this._haxStoreReady=e=>{if(e.detail&&void 0!==this.tagName&&void 0!==this.haxProperties){let e=this.tagName,t=this.haxProperties,i=this;if(""!=e&&void 0===window.HaxStore){const o=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:e.toLowerCase(),properties:t,polymer:!1}});i.dispatchEvent(o)}else if(""!=e&&void 0===window.HaxStore.instance.elementList[e.toLowerCase()]){const o=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:e.toLowerCase(),properties:t}});i.dispatchEvent(o)}else if(void 0!==this.tagName&&void 0===window.HaxStore.instance.elementList[this.tagName.toLowerCase()]){const e=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:this.tagName.toLowerCase(),properties:t}});i.dispatchEvent(e)}}},this.setHaxProperties=(e={},t="",i=document,o=!1)=>{if(void 0===e.api&&(e.api="1"),"1"==e.api){if(void 0===e.canPosition&&(e.canPosition=!0),void 0===e.canScale&&(e.canScale=!0),void 0===e.canEditSource&&(e.canEditSource=!1),void 0===e.gizmo)e.gizmo=!1;else if(void 0!==e.gizmo.iconLib){const t=this.pathFromUrl(decodeURIComponent(import.meta.url));import(`${t}../../../${e.gizmo.iconLib}`)}if(void 0!==e.settings){void 0===e.settings.quick&&(e.settings.quick=[]);for(let t=0;t<e.settings.quick.length;t++)e.settings.quick[t]=this.validateSetting(e.settings.quick[t]),e.settings.quick[t]||e.settings.quick.splice(t,1);void 0===e.settings.configure&&(e.settings.configure=[]);for(let t=0;t<e.settings.configure.length;t++)e.settings.configure[t]=this.validateSetting(e.settings.configure[t]),e.settings.configure[t]||e.settings.configure.splice(t,1);void 0===e.settings.advanced&&(e.settings.advanced=[]);for(let t=0;t<e.settings.advanced.length;t++)e.settings.advanced[t]=this.validateSetting(e.settings.advanced[t]),e.settings.advanced[t]||e.settings.advanced.splice(t,1);e=this.standardAdvancedProps(e)}void 0===e.saveOptions&&(e.saveOptions={wipeSlot:!1}),void 0===e.demoSchema&&(e.demoSchema=[]),o&&this.readyToFireHAXSchema(t,e,i),""===t&&("function"==typeof this._setHaxProperties?this._setHaxProperties(e):this.haxProperties=e)}else console.warn("This is't a valid usage of hax API. See hax-body-behaviors/lib/HAXWiring.js for more details on how to implement the API. https://haxtheweb.org/hax-schema for details but we will try and guess the wiring")},this.readyToFireHAXSchema=(e,t,i)=>{if(""!=e&&void 0===window.HaxStore){const o=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:e.toLowerCase(),properties:t,polymer:!1}});i.dispatchEvent(o)}else if(""!=e){const o=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:e.toLowerCase(),properties:t}});i.dispatchEvent(o)}else if(void 0!==this.tagName){const e=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:this.tagName.toLowerCase(),properties:t}});i.dispatchEvent(e)}else console.warn(`${e} missed our checks and has an issue in implementation with HAX`)},this.standardAdvancedProps=e=>(e.settings.advanced.push({attribute:"class",title:"Classes",description:"CSS classes applied manually to the element",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"style",title:"Styles",description:"Custom CSS styles as applied to the element",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"prefix",title:"Schema: prefix",description:"Schema prefixes",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"typeof",title:"Schema: TypeOf",description:"typeof definition for Schema usage",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"property",title:"Schema: Property",description:"typeof definition for Schema usage",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"resource",title:"Schema: Resource ID",description:"Schema resource identifier",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"id",title:"ID",description:"element ID, only set this if you know why",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"slot",title:"slot",description:"DOM slot area",inputMethod:"textfield"}),e),this.validateSetting=e=>(void 0!==e.property||void 0!==e.slot||void 0!==e.attribute)&&(void 0===e.title&&(void 0===e.attribute?e.title=e.property:e.title=e.attribute),void 0===e.description&&(e.description=""),void 0===e.inputMethod&&(e.inputMethod="textfield"),void 0===e.type&&(e.type="settings"),void 0===e.icon&&(e.icon="android"),void 0===e.options&&(e.options={}),void 0===e.required&&(e.required=!1),void 0===e.disabled&&(e.disabled=!1),void 0===e.validation&&(e.validation=".*"),void 0===e.validationType&&(e.validationType=""),void 0!==e.slot&&(void 0===e.slotWrapper&&(e.slotWrapper="span"),void 0===e.slotAttributes&&(e.slotAttributes={})),e),this.getHaxProperties=()=>this.haxProperties,this.getHaxJSONSchema=(t,i,o=this)=>{void 0===t&&(t="configure"),void 0===i&&(i=o.haxProperties);let s=i.settings[t];var r={$schema:"http://json-schema.org/schema#",title:"HAX "+t+" form schema",type:"object",properties:{}};if(r.properties=(new e).fieldsToSchema(s),i.gizmo&&i.gizmo.tag&&window.customElements.get(i.gizmo.tag)){let e=document.createElement(i.gizmo.tag);r="function"==typeof e.postProcessgetHaxJSONSchema?e.postProcessgetHaxJSONSchema(r):o.postProcessgetHaxJSONSchema(r)}else r=o.postProcessgetHaxJSONSchema(r);return r},this.postProcessgetHaxJSONSchema=e=>e,this._getHaxJSONSchemaProperty=t=>(new e).fieldsToSchema(t),this.getHaxJSONSchemaType=t=>{var i=(new e).fieldsConversion.inputMethod[t]||(new e).fieldsConversion;return i&&i.defaultSettings&&i.defaultSettings.type?i.defaultSettings.type:"string"},this.validHAXPropertyInputMethod=()=>Object.keys((new e).fieldsConversion.inputMethod),this.prototypeHaxProperties=()=>({api:"1",canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Tag name",description:"",icon:"icons:android",color:"purple",groups:["Content"],handles:[{type:"data",type_exclusive:!1,url:"src"}],meta:{author:"auto"}},settings:{quick:[{property:"title",title:"Title",inputMethod:"textfield",icon:"android"},{property:"primaryColor",title:"Primary color",inputMethod:"colorpicker",icon:"color"}],configure:[{slot:"",title:"Inner content",description:"The slotted content that lives inside the tag",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{slot:"button",title:"Button content",description:"The content that can override the button",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{property:"title",title:"Title",description:"",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{property:"primaryColor",title:"Title",description:"",inputMethod:"textfield",icon:"android",required:!1,validation:".*",validationType:"text"}],advanced:[{property:"secondaryColor",title:"Secondary color",description:"An optional secondary color used in certain edge cases.",inputMethod:"colorpicker",icon:"color"},{property:"endPoint",title:"API endpoint",description:"An optional endpoint to hit and load in more data dymaically.",inputMethod:"textfield",icon:"android",validation:"[a-z0-9]",validationType:"url"}]},saveOptions:{wipeSlot:!1,unsetAttributes:["end-point","secondary-color"]},demoSchema:[{tag:"my-tag",content:"<p>inner html</p>",properties:{endPoint:"https://cdn2.thecatapi.com/images/9j5.jpg",primaryColor:"yellow",title:"A cat"}}]})}}export const HAXElement=function(t){return class extends t{constructor(){super(),this.HAXWiring=new HAXWiring}static get properties(){return{...super.properties,haxProperties:window.HAXWiring.haxProperties}}setHaxProperties(e,t="",i=this){return""==t&&void 0!==this.tagName&&(t=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?this.HAXWiring.setHaxProperties(e,t,i,!0):this.HAXWiring.setHaxProperties(e,t,i,!1)}disconnectedCallback(){window.removeEventListener("hax-store-ready",this._haxStoreReady.bind(this)),super.disconnectedCallback&&super.disconnectedCallback()}setup(e,t="",i=this){return this.HAXWiring.setup(e,"",this)}_haxStoreReady(e){return this.HAXWiring._haxStoreReady(e)}validateSetting(e){return this.HAXWiring.validateSetting(e)}getHaxProperties(){return this.haxProperties}getHaxJSONSchema(e,t,i=this){return this.HAXWiring.getHaxJSONSchema(e,t,i)}postProcessgetHaxJSONSchema(e){return this.HAXWiring.postProcessgetHaxJSONSchema(e)}_getHaxJSONSchemaProperty(t){return(new e).fieldsToSchema(t)}getHaxJSONSchemaType(e){return this.HAXWiring.getHaxJSONSchemaType(e)}validHAXPropertyInputMethod(){return this.HAXWiring.validHAXPropertyInputMethod()}prototypeHaxProperties(){return this.HAXWiring.prototypeHaxProperties()}}};window.HAXWiring=new HAXWiring,window.HAXBehaviors=window.HAXBehaviors||{},window.HAXBehaviors.PropertiesBehaviors={properties:{haxProperties:window.HAXWiring.haxProperties},setHaxProperties:function(e,t="",i=this){return""==t&&void 0!==this.tagName&&(t=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?window.HAXWiring.setHaxProperties(e,t,i,!0):window.HAXWiring.setHaxProperties(e,t,i,!1)},_haxStoreReady:function(e){return window.HAXWiring._haxStoreReady(e)},validateSetting:function(e){return window.HAXWiring.validateSetting(e)},getHaxProperties:function(){return this.haxProperties},getHaxJSONSchema:function(e,t,i=this){return window.HAXWiring.getHaxJSONSchema(e,t,i)},postProcessgetHaxJSONSchema:function(e){return window.HAXWiring.postProcessgetHaxJSONSchema(e)},_getHaxJSONSchemaProperty:function(t){return(new e).fieldsToSchema(t)},getHaxJSONSchemaType:function(e){return window.HAXWiring.getHaxJSONSchemaType(e)},validHAXPropertyInputMethod:function(){return window.HAXWiring.validHAXPropertyInputMethod()},prototypeHaxProperties:function(){return window.HAXWiring.prototypeHaxProperties()}};