/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e}from"../../lit-element/lit-element.js";import"../es-global-bridge/es-global-bridge.js";class UndoManager extends t{static get tag(){return"undo-manager"}render(){return e`
      <slot></slot>
    `}static get properties(){return{...super.properties,canUndo:{type:Boolean,attribute:"can-undo"},canRedo:{type:Boolean,attribute:"can-redo"},isDirty:{type:Boolean,attribute:"is-dirty"},target:{type:Object}}}constructor(){super(),this.blocked=!1,this.observer=null;const t=`${this.pathFromUrl(decodeURIComponent(import.meta.url))}../../undo.js/undo.js`;window.addEventListener("es-bridge-undojs-loaded",this._undoLoaded.bind(this)),window.ESGlobalBridge.requestAvailability(),window.ESGlobalBridge.instance.load("undojs",t)}pathFromUrl(t){return t.substring(0,t.lastIndexOf("/")+1)}_undoLoaded(t){this.stack=new Undo.Stack,this.stack.changed=t=>{this.canRedo=this.stack.canRedo(),this.canUndo=this.stack.canUndo(),this.isDirty=this.stack.dirty()},this.stack.changed(),window.removeEventListener("undo-js-loaded",this._undoLoaded.bind(this))}connectedCallback(){this.observer=new MutationObserver(t=>{setTimeout(()=>{if(this.blocked)return void(this.blocked=!1);const t=this.innerHTML;this.stack&&t!=this.startValue&&(this.stack.execute(new UndoManagerCommand(this,this.startValue,t)),this.startValue=t)},50)}),this.observer.observe(this,{attributes:!0,childList:!0,subtree:!0}),super.connectedCallback()}disconnectedCallback(){this.observer.disconnect(),super.disconnectedCallback()}firstUpdated(t){super.firstUpdated&&super.firstUpdated(t),this.startValue=this.innerHTML}updated(t){super.updated&&super.updated(t),t.forEach((t,e)=>{"canUndo"==e&&this.dispatchEvent(new CustomEvent("can-undo-changed",{detail:{value:this[e]}})),"canRedo"==e&&this.dispatchEvent(new CustomEvent("can-redo-changed",{detail:{value:this[e]}})),"isDirty"==e&&this.dispatchEvent(new CustomEvent("is-dirty-changed",{detail:{value:this[e]}}))})}undo(){return this.stack.undo()}redo(){return this.stack.redo()}commands(){return this.stack.commands}stackPosition(){return this.stack.stackPosition}savePosition(){return this.stack.savePosition}save(){this.stack.save()}}customElements.define("undo-manager",UndoManager);class UndoManagerCommand{constructor(t,e,s){this.el=t,this.oldValue=e,this.newValue=s}execute(){}undo(){this.el.blocked=!0,this.el.innerHTML=this.oldValue}redo(){this.el.blocked=!0,this.el.innerHTML=this.newValue}}export{UndoManager,UndoManagerCommand};