/**
 * @license
 * Copyright 2016 Google Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
import*as t from"../../tslib/tslib.es6.js";import{MDCFoundation as e}from"../base/foundation.js";import{cssClasses as i,numbers as a,strings as n}from"./constants.js";import{getNormalizedEventCoords as o}from"./util.js";var r=["touchstart","pointerdown","mousedown","keydown"],s=["touchend","pointerup","mouseup","contextmenu"],d=[],u=function(e){function MDCRippleFoundation(i){var a=e.call(this,t.__assign({},MDCRippleFoundation.defaultAdapter,i))||this;return a.activationAnimationHasEnded_=!1,a.activationTimer_=0,a.fgDeactivationRemovalTimer_=0,a.fgScale_="0",a.frame_={width:0,height:0},a.initialSize_=0,a.layoutFrame_=0,a.maxRadius_=0,a.unboundedCoords_={left:0,top:0},a.activationState_=a.defaultActivationState_(),a.activationTimerCallback_=function(){a.activationAnimationHasEnded_=!0,a.runDeactivationUXLogicIfReady_()},a.activateHandler_=function(t){return a.activate_(t)},a.deactivateHandler_=function(){return a.deactivate_()},a.focusHandler_=function(){return a.handleFocus()},a.blurHandler_=function(){return a.handleBlur()},a.resizeHandler_=function(){return a.layout()},a}return t.__extends(MDCRippleFoundation,e),Object.defineProperty(MDCRippleFoundation,"cssClasses",{get:function(){return i},enumerable:!0,configurable:!0}),Object.defineProperty(MDCRippleFoundation,"strings",{get:function(){return n},enumerable:!0,configurable:!0}),Object.defineProperty(MDCRippleFoundation,"numbers",{get:function(){return a},enumerable:!0,configurable:!0}),Object.defineProperty(MDCRippleFoundation,"defaultAdapter",{get:function(){return{addClass:function(){},browserSupportsCssVars:function(){return!0},computeBoundingRect:function(){return{top:0,right:0,bottom:0,left:0,width:0,height:0}},containsEventTarget:function(){return!0},deregisterDocumentInteractionHandler:function(){},deregisterInteractionHandler:function(){},deregisterResizeHandler:function(){},getWindowPageOffset:function(){return{x:0,y:0}},isSurfaceActive:function(){return!0},isSurfaceDisabled:function(){return!0},isUnbounded:function(){return!0},registerDocumentInteractionHandler:function(){},registerInteractionHandler:function(){},registerResizeHandler:function(){},removeClass:function(){},updateCssVariable:function(){}}},enumerable:!0,configurable:!0}),MDCRippleFoundation.prototype.init=function(){var t=this,e=this.supportsPressRipple_();if(this.registerRootHandlers_(e),e){var i=MDCRippleFoundation.cssClasses,a=i.ROOT,n=i.UNBOUNDED;requestAnimationFrame((function(){t.adapter_.addClass(a),t.adapter_.isUnbounded()&&(t.adapter_.addClass(n),t.layoutInternal_())}))}},MDCRippleFoundation.prototype.destroy=function(){var t=this;if(this.supportsPressRipple_()){this.activationTimer_&&(clearTimeout(this.activationTimer_),this.activationTimer_=0,this.adapter_.removeClass(MDCRippleFoundation.cssClasses.FG_ACTIVATION)),this.fgDeactivationRemovalTimer_&&(clearTimeout(this.fgDeactivationRemovalTimer_),this.fgDeactivationRemovalTimer_=0,this.adapter_.removeClass(MDCRippleFoundation.cssClasses.FG_DEACTIVATION));var e=MDCRippleFoundation.cssClasses,i=e.ROOT,a=e.UNBOUNDED;requestAnimationFrame((function(){t.adapter_.removeClass(i),t.adapter_.removeClass(a),t.removeCssVars_()}))}this.deregisterRootHandlers_(),this.deregisterDeactivationHandlers_()},MDCRippleFoundation.prototype.activate=function(t){this.activate_(t)},MDCRippleFoundation.prototype.deactivate=function(){this.deactivate_()},MDCRippleFoundation.prototype.layout=function(){var t=this;this.layoutFrame_&&cancelAnimationFrame(this.layoutFrame_),this.layoutFrame_=requestAnimationFrame((function(){t.layoutInternal_(),t.layoutFrame_=0}))},MDCRippleFoundation.prototype.setUnbounded=function(t){var e=MDCRippleFoundation.cssClasses.UNBOUNDED;t?this.adapter_.addClass(e):this.adapter_.removeClass(e)},MDCRippleFoundation.prototype.handleFocus=function(){var t=this;requestAnimationFrame((function(){return t.adapter_.addClass(MDCRippleFoundation.cssClasses.BG_FOCUSED)}))},MDCRippleFoundation.prototype.handleBlur=function(){var t=this;requestAnimationFrame((function(){return t.adapter_.removeClass(MDCRippleFoundation.cssClasses.BG_FOCUSED)}))},MDCRippleFoundation.prototype.supportsPressRipple_=function(){return this.adapter_.browserSupportsCssVars()},MDCRippleFoundation.prototype.defaultActivationState_=function(){return{activationEvent:void 0,hasDeactivationUXRun:!1,isActivated:!1,isProgrammatic:!1,wasActivatedByPointer:!1,wasElementMadeActive:!1}},MDCRippleFoundation.prototype.registerRootHandlers_=function(t){var e=this;t&&(r.forEach((function(t){e.adapter_.registerInteractionHandler(t,e.activateHandler_)})),this.adapter_.isUnbounded()&&this.adapter_.registerResizeHandler(this.resizeHandler_)),this.adapter_.registerInteractionHandler("focus",this.focusHandler_),this.adapter_.registerInteractionHandler("blur",this.blurHandler_)},MDCRippleFoundation.prototype.registerDeactivationHandlers_=function(t){var e=this;"keydown"===t.type?this.adapter_.registerInteractionHandler("keyup",this.deactivateHandler_):s.forEach((function(t){e.adapter_.registerDocumentInteractionHandler(t,e.deactivateHandler_)}))},MDCRippleFoundation.prototype.deregisterRootHandlers_=function(){var t=this;r.forEach((function(e){t.adapter_.deregisterInteractionHandler(e,t.activateHandler_)})),this.adapter_.deregisterInteractionHandler("focus",this.focusHandler_),this.adapter_.deregisterInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.deregisterResizeHandler(this.resizeHandler_)},MDCRippleFoundation.prototype.deregisterDeactivationHandlers_=function(){var t=this;this.adapter_.deregisterInteractionHandler("keyup",this.deactivateHandler_),s.forEach((function(e){t.adapter_.deregisterDocumentInteractionHandler(e,t.deactivateHandler_)}))},MDCRippleFoundation.prototype.removeCssVars_=function(){var t=this,e=MDCRippleFoundation.strings;Object.keys(e).forEach((function(i){0===i.indexOf("VAR_")&&t.adapter_.updateCssVariable(e[i],null)}))},MDCRippleFoundation.prototype.activate_=function(t){var e=this;if(!this.adapter_.isSurfaceDisabled()){var i=this.activationState_;if(!i.isActivated){var a=this.previousActivationEvent_;if(!(a&&void 0!==t&&a.type!==t.type))i.isActivated=!0,i.isProgrammatic=void 0===t,i.activationEvent=t,i.wasActivatedByPointer=!i.isProgrammatic&&(void 0!==t&&("mousedown"===t.type||"touchstart"===t.type||"pointerdown"===t.type)),void 0!==t&&d.length>0&&d.some((function(t){return e.adapter_.containsEventTarget(t)}))?this.resetActivationState_():(void 0!==t&&(d.push(t.target),this.registerDeactivationHandlers_(t)),i.wasElementMadeActive=this.checkElementMadeActive_(t),i.wasElementMadeActive&&this.animateActivation_(),requestAnimationFrame((function(){d=[],i.wasElementMadeActive||void 0===t||" "!==t.key&&32!==t.keyCode||(i.wasElementMadeActive=e.checkElementMadeActive_(t),i.wasElementMadeActive&&e.animateActivation_()),i.wasElementMadeActive||(e.activationState_=e.defaultActivationState_())})))}}},MDCRippleFoundation.prototype.checkElementMadeActive_=function(t){return void 0===t||"keydown"!==t.type||this.adapter_.isSurfaceActive()},MDCRippleFoundation.prototype.animateActivation_=function(){var t=this,e=MDCRippleFoundation.strings,i=e.VAR_FG_TRANSLATE_START,a=e.VAR_FG_TRANSLATE_END,n=MDCRippleFoundation.cssClasses,o=n.FG_DEACTIVATION,r=n.FG_ACTIVATION,s=MDCRippleFoundation.numbers.DEACTIVATION_TIMEOUT_MS;this.layoutInternal_();var d="",u="";if(!this.adapter_.isUnbounded()){var p=this.getFgTranslationCoordinates_(),c=p.startPoint,l=p.endPoint;d=c.x+"px, "+c.y+"px",u=l.x+"px, "+l.y+"px"}this.adapter_.updateCssVariable(i,d),this.adapter_.updateCssVariable(a,u),clearTimeout(this.activationTimer_),clearTimeout(this.fgDeactivationRemovalTimer_),this.rmBoundedActivationClasses_(),this.adapter_.removeClass(o),this.adapter_.computeBoundingRect(),this.adapter_.addClass(r),this.activationTimer_=setTimeout((function(){return t.activationTimerCallback_()}),s)},MDCRippleFoundation.prototype.getFgTranslationCoordinates_=function(){var t,e=this.activationState_,i=e.activationEvent;return{startPoint:t={x:(t=e.wasActivatedByPointer?o(i,this.adapter_.getWindowPageOffset(),this.adapter_.computeBoundingRect()):{x:this.frame_.width/2,y:this.frame_.height/2}).x-this.initialSize_/2,y:t.y-this.initialSize_/2},endPoint:{x:this.frame_.width/2-this.initialSize_/2,y:this.frame_.height/2-this.initialSize_/2}}},MDCRippleFoundation.prototype.runDeactivationUXLogicIfReady_=function(){var t=this,e=MDCRippleFoundation.cssClasses.FG_DEACTIVATION,i=this.activationState_,n=i.hasDeactivationUXRun,o=i.isActivated;(n||!o)&&this.activationAnimationHasEnded_&&(this.rmBoundedActivationClasses_(),this.adapter_.addClass(e),this.fgDeactivationRemovalTimer_=setTimeout((function(){t.adapter_.removeClass(e)}),a.FG_DEACTIVATION_MS))},MDCRippleFoundation.prototype.rmBoundedActivationClasses_=function(){var t=MDCRippleFoundation.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(t),this.activationAnimationHasEnded_=!1,this.adapter_.computeBoundingRect()},MDCRippleFoundation.prototype.resetActivationState_=function(){var t=this;this.previousActivationEvent_=this.activationState_.activationEvent,this.activationState_=this.defaultActivationState_(),setTimeout((function(){return t.previousActivationEvent_=void 0}),MDCRippleFoundation.numbers.TAP_DELAY_MS)},MDCRippleFoundation.prototype.deactivate_=function(){var e=this,i=this.activationState_;if(i.isActivated){var a=t.__assign({},i);i.isProgrammatic?(requestAnimationFrame((function(){return e.animateDeactivation_(a)})),this.resetActivationState_()):(this.deregisterDeactivationHandlers_(),requestAnimationFrame((function(){e.activationState_.hasDeactivationUXRun=!0,e.animateDeactivation_(a),e.resetActivationState_()})))}},MDCRippleFoundation.prototype.animateDeactivation_=function(t){var e=t.wasActivatedByPointer,i=t.wasElementMadeActive;(e||i)&&this.runDeactivationUXLogicIfReady_()},MDCRippleFoundation.prototype.layoutInternal_=function(){var t=this;this.frame_=this.adapter_.computeBoundingRect();var e=Math.max(this.frame_.height,this.frame_.width);this.maxRadius_=this.adapter_.isUnbounded()?e:Math.sqrt(Math.pow(t.frame_.width,2)+Math.pow(t.frame_.height,2))+MDCRippleFoundation.numbers.PADDING;var i=Math.floor(e*MDCRippleFoundation.numbers.INITIAL_ORIGIN_SCALE);this.adapter_.isUnbounded()&&i%2!=0?this.initialSize_=i-1:this.initialSize_=i,this.fgScale_=""+this.maxRadius_/this.initialSize_,this.updateLayoutCssVars_()},MDCRippleFoundation.prototype.updateLayoutCssVars_=function(){var t=MDCRippleFoundation.strings,e=t.VAR_FG_SIZE,i=t.VAR_LEFT,a=t.VAR_TOP,n=t.VAR_FG_SCALE;this.adapter_.updateCssVariable(e,this.initialSize_+"px"),this.adapter_.updateCssVariable(n,this.fgScale_),this.adapter_.isUnbounded()&&(this.unboundedCoords_={left:Math.round(this.frame_.width/2-this.initialSize_/2),top:Math.round(this.frame_.height/2-this.initialSize_/2)},this.adapter_.updateCssVariable(i,this.unboundedCoords_.left+"px"),this.adapter_.updateCssVariable(a,this.unboundedCoords_.top+"px"))},MDCRippleFoundation}(e);export{u as MDCRippleFoundation};export default u;