/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-json version: 2.3.0(f70f178c030b18006bc3240fd791bd4aa41da141)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-json/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/json/workerManager",["require","exports"],(function(n,C){Object.defineProperty(C,"__esModule",{value:!0});var E=function(){function e(n){var C=this;this._defaults=n,this._worker=null,this._idleCheckInterval=setInterval((function(){return C._checkIfIdle()}),3e4),this._lastUsedTime=0,this._configChangeListener=this._defaults.onDidChange((function(){return C._stopWorker()}))}return e.prototype._stopWorker=function(){this._worker&&(this._worker.dispose(),this._worker=null),this._client=null},e.prototype.dispose=function(){clearInterval(this._idleCheckInterval),this._configChangeListener.dispose(),this._stopWorker()},e.prototype._checkIfIdle=function(){this._worker&&12e4<Date.now()-this._lastUsedTime&&this._stopWorker()},e.prototype._getClient=function(){return this._lastUsedTime=Date.now(),this._client||(this._worker=monaco.editor.createWebWorker({moduleId:"vs/language/json/jsonWorker",label:this._defaults.languageId,createData:{languageSettings:this._defaults.diagnosticsOptions,languageId:this._defaults.languageId,enableSchemaRequest:this._defaults.diagnosticsOptions.enableSchemaRequest}}),this._client=this._worker.getProxy()),this._client},e.prototype.getLanguageServiceWorker=function(){for(var n,C=this,E=[],T=0;T<arguments.length;T++)E[T]=arguments[T];return this._getClient().then((function(C){n=C})).then((function(n){return C._worker.withSyncedResources(E)})).then((function(C){return n}))},e}();C.WorkerManager=E})),function(n){if("object"==typeof module&&"object"==typeof module.exports){var C=n(require,exports);void 0!==C&&(module.exports=C)}else"function"==typeof define&&define.amd&&define("vscode-languageserver-types/main",["require","exports"],n)}((function(n,C){var E,T,A,x,O,I,M,j,K,L,D,P,N,R,F,V,W,q,U,B,H,z,J,G;Object.defineProperty(C,"__esModule",{value:!0}),(T=E=C.Position||(C.Position={})).create=function(n,C){return{line:n,character:C}},T.is=function(n){var C=n;return Ce.objectLiteral(C)&&Ce.number(C.line)&&Ce.number(C.character)},(x=A=C.Range||(C.Range={})).create=function(n,C,T,A){if(Ce.number(n)&&Ce.number(C)&&Ce.number(T)&&Ce.number(A))return{start:E.create(n,C),end:E.create(T,A)};if(E.is(n)&&E.is(C))return{start:n,end:C};throw new Error("Range#create called with invalid arguments["+n+", "+C+", "+T+", "+A+"]")},x.is=function(n){var C=n;return Ce.objectLiteral(C)&&E.is(C.start)&&E.is(C.end)},(I=O=C.Location||(C.Location={})).create=function(n,C){return{uri:n,range:C}},I.is=function(n){var C=n;return Ce.defined(C)&&A.is(C.range)&&(Ce.string(C.uri)||Ce.undefined(C.uri))},(j=M=C.Color||(C.Color={})).create=function(n,C,E,T){return{red:n,green:C,blue:E,alpha:T}},j.is=function(n){var C=n;return Ce.number(C.red)&&Ce.number(C.green)&&Ce.number(C.blue)&&Ce.number(C.alpha)},(K=C.ColorInformation||(C.ColorInformation={})).create=function(n,C){return{range:n,color:C}},K.is=function(n){var C=n;return A.is(C.range)&&M.is(C.color)},(L=C.ColorPresentation||(C.ColorPresentation={})).create=function(n,C,E){return{label:n,textEdit:C,additionalTextEdits:E}},L.is=function(n){var C=n;return Ce.string(C.label)&&(Ce.undefined(C.textEdit)||B.is(C))&&(Ce.undefined(C.additionalTextEdits)||Ce.typedArray(C.additionalTextEdits,B.is))},(D=C.FoldingRangeKind||(C.FoldingRangeKind={})).Comment="comment",D.Imports="imports",D.Region="region",(P=C.FoldingRange||(C.FoldingRange={})).create=function(n,C,E,T,A){var x={startLine:n,endLine:C};return Ce.defined(E)&&(x.startCharacter=E),Ce.defined(T)&&(x.endCharacter=T),Ce.defined(A)&&(x.kind=A),x},P.is=function(n){var C=n;return Ce.number(C.startLine)&&Ce.number(C.startLine)&&(Ce.undefined(C.startCharacter)||Ce.number(C.startCharacter))&&(Ce.undefined(C.endCharacter)||Ce.number(C.endCharacter))&&(Ce.undefined(C.kind)||Ce.string(C.kind))},(R=N=C.DiagnosticRelatedInformation||(C.DiagnosticRelatedInformation={})).create=function(n,C){return{location:n,message:C}},R.is=function(n){var C=n;return Ce.defined(C)&&O.is(C.location)&&Ce.string(C.message)},(F=C.DiagnosticSeverity||(C.DiagnosticSeverity={})).Error=1,F.Warning=2,F.Information=3,F.Hint=4,(W=V=C.Diagnostic||(C.Diagnostic={})).create=function(n,C,E,T,A,x){var O={range:n,message:C};return Ce.defined(E)&&(O.severity=E),Ce.defined(T)&&(O.code=T),Ce.defined(A)&&(O.source=A),Ce.defined(x)&&(O.relatedInformation=x),O},W.is=function(n){var C=n;return Ce.defined(C)&&A.is(C.range)&&Ce.string(C.message)&&(Ce.number(C.severity)||Ce.undefined(C.severity))&&(Ce.number(C.code)||Ce.string(C.code)||Ce.undefined(C.code))&&(Ce.string(C.source)||Ce.undefined(C.source))&&(Ce.undefined(C.relatedInformation)||Ce.typedArray(C.relatedInformation,N.is))},(U=q=C.Command||(C.Command={})).create=function(n,C){for(var E=[],T=2;T<arguments.length;T++)E[T-2]=arguments[T];var A={title:n,command:C};return Ce.defined(E)&&0<E.length&&(A.arguments=E),A},U.is=function(n){var C=n;return Ce.defined(C)&&Ce.string(C.title)&&Ce.string(C.command)},(H=B=C.TextEdit||(C.TextEdit={})).replace=function(n,C){return{range:n,newText:C}},H.insert=function(n,C){return{range:{start:n,end:n},newText:C}},H.del=function(n){return{range:n,newText:""}},H.is=function(n){var C=n;return Ce.objectLiteral(C)&&Ce.string(C.newText)&&A.is(C.range)},(J=z=C.TextDocumentEdit||(C.TextDocumentEdit={})).create=function(n,C){return{textDocument:n,edits:C}},J.is=function(n){var C=n;return Ce.defined(C)&&Q.is(C.textDocument)&&Array.isArray(C.edits)},(G=C.WorkspaceEdit||(C.WorkspaceEdit={})).is=function(n){var C=n;return C&&(void 0!==C.changes||void 0!==C.documentChanges)&&(void 0===C.documentChanges||Ce.typedArray(C.documentChanges,z.is))};var $,Q,Z,ee,te,ne,re,oe,ie,ae,se,ue,ce,fe,de=function(){function e(n){this.edits=n}return e.prototype.insert=function(n,C){this.edits.push(B.insert(n,C))},e.prototype.replace=function(n,C){this.edits.push(B.replace(n,C))},e.prototype.delete=function(n){this.edits.push(B.del(n))},e.prototype.add=function(n){this.edits.push(n)},e.prototype.all=function(){return this.edits},e.prototype.clear=function(){this.edits.splice(0,this.edits.length)},e}(),le=function(){function e(n){var C=this;this._textEditChanges=Object.create(null),n&&((this._workspaceEdit=n).documentChanges?n.documentChanges.forEach((function(n){var E=new de(n.edits);C._textEditChanges[n.textDocument.uri]=E})):n.changes&&Object.keys(n.changes).forEach((function(E){var T=new de(n.changes[E]);C._textEditChanges[E]=T})))}return Object.defineProperty(e.prototype,"edit",{get:function(){return this._workspaceEdit},enumerable:!0,configurable:!0}),e.prototype.getTextEditChange=function(n){if(Q.is(n)){if(this._workspaceEdit||(this._workspaceEdit={documentChanges:[]}),!this._workspaceEdit.documentChanges)throw new Error("Workspace edit is not configured for versioned document changes.");var C=n;if(!(T=this._textEditChanges[C.uri])){var E={textDocument:C,edits:A=[]};this._workspaceEdit.documentChanges.push(E),T=new de(A),this._textEditChanges[C.uri]=T}return T}if(this._workspaceEdit||(this._workspaceEdit={changes:Object.create(null)}),!this._workspaceEdit.changes)throw new Error("Workspace edit is not configured for normal text edit changes.");var T;if(!(T=this._textEditChanges[n])){var A=[];this._workspaceEdit.changes[n]=A,T=new de(A),this._textEditChanges[n]=T}return T},e}();C.WorkspaceChange=le,($=C.TextDocumentIdentifier||(C.TextDocumentIdentifier={})).create=function(n){return{uri:n}},$.is=function(n){var C=n;return Ce.defined(C)&&Ce.string(C.uri)},(Z=Q=C.VersionedTextDocumentIdentifier||(C.VersionedTextDocumentIdentifier={})).create=function(n,C){return{uri:n,version:C}},Z.is=function(n){var C=n;return Ce.defined(C)&&Ce.string(C.uri)&&Ce.number(C.version)},(ee=C.TextDocumentItem||(C.TextDocumentItem={})).create=function(n,C,E,T){return{uri:n,languageId:C,version:E,text:T}},ee.is=function(n){var C=n;return Ce.defined(C)&&Ce.string(C.uri)&&Ce.string(C.languageId)&&Ce.number(C.version)&&Ce.string(C.text)},(ne=te=C.MarkupKind||(C.MarkupKind={})).PlainText="plaintext",ne.Markdown="markdown",(re=te=C.MarkupKind||(C.MarkupKind={})).is=function(n){var C=n;return C===re.PlainText||C===re.Markdown},(oe=C.MarkupContent||(C.MarkupContent={})).is=function(n){var C=n;return Ce.objectLiteral(n)&&te.is(C.kind)&&Ce.string(C.value)},(ie=C.CompletionItemKind||(C.CompletionItemKind={})).Text=1,ie.Method=2,ie.Function=3,ie.Constructor=4,ie.Field=5,ie.Variable=6,ie.Class=7,ie.Interface=8,ie.Module=9,ie.Property=10,ie.Unit=11,ie.Value=12,ie.Enum=13,ie.Keyword=14,ie.Snippet=15,ie.Color=16,ie.File=17,ie.Reference=18,ie.Folder=19,ie.EnumMember=20,ie.Constant=21,ie.Struct=22,ie.Event=23,ie.Operator=24,ie.TypeParameter=25,(ae=C.InsertTextFormat||(C.InsertTextFormat={})).PlainText=1,ae.Snippet=2,(C.CompletionItem||(C.CompletionItem={})).create=function(n){return{label:n}},(C.CompletionList||(C.CompletionList={})).create=function(n,C){return{items:n||[],isIncomplete:!!C}},(ue=se=C.MarkedString||(C.MarkedString={})).fromPlainText=function(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")},ue.is=function(n){var C=n;return Ce.string(C)||Ce.objectLiteral(C)&&Ce.string(C.language)&&Ce.string(C.value)},(C.Hover||(C.Hover={})).is=function(n){var C=n;return Ce.objectLiteral(C)&&(oe.is(C.contents)||se.is(C.contents)||Ce.typedArray(C.contents,se.is))&&(void 0===n.range||A.is(n.range))},(C.ParameterInformation||(C.ParameterInformation={})).create=function(n,C){return C?{label:n,documentation:C}:{label:n}},(C.SignatureInformation||(C.SignatureInformation={})).create=function(n,C){for(var E=[],T=2;T<arguments.length;T++)E[T-2]=arguments[T];var A={label:n};return Ce.defined(C)&&(A.documentation=C),Ce.defined(E)?A.parameters=E:A.parameters=[],A},(ce=C.DocumentHighlightKind||(C.DocumentHighlightKind={})).Text=1,ce.Read=2,ce.Write=3,(C.DocumentHighlight||(C.DocumentHighlight={})).create=function(n,C){var E={range:n};return Ce.number(C)&&(E.kind=C),E},(fe=C.SymbolKind||(C.SymbolKind={})).File=1,fe.Module=2,fe.Namespace=3,fe.Package=4,fe.Class=5,fe.Method=6,fe.Property=7,fe.Field=8,fe.Constructor=9,fe.Enum=10,fe.Interface=11,fe.Function=12,fe.Variable=13,fe.Constant=14,fe.String=15,fe.Number=16,fe.Boolean=17,fe.Array=18,fe.Object=19,fe.Key=20,fe.Null=21,fe.EnumMember=22,fe.Struct=23,fe.Event=24,fe.Operator=25,fe.TypeParameter=26,(C.SymbolInformation||(C.SymbolInformation={})).create=function(n,C,E,T,A){var x={name:n,kind:C,location:{uri:T,range:E}};return A&&(x.containerName=A),x};var ge,he,pe,me,ve,ye,Y=function(){};C.DocumentSymbol=Y,(ge=Y=C.DocumentSymbol||(C.DocumentSymbol={})).create=function(n,C,E,T,A,x){var O={name:n,detail:C,kind:E,range:T,selectionRange:A};return void 0!==x&&(O.children=x),O},ge.is=function(n){var C=n;return C&&Ce.string(C.name)&&Ce.number(C.kind)&&A.is(C.range)&&A.is(C.selectionRange)&&(void 0===C.detail||Ce.string(C.detail))&&(void 0===C.deprecated||Ce.boolean(C.deprecated))&&(void 0===C.children||Array.isArray(C.children))},C.DocumentSymbol=Y,(he=C.CodeActionKind||(C.CodeActionKind={})).QuickFix="quickfix",he.Refactor="refactor",he.RefactorExtract="refactor.extract",he.RefactorInline="refactor.inline",he.RefactorRewrite="refactor.rewrite",he.Source="source",he.SourceOrganizeImports="source.organizeImports",(pe=C.CodeActionContext||(C.CodeActionContext={})).create=function(n,C){var E={diagnostics:n};return null!=C&&(E.only=C),E},pe.is=function(n){var C=n;return Ce.defined(C)&&Ce.typedArray(C.diagnostics,V.is)&&(void 0===C.only||Ce.typedArray(C.only,Ce.string))},(me=C.CodeAction||(C.CodeAction={})).create=function(n,C,E){var T={title:n};return q.is(C)?T.command=C:T.edit=C,void 0!==E&&(T.kind=E),T},me.is=function(n){var C=n;return C&&Ce.string(C.title)&&(void 0===C.diagnostics||Ce.typedArray(C.diagnostics,V.is))&&(void 0===C.kind||Ce.string(C.kind))&&(void 0!==C.edit||void 0!==C.command)&&(void 0===C.command||q.is(C.command))&&(void 0===C.edit||G.is(C.edit))},(ve=C.CodeLens||(C.CodeLens={})).create=function(n,C){var E={range:n};return Ce.defined(C)&&(E.data=C),E},ve.is=function(n){var C=n;return Ce.defined(C)&&A.is(C.range)&&(Ce.undefined(C.command)||q.is(C.command))},(ye=C.FormattingOptions||(C.FormattingOptions={})).create=function(n,C){return{tabSize:n,insertSpaces:C}},ye.is=function(n){var C=n;return Ce.defined(C)&&Ce.number(C.tabSize)&&Ce.boolean(C.insertSpaces)};var be,ke,_e,X=function(){};C.DocumentLink=X,(be=X=C.DocumentLink||(C.DocumentLink={})).create=function(n,C,E){return{range:n,target:C,data:E}},be.is=function(n){var C=n;return Ce.defined(C)&&A.is(C.range)&&(Ce.undefined(C.target)||Ce.string(C.target))},C.DocumentLink=X,C.EOL=["\n","\r\n","\r"],(ke=C.TextDocument||(C.TextDocument={})).create=function(n,C,E,T){return new Se(n,C,E,T)},ke.is=function(n){var C=n;return!!(Ce.defined(C)&&Ce.string(C.uri)&&(Ce.undefined(C.languageId)||Ce.string(C.languageId))&&Ce.number(C.lineCount)&&Ce.func(C.getText)&&Ce.func(C.positionAt)&&Ce.func(C.offsetAt))},ke.applyEdits=function(n,C){for(var E=n.getText(),T=function e(n,C){if(n.length<=1)return n;var E=n.length/2|0,T=n.slice(0,E),A=n.slice(E);e(T,C),e(A,C);for(var x=0,O=0,I=0;x<T.length&&O<A.length;){var M=C(T[x],A[O]);n[I++]=M<=0?T[x++]:A[O++]}for(;x<T.length;)n[I++]=T[x++];for(;O<A.length;)n[I++]=A[O++];return n}(C,(function(n,C){var E=n.range.start.line-C.range.start.line;return 0===E?n.range.start.character-C.range.start.character:E})),A=E.length,x=T.length-1;0<=x;x--){var O=T[x],I=n.offsetAt(O.range.start),M=n.offsetAt(O.range.end);if(!(M<=A))throw new Error("Ovelapping edit");E=E.substring(0,I)+O.newText+E.substring(M,E.length),A=I}return E},(_e=C.TextDocumentSaveReason||(C.TextDocumentSaveReason={})).Manual=1,_e.AfterDelay=2,_e.FocusOut=3;var Ce,Ee,Te,Se=function(){function e(n,C,E,T){this._uri=n,this._languageId=C,this._version=E,this._content=T,this._lineOffsets=null}return Object.defineProperty(e.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"version",{get:function(){return this._version},enumerable:!0,configurable:!0}),e.prototype.getText=function(n){if(n){var C=this.offsetAt(n.start),E=this.offsetAt(n.end);return this._content.substring(C,E)}return this._content},e.prototype.update=function(n,C){this._content=n.text,this._version=C,this._lineOffsets=null},e.prototype.getLineOffsets=function(){if(null===this._lineOffsets){for(var n=[],C=this._content,E=!0,T=0;T<C.length;T++){E&&(n.push(T),E=!1);var A=C.charAt(T);E="\r"===A||"\n"===A,"\r"===A&&T+1<C.length&&"\n"===C.charAt(T+1)&&T++}E&&0<C.length&&n.push(C.length),this._lineOffsets=n}return this._lineOffsets},e.prototype.positionAt=function(n){n=Math.max(Math.min(n,this._content.length),0);var C=this.getLineOffsets(),T=0,A=C.length;if(0===A)return E.create(0,n);for(;T<A;){var x=Math.floor((T+A)/2);C[x]>n?A=x:T=x+1}var O=T-1;return E.create(O,n-C[O])},e.prototype.offsetAt=function(n){var C=this.getLineOffsets();if(n.line>=C.length)return this._content.length;if(n.line<0)return 0;var E=C[n.line],T=n.line+1<C.length?C[n.line+1]:this._content.length;return Math.max(Math.min(E+n.character,T),E)},Object.defineProperty(e.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!0,configurable:!0}),e}();Ee=Ce||(Ce={}),Te=Object.prototype.toString,Ee.defined=function(n){return void 0!==n},Ee.undefined=function(n){return void 0===n},Ee.boolean=function(n){return!0===n||!1===n},Ee.string=function(n){return"[object String]"===Te.call(n)},Ee.number=function(n){return"[object Number]"===Te.call(n)},Ee.func=function(n){return"[object Function]"===Te.call(n)},Ee.objectLiteral=function(n){return null!==n&&"object"==typeof n},Ee.typedArray=function(n,C){return Array.isArray(n)&&n.every(C)}})),define("vscode-languageserver-types",["vscode-languageserver-types/main"],(function(n){return n})),define("vs/language/json/languageFeatures",["require","exports","vscode-languageserver-types"],(function(n,C,E){Object.defineProperty(C,"__esModule",{value:!0}),monaco.Uri;var T=monaco.Range,A=function(){function e(n,C,E){var T=this;this._languageId=n,this._worker=C,this._disposables=[],this._listener=Object.create(null);var o=function(n){var C,E=n.getModeId();E===T._languageId&&(T._listener[n.uri.toString()]=n.onDidChangeContent((function(){clearTimeout(C),C=setTimeout((function(){return T._doValidate(n.uri,E)}),500)})),T._doValidate(n.uri,E))},i=function(n){monaco.editor.setModelMarkers(n,T._languageId,[]);var C=n.uri.toString(),E=T._listener[C];E&&(E.dispose(),delete T._listener[C])};this._disposables.push(monaco.editor.onDidCreateModel(o)),this._disposables.push(monaco.editor.onWillDisposeModel((function(n){i(n),T._resetSchema(n.uri)}))),this._disposables.push(monaco.editor.onDidChangeModelLanguage((function(n){i(n.model),o(n.model),T._resetSchema(n.model.uri)}))),this._disposables.push(E.onDidChange((function(n){monaco.editor.getModels().forEach((function(n){n.getModeId()===T._languageId&&(i(n),o(n))}))}))),this._disposables.push({dispose:function(){for(var n in monaco.editor.getModels().forEach(i),T._listener)T._listener[n].dispose()}}),monaco.editor.getModels().forEach(o)}return e.prototype.dispose=function(){this._disposables.forEach((function(n){return n&&n.dispose()})),this._disposables=[]},e.prototype._resetSchema=function(n){this._worker().then((function(C){C.resetSchema(n.toString())}))},e.prototype._doValidate=function(n,C){this._worker(n).then((function(T){return T.doValidation(n.toString()).then((function(T){var A=T.map((function(n){return T="number"==typeof(C=n).code?String(C.code):C.code,{severity:function(n){switch(n){case E.DiagnosticSeverity.Error:return monaco.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return monaco.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return monaco.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return monaco.MarkerSeverity.Hint;default:return monaco.MarkerSeverity.Info}}(C.severity),startLineNumber:C.range.start.line+1,startColumn:C.range.start.character+1,endLineNumber:C.range.end.line+1,endColumn:C.range.end.character+1,message:C.message,code:T,source:C.source};var C,T})),x=monaco.editor.getModel(n);x.getModeId()===C&&monaco.editor.setModelMarkers(x,C,A)}))})).then(void 0,(function(n){console.error(n)}))},e}();function a(n){if(n)return{character:n.column-1,line:n.lineNumber-1}}function s(n){if(n)return{start:{line:n.startLineNumber-1,character:n.startColumn-1},end:{line:n.endLineNumber-1,character:n.endColumn-1}}}function u(n){if(n)return new T(n.start.line+1,n.start.character+1,n.end.line+1,n.end.character+1)}function c(n){if(n)return{range:u(n.range),text:n.newText}}C.DiagnosticsAdapter=A;var x=function(){function e(n){this._worker=n}return Object.defineProperty(e.prototype,"triggerCharacters",{get:function(){return[" ",":"]},enumerable:!0,configurable:!0}),e.prototype.provideCompletionItems=function(n,C,T,A){n.getWordUntilPosition(C);var x=n.uri;return this._worker(x).then((function(n){return n.doComplete(x.toString(),a(C))})).then((function(n){if(n){var C=n.items.map((function(n){var C={label:n.label,insertText:n.insertText||n.label,sortText:n.sortText,filterText:n.filterText,documentation:n.documentation,detail:n.detail,kind:function(n){var C=monaco.languages.CompletionItemKind;switch(n){case E.CompletionItemKind.Text:return C.Text;case E.CompletionItemKind.Method:return C.Method;case E.CompletionItemKind.Function:return C.Function;case E.CompletionItemKind.Constructor:return C.Constructor;case E.CompletionItemKind.Field:return C.Field;case E.CompletionItemKind.Variable:return C.Variable;case E.CompletionItemKind.Class:return C.Class;case E.CompletionItemKind.Interface:return C.Interface;case E.CompletionItemKind.Module:return C.Module;case E.CompletionItemKind.Property:return C.Property;case E.CompletionItemKind.Unit:return C.Unit;case E.CompletionItemKind.Value:return C.Value;case E.CompletionItemKind.Enum:return C.Enum;case E.CompletionItemKind.Keyword:return C.Keyword;case E.CompletionItemKind.Snippet:return C.Snippet;case E.CompletionItemKind.Color:return C.Color;case E.CompletionItemKind.File:return C.File;case E.CompletionItemKind.Reference:return C.Reference}return C.Property}(n.kind)};return n.textEdit&&(C.range=u(n.textEdit.range),C.insertText=n.textEdit.newText),n.additionalTextEdits&&(C.additionalTextEdits=n.additionalTextEdits.map(c)),n.insertTextFormat===E.InsertTextFormat.Snippet&&(C.insertTextRules=monaco.languages.CompletionItemInsertTextRule.InsertAsSnippet),C}));return{isIncomplete:n.isIncomplete,suggestions:C}}}))},e}();function f(n){return"string"==typeof n?{value:n}:(C=n)&&"object"==typeof C&&"string"==typeof C.kind?"plaintext"===n.kind?{value:n.value.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}:{value:n.value}:{value:"```"+n.language+"\n"+n.value+"\n```\n"};var C}C.CompletionAdapter=x;var O=function(){function e(n){this._worker=n}return e.prototype.provideHover=function(n,C,E){var T=n.uri;return this._worker(T).then((function(n){return n.doHover(T.toString(),a(C))})).then((function(n){if(n)return{range:u(n.range),contents:function(n){if(n)return Array.isArray(n)?n.map(f):[f(n)]}(n.contents)}}))},e}();C.HoverAdapter=O;var I=function(){function e(n){this._worker=n}return e.prototype.provideDocumentSymbols=function(n,C){var T=n.uri;return this._worker(T).then((function(n){return n.findDocumentSymbols(T.toString())})).then((function(n){if(n)return n.map((function(n){return{name:n.name,detail:"",containerName:n.containerName,kind:function(n){var C=monaco.languages.SymbolKind;switch(n){case E.SymbolKind.File:return C.Array;case E.SymbolKind.Module:return C.Module;case E.SymbolKind.Namespace:return C.Namespace;case E.SymbolKind.Package:return C.Package;case E.SymbolKind.Class:return C.Class;case E.SymbolKind.Method:return C.Method;case E.SymbolKind.Property:return C.Property;case E.SymbolKind.Field:return C.Field;case E.SymbolKind.Constructor:return C.Constructor;case E.SymbolKind.Enum:return C.Enum;case E.SymbolKind.Interface:return C.Interface;case E.SymbolKind.Function:return C.Function;case E.SymbolKind.Variable:return C.Variable;case E.SymbolKind.Constant:return C.Constant;case E.SymbolKind.String:return C.String;case E.SymbolKind.Number:return C.Number;case E.SymbolKind.Boolean:return C.Boolean;case E.SymbolKind.Array:return C.Array}return C.Function}(n.kind),range:u(n.location.range),selectionRange:u(n.location.range)}}))}))},e}();function g(n){return{tabSize:n.tabSize,insertSpaces:n.insertSpaces}}C.DocumentSymbolAdapter=I;var M=function(){function e(n){this._worker=n}return e.prototype.provideDocumentFormattingEdits=function(n,C,E){var T=n.uri;return this._worker(T).then((function(n){return n.format(T.toString(),null,g(C)).then((function(n){if(n&&0!==n.length)return n.map(c)}))}))},e}();C.DocumentFormattingEditProvider=M;var j=function(){function e(n){this._worker=n}return e.prototype.provideDocumentRangeFormattingEdits=function(n,C,E,T){var A=n.uri;return this._worker(A).then((function(n){return n.format(A.toString(),s(C),g(E)).then((function(n){if(n&&0!==n.length)return n.map(c)}))}))},e}();C.DocumentRangeFormattingEditProvider=j;var K=function(){function e(n){this._worker=n}return e.prototype.provideDocumentColors=function(n,C){var E=n.uri;return this._worker(E).then((function(n){return n.findDocumentColors(E.toString())})).then((function(n){if(n)return n.map((function(n){return{color:n.color,range:u(n.range)}}))}))},e.prototype.provideColorPresentations=function(n,C,E){var T=n.uri;return this._worker(T).then((function(n){return n.getColorPresentations(T.toString(),C.color,s(C.range))})).then((function(n){if(n)return n.map((function(n){var C={label:n.label};return n.textEdit&&(C.textEdit=c(n.textEdit)),n.additionalTextEdits&&(C.additionalTextEdits=n.additionalTextEdits.map(c)),C}))}))},e}();C.DocumentColorAdapter=K;var L=function(){function e(n){this._worker=n}return e.prototype.provideFoldingRanges=function(n,C,T){var A=n.uri;return this._worker(A).then((function(n){return n.provideFoldingRanges(A.toString(),C)})).then((function(n){if(n)return n.map((function(n){var C={start:n.startLine+1,end:n.endLine+1};return void 0!==n.kind&&(C.kind=function(n){switch(n){case E.FoldingRangeKind.Comment:return monaco.languages.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return monaco.languages.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return monaco.languages.FoldingRangeKind.Region}}(n.kind)),C}))}))},e}();C.FoldingRangeAdapter=L})),function(n){if("object"==typeof module&&"object"==typeof module.exports){var C=n(require,exports);void 0!==C&&(module.exports=C)}else"function"==typeof define&&define.amd&&define("jsonc-parser/impl/scanner",["require","exports"],n)}((function(n,C){function l(n){return 32===n||9===n||11===n||12===n||160===n||5760===n||8192<=n&&n<=8203||8239===n||8287===n||12288===n||65279===n}function g(n){return 10===n||13===n||8232===n||8233===n}function h(n){return 48<=n&&n<=57}Object.defineProperty(C,"__esModule",{value:!0}),C.createScanner=function(n,C){void 0===C&&(C=!1);var E=0,T=n.length,A="",x=0,O=16,I=0;function f(C,T){for(var A=0,x=0;A<C||!T;){var O=n.charCodeAt(E);if(48<=O&&O<=57)x=16*x+O-48;else if(65<=O&&O<=70)x=16*x+O-65+10;else{if(!(97<=O&&O<=102))break;x=16*x+O-97+10}E++,A++}return A<C&&(x=-1),x}function t(){if(A="",I=0,T<=(x=E))return x=T,O=17;var C=n.charCodeAt(E);if(l(C)){for(;E++,A+=String.fromCharCode(C),l(C=n.charCodeAt(E)););return O=15}if(g(C))return E++,A+=String.fromCharCode(C),13===C&&10===n.charCodeAt(E)&&(E++,A+="\n"),O=14;switch(C){case 123:return E++,O=1;case 125:return E++,O=2;case 91:return E++,O=3;case 93:return E++,O=4;case 58:return E++,O=6;case 44:return E++,O=5;case 34:return E++,A=function(){for(var C="",A=E;;){if(T<=E){C+=n.substring(A,E),I=2;break}var x=n.charCodeAt(E);if(34===x){C+=n.substring(A,E),E++;break}if(92!==x){if(0<=x&&x<=31){if(g(x)){C+=n.substring(A,E),I=2;break}I=6}E++}else{if(C+=n.substring(A,E),T<=++E){I=2;break}switch(x=n.charCodeAt(E++)){case 34:C+='"';break;case 92:C+="\\";break;case 47:C+="/";break;case 98:C+="\b";break;case 102:C+="\f";break;case 110:C+="\n";break;case 114:C+="\r";break;case 116:C+="\t";break;case 117:var O=f(4,!0);0<=O?C+=String.fromCharCode(O):I=4;break;default:I=5}A=E}}return C}(),O=10;case 47:var M=E-1;if(47===n.charCodeAt(E+1)){for(E+=2;E<T&&!g(n.charCodeAt(E));)E++;return A=n.substring(M,E),O=12}if(42!==n.charCodeAt(E+1))return A+=String.fromCharCode(C),E++,O=16;E+=2;for(var j=!1;E<T;){if(42===n.charCodeAt(E)&&E+1<T&&47===n.charCodeAt(E+1)){E+=2,j=!0;break}E++}return j||(E++,I=1),A=n.substring(M,E),O=13;case 45:if(A+=String.fromCharCode(C),++E===T||!h(n.charCodeAt(E)))return O=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return A+=function(){var C=E;if(48===n.charCodeAt(E))E++;else for(E++;E<n.length&&h(n.charCodeAt(E));)E++;if(E<n.length&&46===n.charCodeAt(E)){if(!(++E<n.length&&h(n.charCodeAt(E))))return I=3,n.substring(C,E);for(E++;E<n.length&&h(n.charCodeAt(E));)E++}var T=E;if(E<n.length&&(69===n.charCodeAt(E)||101===n.charCodeAt(E)))if((++E<n.length&&43===n.charCodeAt(E)||45===n.charCodeAt(E))&&E++,E<n.length&&h(n.charCodeAt(E))){for(E++;E<n.length&&h(n.charCodeAt(E));)E++;T=E}else I=3;return n.substring(C,T)}(),O=11;default:for(;E<T&&d(C);)E++,C=n.charCodeAt(E);if(x===E)return A+=String.fromCharCode(C),E++,O=16;switch(A=n.substring(x,E)){case"true":return O=8;case"false":return O=9;case"null":return O=7}return O=16}}function d(n){if(l(n)||g(n))return!1;switch(n){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}return{setPosition:function(n){E=n,A="",O=16,I=x=0},getPosition:function(){return E},scan:C?function(){for(var n;12<=(n=t())&&n<=15;);return n}:t,getToken:function(){return O},getTokenValue:function(){return A},getTokenOffset:function(){return x},getTokenLength:function(){return E-x},getTokenError:function(){return I}}}})),function(n){if("object"==typeof module&&"object"==typeof module.exports){var C=n(require,exports);void 0!==C&&(module.exports=C)}else"function"==typeof define&&define.amd&&define("jsonc-parser/impl/format",["require","exports","./scanner"],n)}((function(n,C){Object.defineProperty(C,"__esModule",{value:!0});var E=n("./scanner");function S(n,C){for(var E="",T=0;T<C;T++)E+=n;return E}function w(n,C){return-1!=="\r\n".indexOf(n.charAt(C))}C.format=function(n,C,T){var A,x,O,I,M;if(C){for(I=C.offset,M=I+C.length,O=I;0<O&&!w(n,O-1);)O--;for(var j=M;j<n.length&&!w(n,j);)j++;x=n.substring(O,j),A=function(n,C){for(var E=0,T=0,A=C.tabSize||4;E<n.length;){var x=n.charAt(E);if(" "===x)T++;else{if("\t"!==x)break;T+=A}E++}return Math.floor(T/A)}(x,T)}else I=O=A=0,M=(x=n).length;var K,L=function(n,C){for(var E=0;E<C.length;E++){var T=C.charAt(E);if("\r"===T)return E+1<C.length&&"\n"===C.charAt(E+1)?"\r\n":"\r";if("\n"===T)return"\n"}return n&&n.eol||"\n"}(T,n),D=!1,P=0;K=T.insertSpaces?S(" ",T.tabSize||4):"\t";var N=E.createScanner(x,!1),R=!1;function p(){return L+S(K,A+P)}function m(){var n=N.scan();for(D=!1;15===n||14===n;)D=D||14===n,n=N.scan();return R=16===n||0!==N.getTokenError(),n}var F=[];function y(C,E,T){!R&&E<M&&I<T&&n.substring(E,T)!==C&&F.push({offset:E,length:T-E,content:C})}var V=m();if(17!==V){var W=N.getTokenOffset()+O;y(S(K,A),O,W)}for(;17!==V;){for(var q=N.getTokenOffset()+N.getTokenLength()+O,U=m(),B="";!D&&(12===U||13===U);)y(" ",q,N.getTokenOffset()+O),q=N.getTokenOffset()+N.getTokenLength()+O,B=12===U?p():"",U=m();if(2===U)1!==V&&(P--,B=p());else if(4===U)3!==V&&(P--,B=p());else{switch(V){case 3:case 1:P++,B=p();break;case 5:case 12:B=p();break;case 13:B=D?p():" ";break;case 6:B=" ";break;case 10:if(6===U){B="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===U||13===U?B=" ":5!==U&&17!==U&&(R=!0);break;case 16:R=!0}!D||12!==U&&13!==U||(B=p())}y(B,q,N.getTokenOffset()+O),V=U}return F},C.isEOL=w})),function(n){if("object"==typeof module&&"object"==typeof module.exports){var C=n(require,exports);void 0!==C&&(module.exports=C)}else"function"==typeof define&&define.amd&&define("jsonc-parser/impl/parser",["require","exports","./scanner"],n)}((function(n,C){Object.defineProperty(C,"__esModule",{value:!0});var E=n("./scanner");function s(n,C,E){return void 0===E&&(E=!1),C>=n.offset&&C<n.offset+n.length||E&&C===n.offset+n.length}function f(n,C,T){var A=E.createScanner(n,!1);function r(n){return n?function(){return n(A.getTokenOffset(),A.getTokenLength())}:function(){return!0}}function i(n){return n?function(C){return n(C,A.getTokenOffset(),A.getTokenLength())}:function(){return!0}}var x=r(C.onObjectBegin),O=i(C.onObjectProperty),I=r(C.onObjectEnd),M=r(C.onArrayBegin),j=r(C.onArrayEnd),K=i(C.onLiteralValue),L=i(C.onSeparator),D=r(C.onComment),P=i(C.onError),N=T&&T.disallowComments,R=T&&T.allowTrailingComma;function v(){for(;;){var n=A.scan();switch(A.getTokenError()){case 4:y(14);break;case 5:y(15);break;case 3:y(13);break;case 1:N||y(11);break;case 2:y(12);break;case 6:y(16)}switch(n){case 12:case 13:N?y(10):D();break;case 16:y(1);break;case 15:case 14:break;default:return n}}}function y(n,C,E){if(void 0===C&&(C=[]),void 0===E&&(E=[]),P(n),0<C.length+E.length)for(var T=A.getToken();17!==T;){if(-1!==C.indexOf(T)){v();break}if(-1!==E.indexOf(T))break;T=v()}}function b(n){var C=A.getTokenValue();return n?K(C):O(C),v(),!0}return v(),17===A.getToken()||(function k(){switch(A.getToken()){case 3:return function(){M(),v();for(var n=!1;4!==A.getToken()&&17!==A.getToken();){if(5===A.getToken()){if(n||y(4,[],[]),L(","),v(),4===A.getToken()&&R)break}else n&&y(6,[],[]);k()||y(4,[],[4,5]),n=!0}return j(),4!==A.getToken()?y(8,[4],[]):v(),!0}();case 1:return function(){x(),v();for(var n=!1;2!==A.getToken()&&17!==A.getToken();){if(5===A.getToken()){if(n||y(4,[],[]),L(","),v(),2===A.getToken()&&R)break}else n&&y(6,[],[]);(10!==A.getToken()?(y(3,[],[2,5]),0):(b(!1),6===A.getToken()?(L(":"),v(),k()||y(4,[],[2,5])):y(5,[],[2,5]),1))||y(4,[],[2,5]),n=!0}return I(),2!==A.getToken()?y(7,[2],[]):v(),!0}();case 10:return b(!0);default:return function(){switch(A.getToken()){case 11:var n=0;try{"number"!=typeof(n=JSON.parse(A.getTokenValue()))&&(y(2),n=0)}catch(n){y(2)}K(n);break;case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return v(),!0}()}}()?(17!==A.getToken()&&y(9,[],[]),!0):(y(4,[],[]),!1))}function d(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";default:return"null"}}C.getLocation=function(n,C){var E=[],T=new Object,A=void 0,x={value:{},offset:0,length:0,type:"object",parent:void 0},O=!1;function r(n,C,E,T){x.value=n,x.offset=C,x.length=E,x.type=T,x.colonOffset=void 0,A=x}try{f(n,{onObjectBegin:function(n,x){if(C<=n)throw T;A=void 0,O=n<C,E.push("")},onObjectProperty:function(n,A,x){if(C<A)throw T;if(r(n,A,x,"property"),E[E.length-1]=n,C<=A+x)throw T},onObjectEnd:function(n,x){if(C<=n)throw T;A=void 0,E.pop()},onArrayBegin:function(n,x){if(C<=n)throw T;A=void 0,E.push(0)},onArrayEnd:function(n,x){if(C<=n)throw T;A=void 0,E.pop()},onLiteralValue:function(n,E,A){if(C<E)throw T;if(r(n,E,A,d(n)),C<=E+A)throw T},onSeparator:function(n,x,I){if(C<=x)throw T;if(":"===n&&A&&"property"===A.type)A.colonOffset=x,O=!1,A=void 0;else if(","===n){var M=E[E.length-1];E[E.length-1]="number"==typeof M?M+1:(O=!0,""),A=void 0}}})}catch(n){if(n!==T)throw n}return{path:E,previousNode:A,isAtPropertyKey:O,matches:function(n){for(var C=0,T=0;C<n.length&&T<E.length;T++)if(n[C]===E[T]||"*"===n[C])C++;else if("**"!==n[C])return!1;return C===n.length}}},C.parse=function(n,C,E){void 0===C&&(C=[]);var T=null,A=[],x=[];function a(n){Array.isArray(A)?A.push(n):T&&(A[T]=n)}return f(n,{onObjectBegin:function(){var n={};a(n),x.push(A),A=n,T=null},onObjectProperty:function(n){T=n},onObjectEnd:function(){A=x.pop()},onArrayBegin:function(){var n=[];a(n),x.push(A),A=n,T=null},onArrayEnd:function(){A=x.pop()},onLiteralValue:a,onError:function(n,E,T){C.push({error:n,offset:E,length:T})}},E),A[0]},C.parseTree=function(n,C,E){void 0===C&&(C=[]);var T={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(n){"property"===T.type&&(T.length=n-T.offset,T=T.parent)}function a(n){return T.children.push(n),n}f(n,{onObjectBegin:function(n){T=a({type:"object",offset:n,length:-1,parent:T,children:[]})},onObjectProperty:function(n,C,E){(T=a({type:"property",offset:C,length:-1,parent:T,children:[]})).children.push({type:"string",value:n,offset:C,length:E,parent:T})},onObjectEnd:function(n,C){T.length=n+C-T.offset,T=T.parent,i(n+C)},onArrayBegin:function(n,C){T=a({type:"array",offset:n,length:-1,parent:T,children:[]})},onArrayEnd:function(n,C){T.length=n+C-T.offset,T=T.parent,i(n+C)},onLiteralValue:function(n,C,E){a({type:d(n),offset:C,length:E,parent:T,value:n}),i(C+E)},onSeparator:function(n,C,E){"property"===T.type&&(":"===n?T.colonOffset=C:","===n&&i(C))},onError:function(n,E,T){C.push({error:n,offset:E,length:T})}},E);var A=T.children[0];return A&&delete A.parent,A},C.findNodeAtLocation=function(n,C){if(n){for(var E=n,T=0,A=C;T<A.length;T++){var x=A[T];if("string"==typeof x){if("object"!==E.type||!Array.isArray(E.children))return;for(var O=!1,I=0,M=E.children;I<M.length;I++){var j=M[I];if(Array.isArray(j.children)&&j.children[0].value===x){E=j.children[1],O=!0;break}}if(!O)return}else{var K=x;if("array"!==E.type||K<0||!Array.isArray(E.children)||K>=E.children.length)return;E=E.children[K]}}return E}},C.getNodePath=function e(n){if(!n.parent||!n.parent.children)return[];var C=e(n.parent);if("property"===n.parent.type){var E=n.parent.children[0].value;C.push(E)}else if("array"===n.parent.type){var T=n.parent.children.indexOf(n);-1!==T&&C.push(T)}return C},C.getNodeValue=function e(n){switch(n.type){case"array":return n.children.map(e);case"object":for(var C=Object.create(null),E=0,T=n.children;E<T.length;E++){var A=T[E],x=A.children[1];x&&(C[A.children[0].value]=e(x))}return C;case"null":case"string":case"number":case"boolean":return n.value;default:return}},C.contains=s,C.findNodeAtOffset=function e(n,C,E){if(void 0===E&&(E=!1),s(n,C,E)){var T=n.children;if(Array.isArray(T))for(var A=0;A<T.length&&T[A].offset<=C;A++){var x=e(T[A],C,E);if(x)return x}return n}},C.visit=f,C.stripComments=function(n,C){var T,A,x=E.createScanner(n),O=[],I=0;do{switch(A=x.getPosition(),T=x.scan()){case 12:case 13:case 17:I!==A&&O.push(n.substring(I,A)),void 0!==C&&O.push(x.getTokenValue().replace(/[^\r\n]/g,C)),I=x.getPosition()}}while(17!==T);return O.join("")}})),function(n){if("object"==typeof module&&"object"==typeof module.exports){var C=n(require,exports);void 0!==C&&(module.exports=C)}else"function"==typeof define&&define.amd&&define("jsonc-parser/impl/edit",["require","exports","./format","./parser"],n)}((function(n,C){Object.defineProperty(C,"__esModule",{value:!0});var E=n("./format"),T=n("./parser");function r(n,C,E,A,x){for(var O,I=C.slice(),M=T.parseTree(n,[]),j=void 0,K=void 0;0<I.length&&(K=I.pop(),void 0===(j=T.findNodeAtLocation(M,I))&&void 0!==E);)E="string"==typeof K?((O={})[K]=E,O):[E];if(j){if("object"===j.type&&"string"==typeof K&&Array.isArray(j.children)){var L=T.findNodeAtLocation(j,[K]);if(void 0!==L){if(void 0!==E)return _(n,{offset:L.offset,length:L.length,content:JSON.stringify(E)},A);if(!L.parent)throw new Error("Malformed AST");var D=j.children.indexOf(L.parent),P=void 0,N=L.parent.offset+L.parent.length;return 0<D?P=(U=j.children[D-1]).offset+U.length:(P=j.offset+1,1<j.children.length&&(N=j.children[1].offset)),_(n,{offset:P,length:N-P,content:""},A)}if(void 0===E)return[];var R=JSON.stringify(K)+": "+JSON.stringify(E),F=x?x(j.children.map((function(n){return n.children[0].value}))):j.children.length,V=void 0;return _(n,V=0<F?{offset:(U=j.children[F-1]).offset+U.length,length:0,content:","+R}:0===j.children.length?{offset:j.offset+1,length:0,content:R}:{offset:j.offset+1,length:0,content:R+","},A)}if("array"===j.type&&"number"==typeof K&&Array.isArray(j.children)){if(-1===K)return R=""+JSON.stringify(E),V=void 0,_(n,V=0===j.children.length?{offset:j.offset+1,length:0,content:R}:{offset:(U=j.children[j.children.length-1]).offset+U.length,length:0,content:","+R},A);if(void 0===E&&0<=j.children.length){var W=K,q=j.children[W];if(V=void 0,1===j.children.length)V={offset:j.offset+1,length:j.length-2,content:""};else if(j.children.length-1===W){var U,B=(U=j.children[W-1]).offset+U.length;V={offset:B,length:j.offset+j.length-2-B,content:""}}else V={offset:q.offset,length:j.children[W+1].offset-q.offset,content:""};return _(n,V,A)}throw new Error("Array modification not supported yet")}throw new Error("Can not add "+("number"!=typeof K?"index":"property")+" to parent of type "+j.type)}if(void 0===E)throw new Error("Can not delete in empty document");return _(n,{offset:M?M.offset:0,length:M?M.length:0,content:JSON.stringify(E)},A)}function _(n,C,T){var A=f(n,C),x=C.offset,O=C.offset+C.content.length;if(0===C.length||0===C.content.length){for(;0<x&&!E.isEOL(A,x-1);)x--;for(;O<A.length&&!E.isEOL(A,O);)O++}for(var I=E.format(A,{offset:x,length:O-x},T),M=I.length-1;0<=M;M--){var j=I[M];A=f(A,j),x=Math.min(x,j.offset),O=Math.max(O,j.offset+j.length),O+=j.content.length-j.length}return[{offset:x,length:n.length-(A.length-O)-x,content:A.substring(x,O)}]}function f(n,C){return n.substring(0,C.offset)+C.content+n.substring(C.offset+C.length)}C.removeProperty=function(n,C,E){return r(n,C,void 0,E)},C.setProperty=r,C.applyEdit=f,C.isWS=function(n,C){return-1!=="\r\n \t".indexOf(n.charAt(C))}})),function(n){if("object"==typeof module&&"object"==typeof module.exports){var C=n(require,exports);void 0!==C&&(module.exports=C)}else"function"==typeof define&&define.amd&&define("jsonc-parser/main",["require","exports","./impl/format","./impl/edit","./impl/scanner","./impl/parser"],n)}((function(n,C){Object.defineProperty(C,"__esModule",{value:!0});var E=n("./impl/format"),T=n("./impl/edit"),A=n("./impl/scanner"),x=n("./impl/parser");C.createScanner=A.createScanner,C.getLocation=x.getLocation,C.parse=x.parse,C.parseTree=x.parseTree,C.findNodeAtLocation=x.findNodeAtLocation,C.findNodeAtOffset=x.findNodeAtOffset,C.getNodePath=x.getNodePath,C.getNodeValue=x.getNodeValue,C.visit=x.visit,C.stripComments=x.stripComments,C.format=function(n,C,T){return E.format(n,C,T)},C.modify=function(n,C,E,A){return T.setProperty(n,C,E,A.formattingOptions,A.getInsertionIndex)},C.applyEdits=function(n,C){for(var E=C.length-1;0<=E;E--)n=T.applyEdit(n,C[E]);return n}})),define("jsonc-parser",["jsonc-parser/main"],(function(n){return n})),define("vs/language/json/tokenization",["require","exports","jsonc-parser"],(function(n,C,E){Object.defineProperty(C,"__esModule",{value:!0}),C.createTokenizationSupport=function(n){return{getInitialState:function(){return new T(null,null,!1)},tokenize:function(A,x,O,I){return function(n,A,x,O,I){void 0===O&&(O=0);var M=0,j=!1;switch(x.scanError){case 2:A='"'+A,M=1;break;case 1:A="/*"+A,M=2}var K,L,D=E.createScanner(A),P=x.lastWasColon;for(L={tokens:[],endState:x.clone()};;){var N=O+D.getPosition(),R="";if(17===(K=D.scan()))break;if(N===O+D.getPosition())throw new Error("Scanner did not advance, next 3 characters are: "+A.substr(D.getPosition(),3));switch(j&&(N-=M),j=0<M,K){case 1:case 2:R=C.TOKEN_DELIM_OBJECT,P=!1;break;case 3:case 4:R=C.TOKEN_DELIM_ARRAY,P=!1;break;case 6:R=C.TOKEN_DELIM_COLON,P=!0;break;case 5:R=C.TOKEN_DELIM_COMMA,P=!1;break;case 8:case 9:R=C.TOKEN_VALUE_BOOLEAN,P=!1;break;case 7:R=C.TOKEN_VALUE_NULL,P=!1;break;case 10:R=P?C.TOKEN_VALUE_STRING:C.TOKEN_PROPERTY_NAME,P=!1;break;case 11:R=C.TOKEN_VALUE_NUMBER,P=!1}if(n)switch(K){case 12:R=C.TOKEN_COMMENT_LINE;break;case 13:R=C.TOKEN_COMMENT_BLOCK}L.endState=new T(x.getStateData(),D.getTokenError(),P),L.tokens.push({startIndex:N,scopes:R})}return L}(n,A,x,O)}}},C.TOKEN_DELIM_OBJECT="delimiter.bracket.json",C.TOKEN_DELIM_ARRAY="delimiter.array.json",C.TOKEN_DELIM_COLON="delimiter.colon.json",C.TOKEN_DELIM_COMMA="delimiter.comma.json",C.TOKEN_VALUE_BOOLEAN="keyword.json",C.TOKEN_VALUE_NULL="keyword.json",C.TOKEN_VALUE_STRING="string.value.json",C.TOKEN_VALUE_NUMBER="number.json",C.TOKEN_PROPERTY_NAME="string.key.json",C.TOKEN_COMMENT_BLOCK="comment.block.json",C.TOKEN_COMMENT_LINE="comment.line.json";var T=function(){function t(n,C,E){this._state=n,this.scanError=C,this.lastWasColon=E}return t.prototype.clone=function(){return new t(this._state,this.scanError,this.lastWasColon)},t.prototype.equals=function(n){return n===this||!!(n&&n instanceof t)&&this.scanError===n.scanError&&this.lastWasColon===n.lastWasColon},t.prototype.getStateData=function(){return this._state},t.prototype.setStateData=function(n){this._state=n},t}()})),define("vs/language/json/jsonMode",["require","exports","./workerManager","./languageFeatures","./tokenization"],(function(n,C,E,T,A){Object.defineProperty(C,"__esModule",{value:!0}),C.setupMode=function(n){var C=[],O=new E.WorkerManager(n);C.push(O);var r=function(){for(var n=[],C=0;C<arguments.length;C++)n[C]=arguments[C];return O.getLanguageServiceWorker.apply(O,n)},I=n.languageId;C.push(monaco.languages.registerCompletionItemProvider(I,new T.CompletionAdapter(r))),C.push(monaco.languages.registerHoverProvider(I,new T.HoverAdapter(r))),C.push(monaco.languages.registerDocumentSymbolProvider(I,new T.DocumentSymbolAdapter(r))),C.push(monaco.languages.registerDocumentFormattingEditProvider(I,new T.DocumentFormattingEditProvider(r))),C.push(monaco.languages.registerDocumentRangeFormattingEditProvider(I,new T.DocumentRangeFormattingEditProvider(r))),C.push(new T.DiagnosticsAdapter(I,r,n)),C.push(monaco.languages.setTokensProvider(I,A.createTokenizationSupport(!0))),C.push(monaco.languages.setLanguageConfiguration(I,x)),C.push(monaco.languages.registerColorProvider(I,new T.DocumentColorAdapter(r))),C.push(monaco.languages.registerFoldingRangeProvider(I,new T.FoldingRangeAdapter(r)))};var x={wordPattern:/(-?\d*\.\d\w*)|([^\[\{\]\}\:\"\,\s]+)/g,comments:{lineComment:"//",blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"]],autoClosingPairs:[{open:"{",close:"}",notIn:["string"]},{open:"[",close:"]",notIn:["string"]},{open:'"',close:'"',notIn:["string"]}]}}));